#set of functions, directly/indirectly involved, in oneChannelGUI dataminingMenu
#oneChannelGUI GOenrichment searching for enrichment of gO terms
        #contains oneChannelGUI SaveTopTable called inside the function
        #         oneChannelGUI OpenAFile called inside the function
#oneChannelGUI plotGO plotting GO relations
#oneChannelGUI extractAffyids This function starts for a topTable and extracts the subset of probe ids associated to a GO class
#                             found differentially expressed using the Goenrichment function
        #contains oneChannelGUI OpenAFile called inside the function
        #         oneChannelGUI SaveHtmlTable called inside the function
#oneChannelGUI templA making a template A from a top table
         #         calling SaveTopTable present inside the function
#oneChanneGUI metaArrayMerge  create a merge object to be used for IC analysis using metaArrayIC
#oneChannelGUI metaArrayIC run metaArray implementation of Parmigiani Integrative Correlation

################################################################################
#updated 13.02.06
#my.go= "BP", "MF", "CC" class of GO to be investigated
#mylib="mgu74av2" microarray anntation library
#pValue=0.01 significant p-value to be detetcted
#topTable=topTable from affylmGUI

"GOenrichment"<-function(){
           require(GOstats) || stop("library GOstats could not be found !")
          Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
           #error if no data are loaded
          Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
          if(whichArrayPlatform ==""){
              Try(tkmessageBox(title="GO analysis",message="No arrays have been loaded.	Please try New or Open from the File menu.",type="ok",icon="error"))
				    	Try(tkfocus(.affylmGUIglobals$ttMain))
              Try(return())
          }    
          #########################

           ##making the menu for selecting intensity threshold
           Try(ttIfDialog<-tktoplevel(.affylmGUIglobals$ttMain))
           Try(tkwm.deiconify(ttIfDialog))
           Try(tkgrab.set(ttIfDialog))
           Try(tkfocus(ttIfDialog))
           Try(tkwm.title(ttIfDialog,"Filtering Options"))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))

           Try(frame1 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
           Try(HowManyQuestion1 <- tklabel(frame1,text="P-value threshold",font=.affylmGUIglobals$affylmGUIfont2))
           Try(tkgrid(HowManyQuestion1))
           Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
           Try(thresholdTcl <- tclVar("0.01"))
           Try(I1.but  <- tkradiobutton(frame1,text="0.05",variable=thresholdTcl,value="0.05",font=.affylmGUIglobals$affylmGUIfont2))
           Try(I2.but  <- tkradiobutton(frame1,text="0.01",variable=thresholdTcl,value="0.01",font=.affylmGUIglobals$affylmGUIfont2))
           Try(I3.but  <- tkradiobutton(frame1,text="0.001",variable=thresholdTcl,value="0.001",font=.affylmGUIglobals$affylmGUIfont2))
           Try(I4.but  <- tkradiobutton(frame1,text="0.0001",variable=thresholdTcl,value="0.0001",font=.affylmGUIglobals$affylmGUIfont2))

           Try(tkgrid(I1.but,sticky="w"))
           Try(tkgrid(I2.but,sticky="w"))
           Try(tkgrid(I3.but,sticky="w"))
           Try(tkgrid(I4.but,sticky="w"))
           Try(tkgrid.configure(HowManyQuestion1,I1.but,I2.but,I3.but,I4.but,sticky="w"))

           Try(frame2 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
           Try(fractionLabel <- tklabel(frame2,text="GO class",font=.affylmGUIglobals$affylmGUIfont2))
           Try(tkgrid(fractionLabel,sticky="w"))
           Try(tkgrid.configure(fractionLabel,sticky="w"))
           Try(fractionTcl <- tclVar("BP"))
           Try(F1.but <- tkradiobutton(frame2,text="BP",variable=fractionTcl,value="BP",font=.affylmGUIglobals$affylmGUIfont2))
           Try(F2.but <- tkradiobutton(frame2,text="MF",variable=fractionTcl,value="MF",font=.affylmGUIglobals$affylmGUIfont2))
           Try(F3.but <- tkradiobutton(frame2,text="CC",variable=fractionTcl,value="CC",font=.affylmGUIglobals$affylmGUIfont2))
           
           Try(tkgrid(F1.but,sticky="w"))
           Try(tkgrid(F2.but,sticky="w"))
           Try(tkgrid(F3.but,sticky="w"))
           Try(tkgrid.configure(fractionLabel,F1.but,F2.but,F3.but,sticky="w"))

           Try(onOK <- function()
           {
                ReturnVal1 <- as.numeric(tclvalue(thresholdTcl))
                ReturnVal2 <- tclvalue(fractionTcl)
                Try(ReturnVal <<- paste(ReturnVal1, ReturnVal2, sep=";"))
                Try(tkgrab.release(ttIfDialog))
                Try(tkdestroy(ttIfDialog))
                Try(tkfocus(.affylmGUIglobals$ttMain))
           })

           Try(frame3 <- tkframe(ttIfDialog,borderwidth=2))
           Try(onCancel <- function() {Try(tkgrab.release(ttIfDialog));
                                Try(tkdestroy(ttIfDialog));
                                Try(tkfocus(.affylmGUIglobals$ttMain));
                                Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                Try(return())
           })
           Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
           Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

           Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))

           Try(tkgrid(tklabel(ttIfDialog,text="    "),frame1,frame2,tklabel(ttIfDialog,text="  ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    "),frame3,tklabel(ttIfDialog,text="  ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))
           Try(tkgrid.configure(frame1,frame2,sticky="w"))

           Try(tkfocus(ttIfDialog))
           Try(tkbind(ttIfDialog, "<Destroy>", function() {Try(tkgrab.release(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));}))
           Try(tkwait.window(ttIfDialog))

	#if exon arrays are used till a specifi exon array data base is available as data base we use the LLMapping libraries
      Try(whichArrayPlatform <- get("whichArrayPlatform", envir=affylmGUIenvironment))
	    if(whichArrayPlatform=="EXON"){
	         require(annotate, quietly = TRUE) || stop("\nneed data package: annotate\n")
           tmp<-strsplit(ReturnVal, ";")
           p.value= as.numeric(tmp[[1]][1])
           Try(x <- get("NormalizedAffyData",envir=affylmGUIenvironment))
           my.go= tmp[[1]][2]
           whichLib <- get("whichLib", envir=affylmGUIenvironment)
                    Try(if(whichLib[[1]][1]=="HuEx"){
                            #require(humanLLMappings) || stop("library humanLLMappings could not be found !")
                            #lib <- "humanLLMappings"
                            require(org.Hs.eg.db, quietly = TRUE) || stop("\nneed data package: org.Hs.eg.db\n")
                            lib = "org.Hs.eg.db"
                    })
                    Try(if(whichLib[[1]][1]=="MoEx"){
                            #require(mouseLLMappings) || stop("library mouseLLMappings could not be found !")
                            #lib <- "mouseLLMappings"
                            require(org.Mm.eg.db, quietly = TRUE) || stop("\nneed data package: org.Mm.eg.db\n")
                            lib = "org.Mm.eg.db"
                   })
                    Try(if(whichLib[[1]][1]=="RaEx"){
                            #require(ratLLMappings) || stop("library ratLLMappings could not be found !")
                            #lib <- "ratLLMappings"
                            require(org.Rn.eg.db, quietly = TRUE) || stop("\nneed data package: org.Rn.eg.db\n")
                            lib = "org.Rn.eg.db"
                   })
      }else{
           tmp<-strsplit(ReturnVal, ";")
           p.value= as.numeric(tmp[[1]][1])
           Try(x <- get("NormalizedAffyData",envir=affylmGUIenvironment))
           lib= .annotation(x)
           if(length(as.character(unlist(strsplit(lib, "\\.")))) == 1){
                   Try(lib <- paste(lib, ".db", sep=""))
           }
           my.go= tmp[[1]][2]
           Try(require(lib, character.only = TRUE) || stop("need data package: ", lib))
           Try(require("annotate", character.only = TRUE) || stop("need data package: annotate"))
    
     }
      ###################carica la lista di affyids
####################################################################################
#      getDataEnv <- function(name, lib) {
#        	get(paste(lib, name, sep = ""), mode = "environment")
#    	}
#    	require(lib, character.only = TRUE) || stop("need data package: ", 
#        lib)
####################################################################################

       Try(startFun <- tclvalue(tkmessageBox(title="GO class enrichment",message="Open the file with the list of differentially expressed probe sets.",type="yesno",icon="question")))
       if (startFun=="no"){
                       Try(tkmessageBox(title="GO class enrichment",message="The file with the list of differentially expressed probe sets\nwas not given!\nAborting analysis."))  
                       Try(return())
       }

      OpenAFile <- function(FileName)
      {
         Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
               if(!nchar(tempFileName))
               {
                  tkfocus(.affylmGUIglobals$ttMain)
                  return()
               }
         mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE)
         return(mySel)
      }
      tmp.x <- OpenAFile()
      if(dim(tmp.x)[2]>1){
            Try(tkmessageBox(title="GO class enrichment",message=paste("Input file should contain\nonly a column with\nAffymetrix ids")))
            Try(return())  
      }
      
      if(whichArrayPlatform=="EXON"){
        Try(annlibloc <- grep(paste("^",whichLib[[1]][1],sep=""), as.vector(unlist(data(package="oneChannelGUI"))), ignore.case = T))
        Try(annlibname <- as.vector(unlist(data(package="oneChannelGUI")))[annlibloc])
        Try(data(list=annlibname,package="oneChannelGUI"))
        Try(exonannlib<- get(annlibname,envir=.GlobalEnv))
        Try(genelist <- featureNames(x))#normalizeAffyData in x
        Try(acc <- as.character(exonannlib$ACC[which(as.character(exonannlib$PROBESETID)%in%genelist)])) #defining the universe of ll
        Try(acc <- acc[!is.na(acc)]) #remove NA
#        Try(lltoacc <- mget(acc, env=getDataEnv("ACCNUM2LL", lib), ifnotfound=""))#LL ids
        Try(lltoacc <- as.character(unlist(lookUp(as.character(acc), lib, "ACCNUM2EG"))))
        Try(gNuniverse <- unique(as.character(unlist(lltoacc))))#ll universe

        Try(gNsel<-as.character(tmp.x[,1]))
        Try(myacc <- as.character(exonannlib$ACC[which(as.character(exonannlib$PROBESETID)%in%gNsel)])) #defining the acc of diff exprs
        Try(myacc <- myacc[!is.na(myacc)])
        #Try(mylltoacc <- mget(myacc,env=getDataEnv("ACCNUM2LL", lib), ifnotfound=""))#LL ids
        Try(mylltoacc <- as.character(unlist(lookUp(myacc, lib, "ACCNUM2EG"))))
        Try(gNll <- unique(as.character(unlist(mylltoacc))))#ll of diff exprs data
      }else{
        gNsel<-as.character(tmp.x[,1])
        Try(annlib1 <- as.character(unlist(strsplit(lib, ".db"))))
        Try(gNll <- lookUp(gNsel, annlib1, "ENTREZID"))
        Try(gNll <- unique(as.character(unlist(gNll))))
        Try(gNuniverse <- lookUp(featureNames(x), annlib1, "ENTREZID"))
        Try(gNuniverse <- unique(as.character(unlist(gNuniverse))))
        
        #gNll <- unique(as.character(unlist(mget(gNsel, env=getDataEnv("ENTREZID", lib), ifnotfound=NA))))#ll of diff exprs data
        #gNuniverse <- unique(as.character(unlist(mget(featureNames(x), env=getDataEnv("ENTREZID", lib), ifnotfound=NA))))#ll universe
     }
      
      ##########################nuova parte
      
      Try(params <- new("GOHyperGParams", geneIds = gNll, universeGeneIds = gNuniverse,
      annotation = lib, ontology = my.go, pvalueCutoff = p.value, conditional = FALSE,testDirection = "over"))
      Try(hgOver <- hyperGTest(params))
      Try(hgOver.info <- paste(description(hgOver),
            paste(length(universeCounts(hgOver)),"GO BP ids tested","(",length(which(pvalues(hgOver) < p.value)),"have p<",p.value,")", sep=" "),
            paste("Selected gene set size:",length(geneIds(hgOver)), sep=" "),
            paste("Gene universe size:", universeMappedCount(hgOver), sep=" "),
            paste("Annotation package:", hgOver@annotation, sep=" "), 
            sep="\n"))
      Try(tkmessageBox(title="GO class enrichment",message=paste(hgOver.info),icon="info",type="ok"))
      Try(conditional(params) <- TRUE)
      #Try(hgCondOver <- hyperGTest(params))
      Try(ggMat <- summary(hgOver))
          ggMat[,2:4] <- signif(ggMat[,2:4] ,2)
          #ggMat.term <- sapply(as.vector(ggMat[,7]), function(x){x.1 <- strsplit(x,">"); return(x.1[[2]])})
          #ggMat.term <- strsplit(ggMat[,7], ">")
          #ggMat.term <- sapply(ggMat.term, function(x){x[[2]]})
          #ggMat.term <- strsplit(ggMat.term, "<")
          #ggMat.term <- sapply(ggMat.term, function(x){x[[1]]})
          #ggMat[,7] <-  ggMat.term

        SaveTopTable <- function()
        {
               Try(FileName <- tclvalue(tkgetSaveFile(initialfile=paste("GO.enrichment.",my.go,"p-value",p.value,".xls",sep=""),filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
               Try(if(!nchar(FileName))
               return())
               Try(write.table(ggMat,file=FileName,quote=FALSE,sep="\t", row.names = F))
        }
 #Try(tkmessageBox(title="GO class enrichment",message="Enriched classes will be displayed in a text window.  You can save it as a tab-delimited text file and then import it into a spreadsheet program.",icon="info",type="ok"))
       Try(tempfile1 <- tempfile())
       write.table(ggMat,file=tempfile1,quote=FALSE,col.names=NA,sep="\t")
       ttToptableTable <- tktoplevel(.affylmGUIglobals$ttMain)
       tkwm.title(ttToptableTable,paste("GO enriched classes using p-value= ",p.value," annotation lib= ",lib," GO class= ",my.go,sep=" "))
       xscr <-tkscrollbar(ttToptableTable, repeatinterval=5,orient="horizontal", command=function(...)tkxview(txt,...))
       scr <- tkscrollbar(ttToptableTable, repeatinterval=5, command=function(...)tkyview(txt,...))
       txt <- tktext(ttToptableTable, bg="white", font="courier",xscrollcommand=function(...)tkset(xscr,...), yscrollcommand=function(...)tkset(scr,...),wrap="none",width=100)
       tkpack(scr, side="right", fill="y")
       tkpack(xscr, side="bottom", fill="x")
       tkpack(txt, side="left", fill="both", expand="yes")
       chn <- tclvalue(tclopen( tempfile1))
       tkinsert(txt, "end", tclvalue(tclread( chn)))
       tclclose( chn)
       tkconfigure(txt, state="disabled")
       tkmark.set(txt,"insert","0.0")
       tkfocus(txt)
       tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow")
       topMenu2 <- tkmenu(ttToptableTable)
       tkconfigure(ttToptableTable, menu=topMenu2)
       fileMenu2 <- tkmenu(topMenu2, tearoff=FALSE)
       tkadd(fileMenu2, "command", label="Save As", command=SaveTopTable) # ) # ,font=affylmGUIfontMenu)
       tkadd(fileMenu2, "command", label="Close", command=function() tkdestroy(ttToptableTable)) # ) # ,font=affylmGUIfontMenu)
       tkadd(topMenu2, "cascade", label="File", menu=fileMenu2) # ,font=affylmGUIfontMenu)
 
      
      #Try(tkmessageBox(title="GO class enrichment",message="Results will be saved as html file in your working directory",icon="info",type="ok"))
      #Try(FileName <- tclvalue(tkgetSaveFile(initialfile="GO.enriched.terms.html",filetypes="{{HTML files} {.html}} {{All files} *}")))
      #htmlReport(hgCondOver, file = FileName)
      #####################################
     #plotitng graphs
     Try(startGraph <- tclvalue(tkmessageBox(title="Plotting Graph",message="Do you wish to plot the graph of the enriched GO terms?\nIf you answer yes, graphviz software and Rgraphviz package should be already installed.",type="yesno",icon="question")))
     if (startGraph=="yes"){
                 require(Rgraphviz) || stop("library Rgraphviz could not be found !")
     } else {
                 Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                 Try(return())
     }
     if(my.go == "BP"){
            tfG <- GOGraph(ggMat[,1], GOBPPARENTS)
      } else if (my.go == "MF"){
            tfG <- GOGraph(ggMat[,1], GOMFPARENTS)
      } else if (my.go == "CC"){
            tfG <- GOGraph(ggMat[,1], GOCCPARENTS)
      }
     gCol <- rep("lightblue", length(nodes(tfG)))
     gCol[which(nodes(tfG)%in%ggMat[,1])] <- "tomato"
     
     tGfnA <- makeNodeAttrs(tfG,label=nodes(tfG),shape="ellipse",fillcolor=gCol,fixedsize=FALSE)
     Try(tkmessageBox(title="Plotting GO parents",message="Plot of GO term parents will be displayed on the main R window",icon="info",type="ok"))
     plot(tfG, nodeAttrs=tGfnA)
     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))

}

#GOenrichment()
################################################################################

plotGO<-function(){
  require(GOstats) || stop("library GOstats could not be found !")
  require(Rgraphviz) || stop("library Rgraphviz could not be found !")
  #error if no data are loaded
  Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
  if(whichArrayPlatform ==""){
              Try(tkmessageBox(title="GO analysis",message="No arrays have been loaded.	Please try New or Open from the File menu.",type="ok",icon="error"))
				    	Try(tkfocus(.affylmGUIglobals$ttMain))
              Try(return())
  }    
  #########################

  Try(ttGetGOName<-tktoplevel(.affylmGUIglobals$ttMain))
  Try(tkwm.deiconify(ttGetGOName))
  Try(tkgrab.set(ttGetGOName))
  Try(tkfocus(ttGetGOName))
  Try(tkwm.title(ttGetGOName,"GO class identifier"))
  Try(tkgrid(tklabel(ttGetGOName,text="    ")))
  Try(GONameText <- "")
  Try(Local.GOName <- tclVar(init=GONameText))
  Try(entry.GOName <-tkentry(ttGetGOName,width="10",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.GOName,bg="white"))
  Try(tkgrid(tklabel(ttGetGOName,text="Please enter the GO term.",font=.affylmGUIglobals$affylmGUIfont2)))
  Try(tkgrid(entry.GOName))
  onOK <- function()
  {
      Try(GONameText <- tclvalue(Local.GOName))
      if(nchar(GONameText)==0)
        GONameText <- "Unselected"
      Try(assign("GONameText",GONameText,affylmGUIenvironment))
      Try(tclvalue(.affylmGUIglobals$GONameTcl) <- GONameText)
      Try(tkgrab.release(ttGetGOName));Try(tkdestroy(ttGetGOName));Try(tkfocus(.affylmGUIglobals$ttMain))
  }
  Try(OK.but <-tkbutton(ttGetGOName,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
  Try(tkgrid(tklabel(ttGetGOName,text="    ")))
  Try(tkgrid(OK.but))
  Try(tkgrid.configure(OK.but))
  Try(tkgrid(tklabel(ttGetGOName,text="       ")))
  Try(tkfocus(entry.GOName))
  Try(tkbind(entry.GOName, "<Return>",onOK))
  Try(tkbind(ttGetGOName, "<Destroy>", function(){Try(tkgrab.release(ttGetGOName));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
  Try(tkwait.window(ttGetGOName))
  Try(tkfocus(.affylmGUIglobals$ttMain))
 #plotting parents of a specific GO term
 
  Try(i <- get("GONameText",envir=affylmGUIenvironment))

#defining the GO class
            Try(ttGetFilterMethod <- tktoplevel(.affylmGUIglobals$ttMain))
	      Try(tkwm.deiconify(ttGetFilterMethod))
            Try(tkgrab.set(ttGetFilterMethod))
            Try(tkfocus(ttGetFilterMethod))
            Try(tkwm.title(ttGetFilterMethod,"Which GO class?"))
	
 	      Try(tkgrid(tklabel(ttGetFilterMethod,text="    ")))
	      Try(ttGetFilterMethodTcl <- tclVar("BP"))
            Try(rbIQR.5 <- tkradiobutton(ttGetFilterMethod,text="BP",variable=ttGetFilterMethodTcl,value="BP",font=.affylmGUIglobals$affylmGUIfont2))
            Try(rbIQR.25<-tkradiobutton(ttGetFilterMethod,text="MF",variable=ttGetFilterMethodTcl,value="MF",font=.affylmGUIglobals$affylmGUIfont2))
            Try(rbIQR.1<-tkradiobutton(ttGetFilterMethod,text="CC",variable=ttGetFilterMethodTcl,value="CC",font=.affylmGUIglobals$affylmGUIfont2))
    
	      Try(tkgrid(tklabel(ttGetFilterMethod,text="    "),rbIQR.5))
	      Try(tkgrid(tklabel(ttGetFilterMethod,text="    "),rbIQR.25))
	      Try(tkgrid(tklabel(ttGetFilterMethod,text="    "),rbIQR.1))
	      Try(tkgrid.configure(rbIQR.5,rbIQR.25,rbIQR.1,columnspan=2,sticky="w"))
	      Try(tkgrid(tklabel(ttGetFilterMethod,text="    "),tklabel(ttGetFilterMethod,text="    ")))
	      Try(ReturnVal <- "")
	      Try(onCancel <- function() {Try(ReturnVal <<- "");Try(tkgrab.release(ttGetFilterMethod));Try(tkdestroy(ttGetFilterMethod));Try(tkfocus(.affylmGUIglobals$ttMain))})
	      Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttGetFilterMethodTcl));Try(tkgrab.release(ttGetFilterMethod));Try(tkdestroy(ttGetFilterMethod));Try(tkfocus(.affylmGUIglobals$ttMain))})

	      Try(OK.but     <- tkbutton(ttGetFilterMethod,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	      Try(Cancel.but <- tkbutton(ttGetFilterMethod,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	      Try(tkgrid(tklabel(ttGetFilterMethod,text="    "),OK.but,Cancel.but,tklabel(ttGetFilterMethod,text="    ")))
	      Try(tkgrid.configure(OK.but,sticky="e"))
	      Try(tkgrid.configure(Cancel.but,sticky="w"))
	      Try(tkgrid(tklabel(ttGetFilterMethod,text="    ")))

	      Try(tkbind(ttGetFilterMethod,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetFilterMethod));Try(tkfocus(.affylmGUIglobals$ttMain))}))
            Try(tkbind(OK.but, "<Return>",onOK))
            Try(tkbind(Cancel.but, "<Return>",onCancel))      

	      Try(tkwait.window(ttGetFilterMethod))
  if(ReturnVal=="BP"){
     tfG <- GOGraph(i, GOBPPARENTS)
     rootNames <- c("all", "top")
     root <- rootNames[rootNames %in% nodes(tfG)]
     if (length(root) > 0)  tfG <- removeNode(root, tfG)
     nL <- nodes(tfG)
     nLterm = unlist(getGOTerm(nL), use.names=FALSE)
     names(nLterm) = nL
     nLterm = gsub("_", " ", nLterm)
     tGfnA <- list()
     tmp <- rep("ellipse", length(nL))
     names(tmp) <- nL
     tGfnA$shape = tmp;
     tmp <- rep(FALSE, length(nL))
     names(tmp) = nL
     tGfnA$fixedsize = tmp
     names(nLterm) <- nL
     tGfnA$label = nLterm
     Try(tkmessageBox(title="Plotting GO parents",message="Plot of GO term parents will be displayed on the main R window",icon="info",type="ok"))
     plot(tfG, nodeAttrs=tGfnA)
  } else if(ReturnVal=="MF"){
     tfG <- GOGraph(i, GOMFPARENTS)
     rootNames <- c("all", "top")
     root <- rootNames[rootNames %in% nodes(tfG)]
     if (length(root) > 0)  tfG <- removeNode(root, tfG)
     nL <- nodes(tfG)
     nLterm = unlist(getGOTerm(nL), use.names=FALSE)
     names(nLterm) = nL
     nLterm = gsub("_", " ", nLterm)
     tGfnA <- list()
     tmp <- rep("ellipse", length(nL))
     names(tmp) <- nL
     tGfnA$shape = tmp;
     tmp <- rep(FALSE, length(nL))
     names(tmp) = nL
     tGfnA$fixedsize = tmp
     names(nLterm) <- nL
     tGfnA$label = nLterm
     Try(tkmessageBox(title="Plotting GO parents",message="Plot of GO term parents will be displayed on the main R window",icon="info",type="ok"))
     plot(tfG, nodeAttrs=tGfnA)
  } else if(ReturnVal=="CC"){

     tfG <- GOGraph(i, GOCCPARENTS)
     rootNames <- c("all", "top")
     root <- rootNames[rootNames %in% nodes(tfG)]
     if (length(root) > 0)  tfG <- removeNode(root, tfG)
     nL <- nodes(tfG)
     nLterm = unlist(getGOTerm(nL), use.names=FALSE)
     names(nLterm) = nL
     nLterm = gsub("_", " ", nLterm)
     tGfnA <- list()
     tmp <- rep("ellipse", length(nL))
     names(tmp) <- nL
     tGfnA$shape = tmp;
     tmp <- rep(FALSE, length(nL))
     names(tmp) = nL
     tGfnA$fixedsize = tmp
     names(nLterm) <- nL
     tGfnA$label = nLterm
     Try(tkmessageBox(title="Plotting GO parents",message="Plot of GO term parents will be displayed on the main R window",icon="info",type="ok"))
     plot(tfG, nodeAttrs=tGfnA)
  } else{
      Try(return())
  } 
}
################################################################################

#This function starts for a topTable and extracts the subset of probe ids associated to a GO class
#found differentially expressed using the Goenrichment function
"extractAffyids" <- function(){
  Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  require(annotate, quietly = TRUE) || stop("\nneed data package: annotate\n")
  require(annaffy, quietly = TRUE) || stop("\nneed data package: annaffy\n")
  #error if no data are loaded
  Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
  if(whichArrayPlatform ==""){
            Try(tkmessageBox(title="GO analysis",message="No arrays have been loaded.	Please try New or Open from the File menu.",type="ok",icon="error"))
	  	    	Try(tkfocus(.affylmGUIglobals$ttMain))
            Try(return())
  }    
  #########################

  Try(ttGetGOName<-tktoplevel(.affylmGUIglobals$ttMain))
  Try(tkwm.deiconify(ttGetGOName))
  Try(tkgrab.set(ttGetGOName))
  Try(tkfocus(ttGetGOName))
  Try(tkwm.title(ttGetGOName,"GO class identifier"))
  Try(tkgrid(tklabel(ttGetGOName,text="    ")))
  Try(GONameText <- "")
  Try(Local.GOName <- tclVar(init=GONameText))
  Try(entry.GOName <-tkentry(ttGetGOName,width="10",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.GOName,bg="white"))
  Try(tkgrid(tklabel(ttGetGOName,text="Please enter the GO term.",font=.affylmGUIglobals$affylmGUIfont2)))
  Try(tkgrid(entry.GOName))
  onOK <- function()
  {
      Try(GONameText <- tclvalue(Local.GOName))
      if(nchar(GONameText)==0)
        GONameText <- "Unselected"
      Try(assign("GONameText",GONameText,affylmGUIenvironment))
      Try(tclvalue(.affylmGUIglobals$GONameTcl) <- GONameText)
      Try(tkgrab.release(ttGetGOName));Try(tkdestroy(ttGetGOName));Try(tkfocus(.affylmGUIglobals$ttMain))
  }
  Try(OK.but <-tkbutton(ttGetGOName,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
  Try(tkgrid(tklabel(ttGetGOName,text="    ")))
  Try(tkgrid(OK.but))
  Try(tkgrid.configure(OK.but))
  Try(tkgrid(tklabel(ttGetGOName,text="       ")))
  Try(tkfocus(entry.GOName))
  Try(tkbind(entry.GOName, "<Return>",onOK))
  Try(tkbind(ttGetGOName, "<Destroy>", function(){Try(tkgrab.release(ttGetGOName));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
  Try(tkwait.window(ttGetGOName))
  Try(tkfocus(.affylmGUIglobals$ttMain))
  
  Try(x <- get("NormalizedAffyData",envir=affylmGUIenvironment))

#passing a library to a function
#  getDataEnv <- function(name, lib) {
#        	get(paste(lib, name, sep = ""), mode = "environment")
#    	}

#opening a file graphically
OpenAFile <- function(FileName) {
         Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
               if(!nchar(tempFileName))
               {
                  tkfocus(.affylmGUIglobals$ttMain)
                  return()
               }
         mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE)
         return(mySel)
      }

  if(!is.numeric(x)){
     #in case of exon arrays I use the LLMapping libraries
     if(whichArrayPlatform=="EXON"){
         whichLib <- get("whichLib", envir=affylmGUIenvironment)
                    Try(if(whichLib[[1]][1]=="HuEx"){
                            #require(humanLLMappings) || stop("library humanLLMappings could not be found !")
                            #lib <- "humanLLMappings"
                            require(org.Hs.eg.db, quietly = TRUE) || stop("\nneed data package: org.Hs.eg.db\n")
                            lib = "org.Hs.eg.db"
                    })
                    Try(if(whichLib[[1]][1]=="MoEx"){
                            #require(mouseLLMappings) || stop("library mouseLLMappings could not be found !")
                            #lib <- "mouseLLMappings"
                            require(org.Mm.eg.db, quietly = TRUE) || stop("\nneed data package: org.Mm.eg.db\n")
                            lib = "org.Mm.eg.db"
                   })
                    Try(if(whichLib[[1]][1]=="RaEx"){
                            #require(ratLLMappings) || stop("library ratLLMappings could not be found !")
                            #lib <- "ratLLMappings"
                            require(org.Rn.eg.db, quietly = TRUE) || stop("\nneed data package: org.Rn.eg.db\n")
                            lib = "org.Rn.eg.db"
                   })
         Try(i <- get("GONameText",envir=affylmGUIenvironment))
         i.name <- strsplit(i, ":")
         #lltoacc <- as.character(unlist(lookUp(as.character(acc), lib, "ACCNUM2EG")))
         #allGO <- unlist(mget(i, env=getDataEnv("GO2LL", lib)))
         #allGO <- unlist(lookUp(as.character(i), lib, "GO2EG"))    #select only the egs associated to the GO terms
         allGO <- unlist(lookUp(as.character(i), lib, "GO2ALLEGS")) #selects the egs associated to the term and to the childrens
  
     }else{  
         lib= .annotation(x)
         if(length(as.character(unlist(strsplit(lib, "\\.")))) == 1){
                   Try(lib <- paste(lib, ".db", sep=""))
         }
        	require(lib, character.only = TRUE) || stop("need data package: ", lib)
          Try(i <- get("GONameText",envir=affylmGUIenvironment))
          i.name <- strsplit(i, ":")
          allGO <- unlist(lookUp(as.character(i), lib,"GO2ALLPROBES"))
    }
      Try(tkmessageBox(title="DF in GO term",message="Select the file containing the set of differentially expressed probe sets",icon="info",type="ok"))
      tmp.x <- OpenAFile()
      if(dim(tmp.x)[2]>1){
            Try(tkmessageBox(title="Extracting Affy IDs",message=paste("Input file should contain\nonly a column with\nAffymetrix ids")))  
      }
      
      if(whichArrayPlatform=="EXON"){
        Try(annlibloc <- grep(paste("^",whichLib[[1]][1],sep=""), as.vector(unlist(data(package="oneChannelGUI"))), ignore.case = T))
        Try(annlibname <- as.vector(unlist(data(package="oneChannelGUI")))[annlibloc])
        Try(data(list=annlibname,package="oneChannelGUI"))
        Try(exonannlib<- get(annlibname,envir=.GlobalEnv))
        Try(gNsel<-as.character(tmp.x[,1]))#gene level ids
        Try(myacc <- as.character(exonannlib$ACC[which(as.character(exonannlib$PROBESETID)%in%gNsel)])) #defining the acc of diff exprs
        Try(myacc <- myacc[!is.na(myacc)])
        #Try(mylltoacc <- mget(myacc,getDataEnv("ACCNUM2LL", lib), ifnotfound=""))#LL ids
        Try(mylltoacc <- as.character(unlist(lookUp(myacc, lib, "ACCNUM2EG"))))
        Try(gNll <- unique(as.character(unlist(mylltoacc))))#ll of diff exprs data
        Try(gNll <- gNll[!is.na(gNll)])
        Try(gNll <- gNll[gNll != ""])
        Try(dfGO <- as.character(unlist(allGO[which(allGO%in% gNll)])))
        #Try(myaccfromll <- mget(as.character(unlist(dfGO)),getDataEnv("LL2ACCNUM", lib), ifnotfound=""))#back to acc
        Try(myaccfromll <- as.character(unlist(lookUp(dfGO,lib, "ACCNUM"))))
        if (length(dfGO)>0){
            Try(mysubset <-  exonannlib[which(exonannlib$ACC%in%myaccfromll),])#To be sure that the subset of probe set associaoted to GO terms is really attached to the sub set of  gene level exon probe set under analysis.
            Try(mysubset <- mysubset[which(mysubset$PROBESETID%in%gNsel),])#To be sure that the subset of probe set associaoted to GO terms is really attached to the sub set of  gene level exon probe set under analysis.
            Try(tkmessageBox(title="DF in GO term",message="Gene level annotation for differentially expressed probe sets will be saved with annotation in a TXT file",icon="info",type="ok"))
            #saving the filtered subset
            SaveTopTable <- function()
           {
               Try(FileName <- tclvalue(tkgetSaveFile(initialfile=paste("df.ids.from.GO.",i.name[[1]][2],".txt",sep=""),filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
               Try(if(!nchar(FileName))
               return())
               Try(write.table(mysubset,file=FileName,quote=FALSE, sep="\t", row.names=F))
          }
          SaveTopTable()
        }
      }else{
        gNsel<-as.character(tmp.x[,1])
        dfGO <- allGO[which(allGO%in% gNsel)]
        if (length(dfGO)>0){
            dfGO <- unique(sort(dfGO))
            anntable <- aafTableAnn(dfGO, lib, colnames=aaf.handler())
            #saving results in a HTML file
            Try(tkmessageBox(title="DF in GO term",message="Differentially expressed probe sets will be saved with annotation in a HTML file",icon="info",type="ok"))
            SaveHtmlTable <- function()
           {
               Try(FileName <- tclvalue(tkgetSaveFile(initialfile=paste("df.ids.from.GO.",i.name[[1]][2],".html",sep=""),filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
               Try(if(!nchar(FileName))
               return())
               Try(saveHTML(anntable, FileName, title = paste("Differentially expressed probe sets in ",i, sep="")))
           }
           SaveHtmlTable()
        } else  Try(tkmessageBox(title="Extract Affy IDs",message="No affy IDs  could be found associated to this GO term", type="ok",icon="error"))
     }
 } else   Try(tkmessageBox(title="Extract Affy IDs",message=paste("A set of arrays should be loaded and normalized"), type="ok",icon="error"))
 Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
}
################################################################################

templA<-function(){
        Try(NormalizedAffyData.Available <- get("NormalizedAffyData.Available",envir=affylmGUIenvironment))
        if(NormalizedAffyData.Available){
           Try(NormalizedAffyData <- get("NormalizedAffyData",envir=affylmGUIenvironment))
        } else {            
           Try(tkmessageBox(title="Creating an Ingenuity Template A",message="Normalized data set is not loaded"))
           return()
        }
        ##selecting the type of differentially expressed topTabe
        Try(ttGetTableMethod <- tktoplevel(.affylmGUIglobals$ttMain))
	      Try(tkwm.deiconify(ttGetTableMethod))
        Try(tkgrab.set(ttGetTableMethod))
        Try(tkfocus(ttGetTableMethod))
        Try(tkwm.title(ttGetTableMethod,"LIMMA/SAM/RankProd output?"))
	      Try(tkgrid(tklabel(ttGetTableMethod,text="    ")))
	      Try(ttGetTableMethodTcl <- tclVar("LIMMA"))
        Try(rbIQR.5 <- tkradiobutton(ttGetTableMethod,text="LIMMA",variable=ttGetTableMethodTcl,value="LIMMA",font=.affylmGUIglobals$affylmGUIfont2))
        Try(rbIQR.25<-tkradiobutton(ttGetTableMethod,text="SAM",variable=ttGetTableMethodTcl,value="SAM",font=.affylmGUIglobals$affylmGUIfont2))
        Try(rbIQR.1<-tkradiobutton(ttGetTableMethod,text="RankProd",variable=ttGetTableMethodTcl,value="RankProd",font=.affylmGUIglobals$affylmGUIfont2))
	      Try(tkgrid(tklabel(ttGetTableMethod,text="    "),rbIQR.5))
	      Try(tkgrid(tklabel(ttGetTableMethod,text="    "),rbIQR.25))
	      Try(tkgrid(tklabel(ttGetTableMethod,text="    "),rbIQR.1))
	      Try(tkgrid.configure(rbIQR.5,rbIQR.25,rbIQR.1,columnspan=2,sticky="w"))
	      Try(tkgrid(tklabel(ttGetTableMethod,text="    "),tklabel(ttGetTableMethod,text="    ")))
	      Try(ReturnVal <- "")
	      Try(onCancel <- function() {Try(ReturnVal <<- "");Try(tkgrab.release(ttGetTableMethod));Try(tkdestroy(ttGetTableMethod));Try(tkfocus(.affylmGUIglobals$ttMain))})
	      Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttGetTableMethodTcl));Try(tkgrab.release(ttGetTableMethod));Try(tkdestroy(ttGetTableMethod));Try(tkfocus(.affylmGUIglobals$ttMain))})

	      Try(OK.but     <- tkbutton(ttGetTableMethod,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	      Try(Cancel.but <- tkbutton(ttGetTableMethod,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	      Try(tkgrid(tklabel(ttGetTableMethod,text="    "),OK.but,Cancel.but,tklabel(ttGetTableMethod,text="    ")))
	      Try(tkgrid.configure(OK.but,sticky="e"))
	      Try(tkgrid.configure(Cancel.but,sticky="w"))
	      Try(tkgrid(tklabel(ttGetTableMethod,text="    ")))

	      Try(tkbind(ttGetTableMethod,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetTableMethod));Try(tkfocus(.affylmGUIglobals$ttMain));}))
        Try(tkbind(OK.but, "<Return>",onOK))
        Try(tkbind(Cancel.but, "<Return>",onCancel))      

	      Try(tkwait.window(ttGetTableMethod))
	      
        if(ReturnVal==""){return()} else{
              #loading a topTable
              Try(tkmessageBox(title="Creating an Ingenuity Template A",message=paste("Open the file containing the table generated in oneChannelGUI by ", ReturnVal,  " methods.")))
              Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt, .xls}} {{All files} *}")))
              if(!nchar(tempFileName)){
                  tkfocus(.affylmGUIglobals$ttMain)
                  return()
              }
              Try(tmp<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote = ""))
              if(ReturnVal == "LIMMA"){
                 if(length(tmp[,1]) == length(unique(tmp[,1]))){
                   Try(id <- featureNames(NormalizedAffyData))
                   Try(fc <- rep("",length(id)))#creating a vector of FC empty
                   Try(names(fc) <- featureNames(NormalizedAffyData))
                   Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
                   if(whichArrayPlatform == "EXON"){
                   ####getting acc
                   Try(whichLib <- get("whichLib", envir=affylmGUIenvironment)) 
                   Try(annlibloc <- grep(paste("^",whichLib[[1]][1],sep=""), as.vector(unlist(data(package="oneChannelGUI"))), ignore.case = T))
                   Try(annlibname <- as.vector(unlist(data(package="oneChannelGUI")))[annlibloc])
                   Try(data(list=annlibname,package="oneChannelGUI"))
                   Try(exonannlib<- get(annlibname,envir=.GlobalEnv))
                 #  Try(genelist <- featureNames(NormalizedAffyData))#normalizeAffyData in x
                   Try(acc <- as.character(exonannlib$ACC[which(as.character(exonannlib$PROBESETID)%in%id)])) #defining the universe of ll
                   Try(probeset <- as.character(exonannlib$PROBESETID[which(as.character(exonannlib$PROBESETID)%in%id)]))#needed to have the same orientation of probe set ids and acc
                   Try(names(acc) <- probeset)
                    #######
                       Try(fc[which(names(fc)%in%as.character(tmp[,1]))] <- tmp[,6]) 
                   } else {
                       Try(fc[which(names(fc)%in%as.character(tmp[,1]))] <- tmp[,4]) #adding the known fc for the differentially expressed genes 
                   }
                   Try(pval.true <- rep(1,length(id)))#creating a vector of p-val empty
                   Try(names(pval.true) <- featureNames(NormalizedAffyData))
                   if(whichArrayPlatform == "EXON"){
                       Try(pval.true[which(names(pval.true)%in%as.character(tmp[,1]))] <- tmp[,9]) 
                   } else {
                       Try(pval.true[which(names(pval.true)%in%as.character(tmp[,1]))] <- tmp[,7]) #adding the known fc for the differentially expressed genes
                   }
                    Try(pval <- rep(1,length(id)))#creating a vector of p-val empty
                   Try(names(pval) <- featureNames(NormalizedAffyData))
                   Try(pval[which(names(pval)%in%as.character(tmp[,1]))] <- 0) #adding the known fc for the differentially expressed genes 
                   Try(absent <- rep("",length(id)))
                   Try(override <- rep("",length(id)))
                   Try(out<-data.frame(id,fc,pval,pval.true,absent,override))
                   Try(names(out)<-c("Gene/Protein ID","Fold change","P value for subsetting","True P value", "Absent", "Override"))
                   if(whichArrayPlatform == "EXON"){
                        Try(out <- out[order(out[,1]),])
                        Try(acc <- acc[order(names(acc))])
                      if(identical(as.character(out[,1]), as.character(names(acc)))){ 
                           Try(out[,1] <- acc)
                      } else {
                                 Try(tkmessageBox(title="Creating an Ingenuity Template A",message="Internal error in templA for exon arrays.\nPlease, contact the oneChannelGUI mantainer."))
                                 Try(return())
                      }
                   }
               }  else {
                          Try(tkmessageBox(title="Creating an Ingenuity Template A",message="Chech your table of differentially expressed genes for the presence of duplicated probe sets\nremove them before creating the templateA."))
                          Try(return())
                  }
             } else if (ReturnVal == "RankProd"){
                 if(length(tmp[,1]) == length(unique(tmp[,1]))){  
                   Try(id <- featureNames(NormalizedAffyData))
                   Try(fc <- rep("",length(id)))#creating a vector of FC empty
                   Try(names(fc) <- featureNames(NormalizedAffyData))
                   Try(fc[which(names(fc)%in%as.character(tmp[,1]))] <- tmp[,6]) #adding the known fc for the differentially expressed genes
                   Try(pval.true <- rep(1,length(id)))#creating a vector of p-val empty
                   Try(names(pval.true) <- featureNames(NormalizedAffyData))
                   Try(pval.true[which(names(pval.true)%in%as.character(tmp[,1]))] <- tmp[,8]) #adding the known pval for the differentially expressed genes
                   Try(pval <- rep(1,length(id)))#creating a vector of p-val empty
                   Try(names(pval) <- featureNames(NormalizedAffyData))
                   Try(pval[which(names(pval)%in%as.character(tmp[,1]))] <- 0) #adding the selection p val for the differentially expressed genes
                   Try(absent <- rep("",length(id)))
                   Try(override <- rep("",length(id)))
                   Try(out<-data.frame(id,fc,pval,pval.true,absent,override))
                   names(out)<-c("Gene/Protein ID","Fold change","P value for subsetting","True P value", "Absent", "Override")
                 } else {
                          Try(tkmessageBox(title="Creating an Ingenuity Template A",message="Chech your table of differentially expressed genes for the presence of duplicated probe sets\nremove them before creating the templateA."))
                          Try(return())
                   }            
              } else if (ReturnVal == "SAM"){
                 if(length(tmp[,1]) == length(unique(tmp[,1]))){
                   Try(id <- featureNames(NormalizedAffyData))
                   Try(fc <- rep("",length(id)))#creating a vector of FC empty
                   Try(names(fc) <- featureNames(NormalizedAffyData))
                   Try(fc[which(names(fc)%in%as.character(tmp[,1]))] <- tmp[,8]) #adding the known fc for the differentially expressed genes
                   Try(pval.true <- rep(1,length(id)))#creating a vector of p-val empty
                   Try(names(pval.true) <- featureNames(NormalizedAffyData))
                   Try(pval.true[which(names(pval.true)%in%as.character(tmp[,1]))] <- tmp[,6]) #adding the known pval for the differentially expressed genes
                   Try(pval <- rep(1,length(id)))#creating a vector of p-val empty
                   Try(names(pval) <- featureNames(NormalizedAffyData))
                   Try(pval[which(names(pval)%in%as.character(tmp[,1]))] <- 0) #adding the selection p-val for the differentially expressed genes
                   Try(absent <- rep("",length(id)))
                   Try(override <- rep("",length(id)))
                   Try(out<-data.frame(id,fc,pval,pval.true,absent,override))
                   names(out)<-c("Gene/Protein ID","Fold change","P value for subsetting","True P value", "Absent", "Override")             
                }  else {
                          Try(tkmessageBox(title="Creating an Ingenuity Template A",message="Chech your table of differentially expressed genes for the presence of duplicated probe sets\nremove them before creating the templateA."))
                          Try(return())
                   }
                }
      #saving the filtered subset
      SaveTopTable <- function()
      {
               Try(FileName <- tclvalue(tkgetSaveFile(initialfile=paste(tempFileName,".templA",".xls",sep=""),filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
               Try(if(!nchar(FileName))
               return())
               Try(write.table(out,file=FileName,quote=FALSE, sep="\t", row.names=F))
      }
             

      Try(mbVal <- tkmessageBox(title="Ingenuity template A",
                message="Save the templateA for IPA upload\nRemember: the differentially expressed genes can be subsetted in Ingenuity \nsetting to 0 the threshold for P.value.for.subsetting column.",
                icon="question",type="yesno",default="yes"))
                try(if(tclvalue(mbVal)=="yes") SaveTopTable())
   }
}
################################################################################

metaArrayMerge <- function(){
         require(metaArray) || stop("library metaArray could not be found !")
         require(MergeMaid) || stop("\nMissing MergeMaid package\n")
         require(affy) || stop("library affy could not be found !")
         #opening a file graphically
         OpenAFile <- function(FileName) {
               Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
                 if(!nchar(tempFileName))
                 {
                   tkfocus(.affylmGUIglobals$ttMain)
                   return()
                 }
                 mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, row.names=1)
                 return(mySel)
         }
         #error if no data are loaded
         Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
         if(whichArrayPlatform ==""){
              Try(tkmessageBox(title="Meta analysis",message="No arrays have been loaded.	Please try New or Open from the File menu.",type="ok",icon="error"))
				    	Try(tkfocus(.affylmGUIglobals$ttMain))
              Try(return())
          }    
        Try(NormalizedAffyData.Available     <- get("NormalizedAffyData.Available" , envir=affylmGUIenvironment))
        if(NormalizedAffyData.Available){
              Try(NormalizedAffyData     <- get("NormalizedAffyData" , envir=affylmGUIenvironment))

              ##makning the menu for selecting IQR threshold
              Try(ttMetaSet <- tktoplevel(.affylmGUIglobals$ttMain))
	            Try(tkwm.deiconify(ttMetaSet))
              Try(tkgrab.set(ttMetaSet))
              Try(tkfocus(ttMetaSet))
              Try(tkwm.title(ttMetaSet,"How many data sets will be merged to NormalizedAffyData?"))
 	            Try(tkgrid(tklabel(ttMetaSet,text="    ")))
	            Try(ttMetaSetTcl <- tclVar("1"))
              Try(rbM1 <- tkradiobutton(ttMetaSet,text="1 data set",variable=ttMetaSetTcl,value="1",font=.affylmGUIglobals$affylmGUIfont2))
              Try(rbM2<-tkradiobutton(ttMetaSet,text="2 data sets",variable=ttMetaSetTcl,value="2",font=.affylmGUIglobals$affylmGUIfont2))
              Try(rbM3<-tkradiobutton(ttMetaSet,text="3 data sets",variable=ttMetaSetTcl,value="3",font=.affylmGUIglobals$affylmGUIfont2))
	            Try(tkgrid(tklabel(ttMetaSet,text="    "),rbM1))
	            Try(tkgrid(tklabel(ttMetaSet,text="    "),rbM2))
	            Try(tkgrid(tklabel(ttMetaSet,text="    "),rbM3))
	            Try(tkgrid.configure(rbM1,rbM2,rbM3,columnspan=2,sticky="w"))
	            Try(tkgrid(tklabel(ttMetaSet,text="    "),tklabel(ttMetaSet,text="    ")))
	            Try(ReturnVal <- "")
	            Try(onCancel <- function() {Try(tkgrab.release(ttMetaSet));Try(tkdestroy(ttMetaSet));Try(tkfocus(.affylmGUIglobals$ttMain)); Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"));Try(return())})
	            Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttMetaSetTcl));Try(tkgrab.release(ttMetaSet));Try(tkdestroy(ttMetaSet));Try(tkfocus(.affylmGUIglobals$ttMain))})
	            Try(OK.but     <- tkbutton(ttMetaSet,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	            Try(Cancel.but <- tkbutton(ttMetaSet,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	            Try(tkgrid(tklabel(ttMetaSet,text="    "),OK.but,Cancel.but,tklabel(ttMetaSet,text="    ")))
	            Try(tkgrid.configure(OK.but,sticky="e"))
	            Try(tkgrid.configure(Cancel.but,sticky="w"))
	            Try(tkgrid(tklabel(ttMetaSet,text="    ")))

	            Try(tkbind(ttMetaSet,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttMetaSet));Try(tkfocus(.affylmGUIglobals$ttMain));}))
              Try(tkbind(OK.but, "<Return>",onOK))
              Try(tkbind(Cancel.but, "<Return>",onCancel))      
	            Try(tkwait.window(ttMetaSet))

              if(ReturnVal=="1"){
                   #target second set
                   Try(tkmessageBox(title="Selecting the target file of the data set to be merged to NormalizedAffyData",message="Open the target file of the associated to the data set to be merged\nThis is a standard oneChannelGUI target file!", type="ok", icon="info"))  
                   Try(secondSetpData <- OpenAFile())
                   Try(rownames(secondSetpData) <- secondSetpData$FileName) 
                   Try(var.tmp.pd<-data.frame(names(secondSetpData)))
                   Try(names(var.tmp.pd)<-"labelDescription" )
                   Try(rownames(var.tmp.pd)<-names(secondSetpData))
                   Try(tmp1.pd<-new("AnnotatedDataFrame", data=secondSetpData, varMetadata=var.tmp.pd))
                   #data second set
                   Try(tkmessageBox(title="Selecting the data set to be merged to NormalizedAffyData",message="Only tab delimited files, with array names in header and 1st column with probe set ids", type="ok", icon="info"))  
                   Try(secondSet <- OpenAFile())
                   Try(secondSet <- new("ExpressionSet", exprs=as.matrix(secondSet), phenoData=tmp1.pd, annotation=""))
                   if(identical(featureNames(NormalizedAffyData),featureNames(secondSet))){
                         Try(merged <- mergeExprs(NormalizedAffyData, secondSet))
                         Try(assign("metaData.Available",TRUE,affylmGUIenvironment))
                         Try(assign("metaData",merged,affylmGUIenvironment))
                         Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
                         Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree))
                   } else {
                         Try(common <- length(intersect(featureNames(NormalizedAffyData),featureNames(secondSet))))
                         Try(metaVal <- tkmessageBox(title="Meta analysis",
				    											message=paste("The two datasets have in common ",common," probe sets.\nDo you wish to continue the analysis on them?",sep=""),
						    									icon="question",type="yesno",default="yes"
								    						 )#end of tkmessageBox
		                     )#end of Try(mbVal..
		                     if(tclvalue(metaVal)=="no"){Try(return())}
		                     Try(commonSet <- intersect(featureNames(NormalizedAffyData),featureNames(secondSet)))
                         Try(merged <- mergeExprs(NormalizedAffyData[which(featureNames(NormalizedAffyData)%in%commonSet),], secondSet[which(featureNames(secondSet)%in%commonSet),]))
                         Try(assign("metaData.Available",TRUE,affylmGUIenvironment))
                         Try(assign("metaData",merged,affylmGUIenvironment))
                         Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
                         Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Available 2 sets",font=.affylmGUIglobals$affylmGUIfontTree))
                  }
              } else if(ReturnVal=="2"){
                   #target second set
                   Try(tkmessageBox(title="Selecting the target file of the 1st data set to be merged to NormalizedAffyData",message="Open the target file of the associated to the 1ST data set to be merged\nThis is a standard oneChannelGUI target file!", type="ok", icon="info"))  
                   Try(tmppData <- OpenAFile())
                   Try(rownames(tmppData) <- tmppData$FileName) 
                   Try(var.tmp.pd<-data.frame(names(tmppData)))
                   Try(names(var.tmp.pd)<-"labelDescription" )
                   Try(rownames(var.tmp.pd)<-names(tmppData))
                   Try(tmp1.pd<-new("AnnotatedDataFrame", data=tmppData, varMetadata=var.tmp.pd))
                   #data second set
                   Try(tkmessageBox(title="Selecting the 1st data set to be merged to NormalizedAffyData",message="1ST data set: Only tab delimited files, with array names in header and 1st column with probe set ids", type="ok", icon="info"))  
                   Try(tmpSet <- OpenAFile())
                   Try(secondSet <- new("ExpressionSet", exprs=as.matrix(tmpSet), phenoData=tmp1.pd, annotation=""))

                   #target 3rd set
                   Try(tkmessageBox(title="Selecting the target file of the 2nd data set to be merged to NormalizedAffyData",message="Open the target file of the associated to the 2ND data set to be merged\nThis is a standard oneChannelGUI target file!", type="ok", icon="info"))  
                   Try(tmppData <- OpenAFile())
                   Try(rownames(tmppData) <- tmppData$FileName) 
                   Try(var.tmp.pd<-data.frame(names(tmppData)))
                   Try(names(var.tmp.pd)<-"labelDescription" )
                   Try(rownames(var.tmp.pd)<-names(tmppData))
                   Try(tmp1.pd<-new("AnnotatedDataFrame", data=tmppData, varMetadata=var.tmp.pd))
                   #data 3rd set
                   Try(tkmessageBox(title="Selecting the 2nd data set to be merged to NormalizedAffyData",message="2ND dataset: Only tab delimited files, with array names in header and 1st column with probe set ids", type="ok", icon="info"))  
                   Try(tmpSet <- OpenAFile())
                   Try(thirdSet <- new("ExpressionSet", exprs=as.matrix(tmpSet), phenoData=tmp1.pd, annotation=""))

                   if(identical(featureNames(NormalizedAffyData),featureNames(secondSet)) 
                       & identical(featureNames(NormalizedAffyData),featureNames(thirdSet))){
                         Try(merged <- mergeExprs(NormalizedAffyData, secondSet, thirdSet))
                         Try(assign("metaData.Available",TRUE,affylmGUIenvironment))
                         Try(assign("metaData",merged,affylmGUIenvironment))
                         Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
                         Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Available 3 sets",font=.affylmGUIglobals$affylmGUIfontTree))
                   } else {
                         Try(tkmessageBox(title="Meta analysis",message="Data sets do not share the same identifiers!",type="ok",icon="error"))
				    	           Try(tkfocus(.affylmGUIglobals$ttMain))
                         Try(return())
    
                  }
              } else if(ReturnVal=="3"){
                   #target second set
                   Try(tkmessageBox(title="Selecting the target file of the 1st data set to be merged to NormalizedAffyData",message="Open the target file of the associated to the 1ST data set to be merged\nThis is a standard oneChannelGUI target file!", type="ok", icon="info"))  
                   Try(tmppData <- OpenAFile())
                   Try(rownames(tmppData) <- tmppData$FileName) 
                   Try(var.tmp.pd<-data.frame(names(tmppData)))
                   Try(names(var.tmp.pd)<-"labelDescription" )
                   Try(rownames(var.tmp.pd)<-names(tmppData))
                   Try(tmp1.pd<-new("AnnotatedDataFrame", data=tmppData, varMetadata=var.tmp.pd))
                   #data second set
                   Try(tkmessageBox(title="Selecting the 1st data set to be merged to NormalizedAffyData",message="1ST data set: Only tab delimited files, with array names in header and 1st column with probe set ids", type="ok", icon="info"))  
                   Try(tmpSet <- OpenAFile())
                   Try(secondSet <- new("ExpressionSet", exprs=as.matrix(tmpSet), phenoData=tmp1.pd, annotation=""))

                   #target 3rd set
                   Try(tkmessageBox(title="Selecting the target file of the 2nd data set to be merged to NormalizedAffyData",message="Open the target file of the associated to the 2ND data set to be merged\nThis is a standard oneChannelGUI target file!", type="ok", icon="info"))  
                   Try(tmppData <- OpenAFile())
                   Try(rownames(tmppData) <- tmppData$FileName) 
                   Try(var.tmp.pd<-data.frame(names(tmppData)))
                   Try(names(var.tmp.pd)<-"labelDescription" )
                   Try(rownames(var.tmp.pd)<-names(tmppData))
                   Try(tmp1.pd<-new("AnnotatedDataFrame", data=tmppData, varMetadata=var.tmp.pd))
                   #data 3rd set
                   Try(tkmessageBox(title="Selecting the 2nd data set to be merged to NormalizedAffyData",message="2ND data file: Only tab delimited files, with array names in header and 1st column with probe set ids", type="ok", icon="info"))  
                   Try(tmpSet <- OpenAFile())
                   Try(thirdSet <- new("ExpressionSet", exprs=as.matrix(tmpSet), phenoData=tmp1.pd, annotation=""))

                   #target 4th set
                   Try(tkmessageBox(title="Selecting the target file of the 3rd data set to be merged to NormalizedAffyData",message="Open the target file of the associated to the 3RD data set to be merged\nThis is a standard oneChannelGUI target file!", type="ok", icon="info"))  
                   Try(tmppData <- OpenAFile())
                   Try(rownames(tmppData) <- tmppData$FileName) 
                   Try(var.tmp.pd<-data.frame(names(tmppData)))
                   Try(names(var.tmp.pd)<-"labelDescription" )
                   Try(rownames(var.tmp.pd)<-names(tmppData))
                   Try(tmp1.pd<-new("AnnotatedDataFrame", data=tmppData, varMetadata=var.tmp.pd))
                   #data 4th set
                   Try(tkmessageBox(title="Selecting the 2nd data set to be merged to NormalizedAffyData",message="3RD data file: Only tab delimited files, with array names in header and 1st column with probe set ids", type="ok", icon="info"))  
                   Try(tmpSet <- OpenAFile())
                   Try(fourthSet <- new("ExpressionSet", exprs=as.matrix(tmpSet), phenoData=tmp1.pd, annotation=""))

                   if(identical(featureNames(NormalizedAffyData),featureNames(secondSet)) 
                      & identical(featureNames(NormalizedAffyData),featureNames(thirdSet)) 
                      & identical(featureNames(NormalizedAffyData),featureNames(fourthSet))){
                         Try(merged <- mergeExprs(NormalizedAffyData, secondSet, thirdSet, fourthSet))
                         Try(assign("metaData.Available",TRUE,affylmGUIenvironment))
                         Try(assign("metaData",merged,affylmGUIenvironment))
                         Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
                         Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Available 3 sets",font=.affylmGUIglobals$affylmGUIfontTree))
                   } else {
                         Try(tkmessageBox(title="Meta analysis",message="Data sets do not share the same identifiers!",type="ok",icon="error"))
				    	           Try(tkfocus(.affylmGUIglobals$ttMain))
                         Try(return())
    
                  }
              }

         }
}
################################################################################

metaArrayIC <- function(){
         require(metaArray) || stop("library metaArray could not be found !")
         require(MergeMaid) || stop("\nMissing MergeMaid package\n")

         SaveICTable <- function()
	       {
		                Try(FileName <- tclvalue(tkgetSaveFile(initialfile="IC.table.xls",filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
		                Try(if(!nchar(FileName))
			     	              return())
		                Try(write.table(merged.cor$pair.cor,file=FileName,quote=FALSE,col.names=NA,sep="\t"))
         }

         #error if no data are loaded
         Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
         if(whichArrayPlatform ==""){
              Try(tkmessageBox(title="Meta analysis",message="No arrays have been loaded.	Please try New or Open from the File menu.",type="ok",icon="error"))
				    	Try(tkfocus(.affylmGUIglobals$ttMain))
              Try(return())
         }
         Try(metaData.Available <- get("metaData.Available",envir=affylmGUIenvironment))    
         if(metaData.Available){
                Try(metaData <- get("metaData",envir=affylmGUIenvironment))
                #Try(merged.cor <- intcor(metaData))
                Try(merged.cor <- intCor(metaData))
                Try(mycor <- pairwise.cors(merged.cor))
                if(dim(mycor)[2]==1){
                    Try(hist(mycor[,1], main="Average IC"))
                    Try(SaveICTable())
                } else if (dim(mycor)[2]==2){
                    par(mfrow=c(1,2))
                    Try(hist(mycor[,1], main="Average IC"))
                    Try(hist(mycor[,2], main="Average IC"))
                    Try(SaveICTable())
                } else if (dim(mycor$pair.cor)[2]==3){
                    par(mfrow=c(1,3))
                    Try(hist(mycor[,1], main="Average IC"))
                    Try(hist(mycor[,2], main="Average IC"))
                    Try(hist(mycor[,3], main="Average IC"))
                    Try(SaveICTable())
                }
                  
                    
         } else{
             Try(tkmessageBox(title="Meta analysis",message="No meta data were prepared!\nPlease try Merge function from the Biological interpretation menu.",type="ok",icon="error"))
             Try(tkfocus(.affylmGUIglobals$ttMain))
             Try(return())
         }


}
################################################################################



