#set of functions, directly/indirectly involved, in oneChannelGUI fileMenu
#oneChannelGUI annotation(eSet) restoring the annotation function to retrieve annotatio form expression set slot
#oneChannelGUI targetWidget used for the graphical creation of a target file when .CEL files are available
#oneChannelGUI NewLimmaFile open new projects for affy, exon, gene, large tab delimited data
       #contains: affylmGUI SaveLimmaFile() calling oneChannelGUI SaveAsLimmaFile
       #          affylmGUI SetWD
       #          affylmGUI initGlobals
       #          oneChannelGUI OpenCDFandTargetsfiles
       #          oneChannelGUI whichKindOfArray
       #          oneChannelGUI changeMenu
       #          oneChannelGUI files
       #          oneChannelGUI OpenGeofiles
       #          oneChannelGUI OpenBeadStudioFiles which uses:                
       #                BeadExplorer .readBead modified since the original version has an error
#oneChannelGUI SetED #setting dirs where exon libraries and apt tools are located
       #contains oneChannelGUI chooseEDir
#oneChannelGUI SaveAsLimmaFile save a project with a specific name
       #contains oneChannelGUI OpenALimmaFile defined internally
#oneChannelGUI OpenCDFandTargetsfiles is a modification of the same affylmGUI function  it is used to load .CEL file in an affy project
       #contains: oneChannelGUI OpenTargetsFileAndSetCursor internally defined
       #          oneChannelGUI OpenCDFFileAndSetCursor internally defined
       #          affylmGUI OpenCDFFile
       #          affylmGUI GetlimmaDataSetName
#oneChannelGUI whichKindOfArray this function handles the apt tool dir and exon library files information it is needed to load exon data in an exon project
       #contains: oneChannelGUI .aptDir, written immedialtely after the whichKindOfArray function
       #          oneChannelGUI libraryFilesDir
#oneChannelGUI  .aptDir this is an internal oneChannelGUI function to be used to handle the location of the main APT affymetrix tools dir
#oneChannelGUI libraryFilesDir this function hangles the locationof the exon arrays library files
#oneChannelGUI changeMenu this function modify the affylmGUI menu to oneChannelGUI affy, exon and large menus.
#      #contains: oneChannelGUI OpenALimmaFile function to assign a specific name to the project
#oneChannelGUI OpenLargefiles this function handles the loading of tab delimited files containing array data information
       #contains: oneChannelGUI OpenTargetsFileAndSetCursor internally defined
       #          affylmGUI OpenTargetsFile
       #          oneChannelGUI OpenLargeFile written immediately after the OpenLargefiles          
       #          affylmGUI GetlimmaDataSetName
       #          oneChannelGUI OpenAFile written immediately after the OpenLargeFile
#oneChannelGUI OpenLargeFile calls OpenAFile function
#oneChannelGUI OpenAFile opens the tab delimited file with array data 

#oneChannelGUI OpenGeoFile calls OpenAGeoFile function
#oneChannelGUI OpenAGeoFile opens the tab delimited file GEO siries matrix file
#oneChannelGUI createGeoTarget open an tab delimited file GEO series matrix file and creates a Target file to be used to load that GEO file. 
#oneChannelGUI OpenLimmaFile calls oneChannelGUI OpenALimmaFile
#oneChannelGUI OpenALimmaFile
       #contains affylmGUI SaveLimmaFile
       #         oneChannelGUI OpenALimmaFile defined internally
       #         oneChannelGUI changeMenu see above
#oneChannelGUI showDataset describes the content of the loaded data set       
#oneChannelGUI ExportNormalizedExpressionValues1 this function exports as a tab delimited file normalized gene level expression 
#               data present in the project in exon case also SI/RP/exon/MiDAS data ere exported if available      
       #contains oneChannelGUI NormalizeNow present in the normalizemenu.R  
#oneChannelGUI addAnnLib this function attaches a Bioconductor annotation database name to the large tab delimited data sets loaded in the project
#oneChannelGUI OpenExonandTargetsfiles function to handle exon arrays data by APT of flat files
       #contains: oneChannelGUI OpenTargetsFileAndSetCursor internally defined
       #          affylmGUI OpenTargetsFile 
       #          affylmGUI GetlimmaDataSetName
       #          oneChannelGUI  OpenExonFile  written below the function
       #          oneChannelGUI  OpenExonProbeFile   written below the function
       #          oneChannelGUI OpenAFile   written below the function
################################################################################

".annotation" <- function(eset){return(eset@annotation)}
################################################################################

SetED <- function(){
	ED <- chooseEDir()
	if(!nchar(ED)){
		tkfocus(.affylmGUIglobals$ttMain)
		return("")
	}
	Try(setwd(ED))
	tkfocus(.affylmGUIglobals$ttMain)
	return(ED)
}#end of SetED <- function()
chooseEDir <- function(){
	Try(wd <- tclVar(getwd()))
	Try(
		if(.Platform$OS.type=="windows"){
			Try(tclvalue(wd) <- gsub("/","\\\\",tclvalue(wd)))
		}
	)
	Try(ttChooseDir <- tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.title(ttChooseDir,"Choose APT directory"))
	Try(tkwm.deiconify(ttChooseDir))
	Try(tkgrab.set(ttChooseDir))
	Try(tkgrid(tklabel(ttChooseDir,text="    ")))
	Try(label1 <- tklabel(ttChooseDir,text="Choose directory:",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttChooseDir,text="    "),label1,sticky="w"))
	Try(tkgrid.configure(label1,columnspan=3))
	Try(tkgrid(tklabel(ttChooseDir,text="    ")))
	#
	#
	Try(
		onBrowse <- function(){
			Try(if(file.exists(gsub("\\\\","/",tclvalue(wd)))) initialdir<-gsub("\\\\","/",tclvalue(wd)) else initialdir<-getwd())
			Try(dir1 <- tclvalue(tkchooseDirectory(title="Please choose a working directory for the Limma Analysis",initialdir=initialdir)))
			Try(if(nchar(dir1)>0) tclvalue(wd) <- dir1)
			Try(
				if(.Platform$OS.type=="windows"){
					Try(tclvalue(wd) <- gsub("/","\\\\",tclvalue(wd)))
				}
			)
		} #end of onBrowse <- function()
	)# end of Try
	#
	#
	Try(ReturnVal <- "")
	#
	#
	Try(
		onOK <- function(){
			Try(DirChosen <- tclvalue(wd))
			Try(tkgrab.release(ttChooseDir))
			Try(tkdestroy(ttChooseDir))
			Try(DirChosen <- gsub("\\\\","/",DirChosen))
			Try(ReturnVal <<- DirChosen)
		} #end of onOK <- function()
	)
	#
	#
	Try(
		onCancel <- function(){
			Try(tkgrab.release(ttChooseDir));
			Try(tkdestroy(ttChooseDir))
		} #end of onCancel <- function()
	) #end of try
	#
	#
	Try(Browse.but <- tkbutton(ttChooseDir,text="Browse",command=onBrowse,font=.affylmGUIglobals$affylmGUIfont2))
	Try(OK.but <- tkbutton(ttChooseDir,text="    OK		",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <- tkbutton(ttChooseDir,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	#
	Try(entry1 <- tkentry(ttChooseDir,textvariable=wd,width=40,font=.affylmGUIglobals$affylmGUIfont2))
	#
	Try(tkgrid(tklabel(ttChooseDir,text="    "),entry1))
	Try(tkgrid.configure(entry1,columnspan=3))
	Try(tkgrid(tklabel(ttChooseDir,text="    "),row=3,column=4))
	Try(tkgrid(Browse.but,row=3,column=5))
	Try(tkgrid(tklabel(ttChooseDir,text="    "),row=3,column=6))
	Try(tkgrid(tklabel(ttChooseDir,text="    ")))
	Try(tkgrid(tklabel(ttChooseDir,text="    "),tklabel(ttChooseDir,text="    "),OK.but,Cancel.but))
	Try(tkgrid.configure(Cancel.but,sticky="w"))
	Try(tkgrid(tklabel(ttChooseDir,text="    ")))
	#
	Try(tkfocus(entry1))
	Try(tkbind(ttChooseDir,"<Destroy>",function()tkgrab.release(ttChooseDir)))
	Try(tkbind(entry1,"<Return>",onOK))
	Try(tkwait.window(ttChooseDir))
	#
	return(ReturnVal)
}#end of chooseEDir <- function()


##########################################################################
"targetWidget" <- function () {
    require(tkWidgets) || stop("library tkWidgets could not be found !")
    Try(widgetfiles <- fileBrowser(textToShow = "Choose CEL files", 
                         testFun = hasSuffix("[cC][eE][lL]")))
    Try(celfile.path <- getwd())
    Try(if (length(widgetfiles) == 0) 
        stop("No cel filennames specified") else{

        sampleNames <- sub("^/?([^/]*/)*", "", widgetfiles, extended = TRUE)
        myNames <- paste(rep("n", length(sampleNames)),seq(1, length(sampleNames)), sep="")
        pd <- read.phenoData(sampleNames = sampleNames, widget = TRUE)
        pd <- as.data.frame(pData(pd))
        pd <- cbind(rownames(pd), pd)
        
        if(dim(pd)[2]>2){
                targets <- pd[, 2:dim(pd)[2]]
                targets <- apply(targets,1,function(x)paste(x,collapse="_"))
                pd <- as.data.frame(cbind(myNames, rownames(pd), as.character(targets))) 
        } else{
                pd <-as.data.frame(cbind(myNames, pd))
        }
        names(pd) <- c("Name", "FileName", "Target")
        write.table(pd, "target.txt", sep="\t", row.names=F)
        
    })
    Try(tkmessageBox(title="Make an Affy Target file",message=paste("Target file is available in your working directory")))  

 
}

##########################################################################

NewLimmaFile <- function(){
	####################################################
	Try(ttGetArray <- tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttGetArray))
	Try(tkgrab.set(ttGetArray))
	Try(tkfocus(ttGetArray))
	Try(tkwm.title(ttGetArray,"Selecting the Array platform"))
	#
	Try(tkgrid(tklabel(ttGetArray,text="    ")))
	Try(ArrayTcl <- tclVar("AFFY"))
	Try(rbAFFY <- tkradiobutton(ttGetArray,text="Affy CEL files: 3 IVT",variable=ArrayTcl,value="AFFY",font=.affylmGUIglobals$affylmGUIfont2))
	Try(rbEXON <- tkradiobutton(ttGetArray,text="EXON 1.0 ST ARRAYS: probe sets summary from Affymetrix \nExpression Console/APT",variable=ArrayTcl,value="EXON",font=.affylmGUIglobals$affylmGUIfont2))
	Try(rbGENE <- tkradiobutton(ttGetArray,text="GENE 1.0 ST ARRAYS: probe sets summary from Affymetrix APT",variable=ArrayTcl,value="GENE",font=.affylmGUIglobals$affylmGUIfont2))
	Try(rbLARGE<-tkradiobutton(ttGetArray,text="Large normalized tab delimited data set: any single channel platform",variable=ArrayTcl,value="LARGE",font=.affylmGUIglobals$affylmGUIfont2))
	Try(rbILLU<-tkradiobutton(ttGetArray,text="ILLUMINA: loading data generated by BeadStudio software v1/2/3",variable=ArrayTcl,value="ILLU",font=.affylmGUIglobals$affylmGUIfont2))
	Try(rbGEO<-tkradiobutton(ttGetArray,text="GEO Series Matrix file",variable=ArrayTcl,value="GEO",font=.affylmGUIglobals$affylmGUIfont2))
#	Try(rbAB <- tkradiobutton(ttGetArray,text="AB1700",variable=ArrayTcl,value="AB",font=.affylmGUIglobals$affylmGUIfont2))
	
  Try(tkgrid(tklabel(ttGetArray,text="    "),rbAFFY))
	Try(tkgrid(tklabel(ttGetArray,text="    "),rbEXON))
  Try(tkgrid(tklabel(ttGetArray,text="    "),rbGENE))
  Try(tkgrid(tklabel(ttGetArray,text="    "),rbLARGE))
  Try(tkgrid(tklabel(ttGetArray,text="    "),rbILLU))
	Try(tkgrid(tklabel(ttGetArray,text="    "),rbGEO))
	Try(tkgrid.configure(rbAFFY,rbEXON,rbGENE,rbLARGE,rbILLU,rbGEO,columnspan=2,sticky="w"))
	Try(tkgrid(tklabel(ttGetArray,text="    "),tklabel(ttGetArray,text="    ")))
	#
	Try(ReturnVal <- "")
	Try(
		onCancel <- function() {
			Try(ReturnVal <<- "");
			Try(tkgrab.release(ttGetArray));
			Try(tkdestroy(ttGetArray));
			Try(tkfocus(.affylmGUIglobals$ttMain))
			Try(return())
		}
	)
	Try(
		onOK <- function() {
			Try(ReturnVal <<- tclvalue(ArrayTcl));
			Try(tkgrab.release(ttGetArray));
			Try(tkdestroy(ttGetArray));
			Try(tkfocus(.affylmGUIglobals$ttMain))
		}
	)
	#
	Try(OK.but     <- tkbutton(ttGetArray,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <- tkbutton(ttGetArray,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	#
	Try(tkgrid(tklabel(ttGetArray,text="    "),OK.but,Cancel.but,tklabel(ttGetArray,text="    ")))
	Try(tkgrid.configure(OK.but,sticky="e"))
	Try(tkgrid.configure(Cancel.but,sticky="w"))
	Try(tkgrid(tklabel(ttGetArray,text="    ")))
	#
	Try(tkbind(ttGetArray,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetArray));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkbind(OK.but, "<Return>",onOK))
	Try(tkbind(Cancel.but, "<Return>",onCancel))
	#
	Try(tkwait.window(ttGetArray))
#selecting the array type
  Try(
    if(ReturnVal=="AFFY"){
      Try(assign("whichArrayPlatform","AFFY",affylmGUIenvironment))
##############initialization variables start
                        Try(tt <- "")
                        Try(assign("illuData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("illuData",tt,affylmGUIenvironment))

                        Try(assign("RawAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("NormalizedAffyData.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("unfilteredData.location", tt, affylmGUIenvironment))
                        Try(assign("geoPlatform",  tt, env=affylmGUIenvironment))

                        Try(assign("metaData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("metaData",tt,affylmGUIenvironment))

                        Try(assign("exprConsoleLibs.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exprConsoleLibs", tt ,affylmGUIenvironment))#locate here the library files as a list of data.frames

                        assign("libDir.Available",FALSE,affylmGUIenvironment)
                        assign("libDir", tt ,affylmGUIenvironment)#locate here the library files as a list of data.frames
                        assign("whichLib", tt ,affylmGUIenvironment)#remember the type of exon library loaded
                        
                        Try(assign("exonAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exonAffyData", tt ,affylmGUIenvironment))
                        Try(assign("dabg.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("dabg.p" , tt, affylmGUIenvironment))    
                        Try(assign("midas.p" , tt, affylmGUIenvironment))
                        Try(assign("midas.p.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("spliceIndexData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("spliceIndexData", tt ,affylmGUIenvironment))
                        Try(assign("AltSplRP.e.p" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.e.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("AltSplRP.g" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.g.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("detected.splicing" , tt, affylmGUIenvironment))
                        Try(assign("detected.splicing.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("LinearModelFitExon.Available",FALSE,affylmGUIenvironment))
                        Try(assign("cosie.Available", FALSE ,affylmGUIenvironment))
                        Try(assign("fitExon",tt,affylmGUIenvironment))
                        Try(assign("LinearModelFitExon.Available",FALSE,affylmGUIenvironment))
                        Try(assign("AltSplLimma" , tt, affylmGUIenvironment))
                        Try(assign("AltSplLimma.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("intronicBg.available", TRUE,affylmGUIenvironment))
                        Try(assign("intronicBg", tt,affylmGUIenvironment))

                        Try(assign("maSigProSigs.Available",FALSE,affylmGUIenvironment))

                        Try(assign("Pset.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("MLdesign.Available",FALSE,affylmGUIenvironment))
                        Try(assign("MLdesign", tt ,affylmGUIenvironment))
                        Try(assign("trainAffyData.available", FALSE, env=affylmGUIenvironment))
                        Try(assign("testAffyData.available", FALSE, env=affylmGUIenvironment))
##############initialization variables end

      Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
    	Try(NumParameters <- get("NumParameters",envir=affylmGUIenvironment))
	    Try(NumContrastParameterizations <- get("NumContrastParameterizations",envir=affylmGUIenvironment))
	    Try(ContrastParameterizationList <- get("ContrastParameterizationList",envir=affylmGUIenvironment))
	    Try(ContrastParameterizationTREEIndexVec <- get("ContrastParameterizationTREEIndexVec",envir=affylmGUIenvironment))
	    Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	    if(limmaDataSetNameText!="Untitled"){
		    Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled"){LimmaFileName <- limmaDataSetNameText} )	# Local assignment only
		    Try(mbVal <- tkmessageBox(title="Start New Analysis",
				    											message=paste("Save changes to ",fixSeps(LimmaFileName),"?",sep=""),
						    									icon="question",type="yesnocancel",default="yes"
								    						 )#end of tkmessageBox
		    )#end of Try(mbVal..
		    if(tclvalue(mbVal)=="yes"){Try(SaveLimmaFile())}
		    if(tclvalue(mbVal)=="cancel"){
			    Try(tkfocus(.affylmGUIglobals$ttMain))
			    return()
		    }#end of if(tclvalue(mbVal)=="cancel")
		    Try(limmaDataSetNameText <- "Untitled")
	    }#end of if(limmaDataSetNameText!="Untitled")
	    #Try(tkmessageBox(title="Working Directory",message="After clicking OK, please select a working directory.",type="ok"))
	    Try(WD <- SetWD())
	    if(WD=="") return()
	    Try(tkdelete(.affylmGUIglobals$mainTree,"RawAffyData.Status"))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFit.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFit","LinearModelFit.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(tkdelete(.affylmGUIglobals$mainTree,"maSIgProData.Status"))
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","maSIgProData","maSIgProData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"PLM.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","PLM","PLM.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptDabg.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptMidas.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptMidas","AptMidas.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"spliceIndex.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","spliceIndex","spliceIndex.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.e.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.e.Status" ,text="Not Available at exon level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.g.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.g.Status" ,text="Not Available at gene level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"classification.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","classification","classification.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
     	Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFitExon.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFitExon","LinearModelFitExon.Status",text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))


	    Try(
		    if(NumContrastParameterizations>0){
			    Try(for (i in (1:NumContrastParameterizations))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("ContrastParameterizations.Status.",i,sep="")))
			    )
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"ContrastParameterizations.Status.1"))
		    }
	    )
	    Try(
		    tkinsert(.affylmGUIglobals$mainTree,"end","ContrastParameterizations","ContrastParameterizations.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree)
	    )#end of Try
	    Try(
		    if(NumParameters>0){
			    Try(for (i in (1:NumParameters))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("Parameters.Status.",i,sep="")))
			    )#end of Try-for..
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"Parameters.Status.1"))
		    }
	    )#end of Try-if...
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters","Parameters.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree))
	    if(NumContrastParameterizations>0){
		    for (contrastParameterizationIndex in (1:NumContrastParameterizations)){
			    Try(.affylmGUIglobals$ContrastParameterizationTREEIndex <- ContrastParameterizationTREEIndexVec[contrastParameterizationIndex])
			    Try(ParameterizationNameNode <- paste("ContrastParameterizationName.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			    Try(tkdelete(.affylmGUIglobals$ContrastParameterizationTREE,ParameterizationNameNode))
			    Try(assign("ContrastParameterizationList", deleteItemFromList(ContrastParameterizationList,ParameterizationNameNode),affylmGUIenvironment))
		    }#end of for
	    }#end of if
	    Try(initGlobals())
	    Try(LimmaFileName <- get("LimmaFileName",affylmGUIenvironment))
      Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled") LimmaFileName <- limmaDataSetNameText) # Local assignment only
      Try(if(.Platform$OS.type=="windows")
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",gsub("/","\\\\",LimmaFileName))))
	             else
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",LimmaFileName)))
      )#end of Try
	    Try(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)		 <- "Please select a Chip Definition (CDF) file.")
	    Try(tclvalue(.affylmGUIglobals$CDFfileName)				 <- "No filename is selected at the moment.	Press the Select CDF File Button.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle) <- "Please select a tab-delimited file listing the CEL files.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileName)		 <- "No filename is selected at the moment.	Press the Select Targets File Button.")
	    Try(OpenCDFandTargetsfiles())
	    Try(tkfocus(.affylmGUIglobals$ttMain))
      })
       #as default the oneChannel Menu reffer to that used for 3'IVT affymrtrix arrays
       Try(if(ReturnVal=="ILLU"){
           Try(assign("whichArrayPlatform","ILLU",affylmGUIenvironment))
##############initialization variables start
                        Try(tt <- "")
                        Try(assign("illuData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("illuData",tt,affylmGUIenvironment))
                        
                        Try(assign("RawAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("NormalizedAffyData.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("unfilteredData.location", tt, affylmGUIenvironment))
                        Try(assign("geoPlatform",  tt, env=affylmGUIenvironment))

                        Try(assign("metaData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("metaData",tt,affylmGUIenvironment))

                        Try(assign("exprConsoleLibs.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exprConsoleLibs", tt ,affylmGUIenvironment))#locate here the library files as a list of data.frames

                        assign("libDir.Available",FALSE,affylmGUIenvironment)
                        assign("libDir", tt ,affylmGUIenvironment)#locate here the library files as a list of data.frames
                        assign("whichLib", tt ,affylmGUIenvironment)#remember the type of exon library loaded
                        
                        Try(assign("exonAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exonAffyData", tt ,affylmGUIenvironment))
                        Try(assign("dabg.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("dabg.p" , tt, affylmGUIenvironment))    
                        Try(assign("midas.p" , tt, affylmGUIenvironment))
                        Try(assign("midas.p.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("spliceIndexData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("spliceIndexData", tt ,affylmGUIenvironment))
                        Try(assign("AltSplRP.e.p" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.e.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("AltSplRP.g" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.g.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("detected.splicing" , tt, affylmGUIenvironment))
                        Try(assign("detected.splicing.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("LinearModelFitExon.Available",FALSE,affylmGUIenvironment))
                        Try(assign("cosie.Available", FALSE ,affylmGUIenvironment))
                        Try(assign("fitExon",tt,affylmGUIenvironment))
                        Try(assign("LinearModelFitExon.Available",FALSE,affylmGUIenvironment))
                        Try(assign("AltSplLimma" , tt, affylmGUIenvironment))
                        Try(assign("AltSplLimma.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("intronicBg.available", TRUE,affylmGUIenvironment))
                        Try(assign("intronicBg", tt,affylmGUIenvironment))

                        Try(assign("maSigProSigs.Available",FALSE,affylmGUIenvironment))

                        Try(assign("Pset.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("MLdesign.Available",FALSE,affylmGUIenvironment))
                        Try(assign("MLdesign", tt ,affylmGUIenvironment))
                        Try(assign("trainAffyData.available", FALSE, env=affylmGUIenvironment))
                        Try(assign("testAffyData.available", FALSE, env=affylmGUIenvironment))
##############initialization variables end
 #         Try(whichKindOfArray())
          #define the right Menu depending on the platform
          Try(changeMenu())#modify the default manu in aplatform specific menu
           #Try(tkmessageBox(title="Selecting the Array Platform",message="Only tab delimited files, with array names in header and 1st column with probe set ids", type="ok", icon="info"))  
           Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
    	     Try(NumParameters <- get("NumParameters",envir=affylmGUIenvironment))
	         Try(NumContrastParameterizations <- get("NumContrastParameterizations",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationList <- get("ContrastParameterizationList",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationTREEIndexVec <- get("ContrastParameterizationTREEIndexVec",envir=affylmGUIenvironment))
	         Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	         if(limmaDataSetNameText!="Untitled"){
		         Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled"){LimmaFileName <- limmaDataSetNameText} )	# Local assignment only
		         Try(mbVal <- tkmessageBox(title="Start New Analysis",
				         											message=paste("Save changes to ",fixSeps(LimmaFileName),"?",sep=""),
						         									icon="question",type="yesnocancel",default="yes"
								         						 )#end of tkmessageBox
		         )#end of Try(mbVal..
		         if(tclvalue(mbVal)=="yes"){Try(SaveLimmaFile())}
		         if(tclvalue(mbVal)=="cancel"){
			         Try(tkfocus(.affylmGUIglobals$ttMain))
			         return()
		         }#end of if(tclvalue(mbVal)=="cancel")
		         Try(limmaDataSetNameText <- "Untitled")
	         }#end of if(limmaDataSetNameText!="Untitled")
	         #Try(tkmessageBox(title="Working Directory",message="After clicking OK, please select a working directory.",type="ok"))
	         Try(WD <- SetWD())
	         if(WD=="") return()
	    Try(tkdelete(.affylmGUIglobals$mainTree,"RawAffyData.Status"))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFit.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFit","LinearModelFit.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(tkdelete(.affylmGUIglobals$mainTree,"maSIgProData.Status"))
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","maSIgProData","maSIgProData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"PLM.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","PLM","PLM.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptDabg.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptMidas.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptMidas","AptMidas.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"spliceIndex.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","spliceIndex","spliceIndex.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.e.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.e.Status" ,text="Not Available at exon level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.g.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.g.Status" ,text="Not Available at gene level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"classification.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","classification","classification.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFitExon.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFitExon","LinearModelFitExon.Status",text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(
		    if(NumContrastParameterizations>0){
			    Try(for (i in (1:NumContrastParameterizations))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("ContrastParameterizations.Status.",i,sep="")))
			    )
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"ContrastParameterizations.Status.1"))
		    }
	    )
	    Try(
		    tkinsert(.affylmGUIglobals$mainTree,"end","ContrastParameterizations","ContrastParameterizations.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree)
	    )#end of Try
	    Try(
		    if(NumParameters>0){
			    Try(for (i in (1:NumParameters))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("Parameters.Status.",i,sep="")))
			    )#end of Try-for..
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"Parameters.Status.1"))
		    }
	    )#end of Try-if...
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters","Parameters.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree))
	    if(NumContrastParameterizations>0){
		    for (contrastParameterizationIndex in (1:NumContrastParameterizations)){
			    Try(.affylmGUIglobals$ContrastParameterizationTREEIndex <- ContrastParameterizationTREEIndexVec[contrastParameterizationIndex])
			    Try(ParameterizationNameNode <- paste("ContrastParameterizationName.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			    Try(tkdelete(.affylmGUIglobals$ContrastParameterizationTREE,ParameterizationNameNode))
			    Try(assign("ContrastParameterizationList", deleteItemFromList(ContrastParameterizationList,ParameterizationNameNode),affylmGUIenvironment))
		    }#end of for
	    }#end of if
	    Try(initGlobals())
	    Try(LimmaFileName <- get("LimmaFileName",affylmGUIenvironment))
      Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled") LimmaFileName <- limmaDataSetNameText) # Local assignment only
      Try(if(.Platform$OS.type=="windows")
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",gsub("/","\\\\",LimmaFileName))))
	             else
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",LimmaFileName)))
      )#end of Try
#	    Try(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)		 <- "Please select a Chip Definition (CDF) file.")
#	    Try(tclvalue(.affylmGUIglobals$CDFfileName)				 <- "No filename is selected at the moment.	Press the Select CDF File Button.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle) <- "Please select a tab-delimited file listing the CEL files.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileName)		 <- "No filename is selected at the moment.	Press the Select Targets File Button.")
      Try(OpenBeadStudioFiles())#function to read beadarrays produced from beadstudio 1/2 wrapping .readBead
	    Try(tkfocus(.affylmGUIglobals$ttMain))
       })
#       Try(if(ReturnVal=="AB"){
#           Try(tkmessageBox(title="Selecting the Array Platform",message="AB1700 Not yet implemented", type="ok", icon="info"))  
#           Try(assign("whichArrayPlatform","AB",affylmGUIenvironment))
#           Try(changeMenu())#modify the default manu in aplatform specific menu
#       })
        Try(if(ReturnVal=="EXON"){
          Try(assign("whichArrayPlatform","EXON",affylmGUIenvironment))
##############initialization variables start
                        Try(tt <- "")
                        Try(assign("illuData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("illuData",tt,affylmGUIenvironment))

                        Try(assign("RawAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("NormalizedAffyData.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("unfilteredData.location", tt, affylmGUIenvironment))
                        Try(assign("geoPlatform",  tt, env=affylmGUIenvironment))

                        Try(assign("metaData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("metaData",tt,affylmGUIenvironment))

                        Try(assign("exprConsoleLibs.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exprConsoleLibs", tt ,affylmGUIenvironment))#locate here the library files as a list of data.frames

                        #gathering affy libs and apt tools folders
                        Try(localdata  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/localData.txt", sep=""))
                        Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                        Try(libDirLocation <- myinfo[which(myinfo[,1]=="libDirLocation"),2])
                        Try(if(is.na(libDirLocation)) libDirLocation <- tt)
                        if(libDirLocation != ""){
                          assign("libDirLocation", libDirLocation, affylmGUIenvironment)#directory where affy library files are located
                        } else{  
                                Try(geneExonLibs())
                                Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                                Try(libDirLocation <- myinfo[which(myinfo[,1]=="libDirLocation"),2])
                                Try(assign("libDirLocation", libDirLocation, affylmGUIenvironment))#directory where affy library files are located
                        }
                        
                        assign("libDir.Available",FALSE,affylmGUIenvironment)
                        assign("libDir", tt ,affylmGUIenvironment)#locate here the library files as a list of data.frames
                        assign("whichLib", tt ,affylmGUIenvironment)#remember the type of exon library loaded
                        Try(aptDir <- myinfo[which(myinfo[,1]=="aptDir"),2])
                        Try(if(is.na(aptDir)) aptDir <- tt)
                        if(aptDir != ""){
                          assign("aptDir.Available",TRUE,affylmGUIenvironment)
                          assign("aptDir", aptDir ,affylmGUIenvironment)
                        } else{  
                                assign("aptDir.Available",FALSE,affylmGUIenvironment)
                                Try(aptFolder())
                                Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                                Try(aptDir <- myinfo[which(myinfo[,1]=="aptDir"),2])
                                assign("aptDir.Available",TRUE,affylmGUIenvironment)
                                assign("aptDir", aptDir ,affylmGUIenvironment)
                        }
                        
                        Try(assign("exonAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exonAffyData", tt ,affylmGUIenvironment))
                        Try(assign("dabg.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("dabg.p" , tt, affylmGUIenvironment))    
                        Try(assign("midas.p" , tt, affylmGUIenvironment))
                        Try(assign("midas.p.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("spliceIndexData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("spliceIndexData", tt ,affylmGUIenvironment))
                        Try(assign("AltSplRP.e.p" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.e.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("AltSplRP.g" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.g.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("LinearModelFitExon.Available",FALSE,affylmGUIenvironment))
	                      Try(assign("cosie.Available", FALSE ,affylmGUIenvironment))
                        Try(assign("fitExon",tt,affylmGUIenvironment))
                        Try(assign("AltSplLimma" , tt, affylmGUIenvironment))
                        Try(assign("AltSplLimma.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("intronicBg.available", TRUE,affylmGUIenvironment))
                        Try(assign("intronicBg", tt,affylmGUIenvironment))

                        Try(assign("maSigProSigs.Available",FALSE,affylmGUIenvironment))

                        Try(assign("Pset.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("MLdesign.Available",FALSE,affylmGUIenvironment))
                        Try(assign("MLdesign", tt ,affylmGUIenvironment))
                        Try(assign("trainAffyData.available", FALSE, env=affylmGUIenvironment))
                        Try(assign("testAffyData.available", FALSE, env=affylmGUIenvironment))
##############initialization variables end

          Try(whichKindOfArray())
#          if (affylmGUIenvironment$aptDir.Available & affylmGUIenvironment$exprConsoleLibs.Available){
           if (affylmGUIenvironment$exprConsoleLibs.Available){
          #define the right Menu depending on the platform
           Try(changeMenu())#modify the default manu in aplatform specific menu
          
           Try(tkmessageBox(title="Selecting the Array Platform",message="If Affymetrix APT tools are installed, \ngene/exon probe sets summaries can be calculated starting from .CEL, \nelse only tab delimted files exported from  Expression Console are supported.", type="ok", icon="info"))  
           Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
    	     Try(NumParameters <- get("NumParameters",envir=affylmGUIenvironment))
	         Try(NumContrastParameterizations <- get("NumContrastParameterizations",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationList <- get("ContrastParameterizationList",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationTREEIndexVec <- get("ContrastParameterizationTREEIndexVec",envir=affylmGUIenvironment))
	         Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	         if(limmaDataSetNameText!="Untitled"){
		         Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled"){LimmaFileName <- limmaDataSetNameText} )	# Local assignment only
		         Try(mbVal <- tkmessageBox(title="Start New Analysis",
				         											message=paste("Save changes to ",fixSeps(LimmaFileName),"?",sep=""),
						         									icon="question",type="yesnocancel",default="yes"
								         						 )#end of tkmessageBox
		         )#end of Try(mbVal..
		         if(tclvalue(mbVal)=="yes"){Try(SaveLimmaFile())}
		         if(tclvalue(mbVal)=="cancel"){
			         Try(tkfocus(.affylmGUIglobals$ttMain))
			         return()
		         }#end of if(tclvalue(mbVal)=="cancel")
		         Try(limmaDataSetNameText <- "Untitled")
	         }#end of if(limmaDataSetNameText!="Untitled")
	         #Try(tkmessageBox(title="Working Directory",message="After clicking OK, please select a working directory.",type="ok"))
	         Try(WD <- SetWD())
	         if(WD=="") return()
	    Try(tkdelete(.affylmGUIglobals$mainTree,"RawAffyData.Status"))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFit.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFit","LinearModelFit.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(tkdelete(.affylmGUIglobals$mainTree,"maSIgProData.Status"))
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","maSIgProData","maSIgProData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"PLM.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","PLM","PLM.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptDabg.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptMidas.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptMidas","AptMidas.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"spliceIndex.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","spliceIndex","spliceIndex.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.e.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.e.Status" ,text="Not Available at exon level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.g.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.g.Status" ,text="Not Available at gene level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"classification.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","classification","classification.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
     	Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFitExon.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFitExon","LinearModelFitExon.Status",text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(
		    if(NumContrastParameterizations>0){
			    Try(for (i in (1:NumContrastParameterizations))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("ContrastParameterizations.Status.",i,sep="")))
			    )
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"ContrastParameterizations.Status.1"))
		    }
	    )
	    Try(
		    tkinsert(.affylmGUIglobals$mainTree,"end","ContrastParameterizations","ContrastParameterizations.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree)
	    )#end of Try
	    Try(
		    if(NumParameters>0){
			    Try(for (i in (1:NumParameters))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("Parameters.Status.",i,sep="")))
			    )#end of Try-for..
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"Parameters.Status.1"))
		    }
	    )#end of Try-if...
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters","Parameters.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree))
	    if(NumContrastParameterizations>0){
		    for (contrastParameterizationIndex in (1:NumContrastParameterizations)){
			    Try(.affylmGUIglobals$ContrastParameterizationTREEIndex <- ContrastParameterizationTREEIndexVec[contrastParameterizationIndex])
			    Try(ParameterizationNameNode <- paste("ContrastParameterizationName.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			    Try(tkdelete(.affylmGUIglobals$ContrastParameterizationTREE,ParameterizationNameNode))
			    Try(assign("ContrastParameterizationList", deleteItemFromList(ContrastParameterizationList,ParameterizationNameNode),affylmGUIenvironment))
		    }#end of for
	    }#end of if
	    Try(initGlobals())
	    Try(LimmaFileName <- get("LimmaFileName",affylmGUIenvironment))
      Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled") LimmaFileName <- limmaDataSetNameText) # Local assignment only
      Try(if(.Platform$OS.type=="windows")
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",gsub("/","\\\\",LimmaFileName))))
	             else
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",LimmaFileName)))
      )#end of Try
#	    Try(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)		 <- "Please select a Chip Definition (CDF) file.")
#	    Try(tclvalue(.affylmGUIglobals$CDFfileName)				 <- "No filename is selected at the moment.	Press the Select CDF File Button.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle) <- "Please select a tab-delimited file listing the CEL files.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileName)		 <- "No filename is selected at the moment.	Press the Select Targets File Button.")
	    Try(OpenExonandTargetsfiles())
	    Try(tkfocus(.affylmGUIglobals$ttMain))
  }  else {return()}# some parameters were missed therefore gene/exon data cannot be loaded  
       
       })

##########################################################################
        Try(if(ReturnVal=="GENE"){
          Try(assign("whichArrayPlatform","GENE",affylmGUIenvironment))
##############initialization variables start
                        Try(tt <- "")
                        Try(assign("illuData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("illuData",tt,affylmGUIenvironment))

                        Try(assign("RawAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("NormalizedAffyData.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("unfilteredData.location", tt, affylmGUIenvironment))
                        Try(assign("geoPlatform",  tt, env=affylmGUIenvironment))

                        Try(assign("metaData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("metaData",tt,affylmGUIenvironment))

                        Try(assign("exprConsoleLibs.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exprConsoleLibs", tt ,affylmGUIenvironment))#locate here the library files as a list of data.frames

                        #gathering affy libs and apt tools folders
                        Try(localdata  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/localData.txt", sep=""))
                        Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                        Try(libDirLocation <- myinfo[which(myinfo[,1]=="libDirLocation"),2])
                        Try(if(is.na(libDirLocation)) libDirLocation <- tt)
                        if(libDirLocation != ""){
                          assign("libDirLocation", libDirLocation, affylmGUIenvironment)#directory where affy library files are located
                        } else{  
                                Try(geneExonLibs())
                                Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                                Try(libDirLocation <- myinfo[which(myinfo[,1]=="libDirLocation"),2])
                                Try(assign("libDirLocation", libDirLocation, affylmGUIenvironment))#directory where affy library files are located
                        }
                        
                        assign("libDir.Available",FALSE,affylmGUIenvironment)
                        assign("libDir", tt ,affylmGUIenvironment)#locate here the library files as a list of data.frames
                        assign("whichLib", tt ,affylmGUIenvironment)#remember the type of exon library loaded
                        Try(aptDir <- myinfo[which(myinfo[,1]=="aptDir"),2])
                        Try(if(is.na(aptDir)) aptDir <- tt)
                        if(aptDir != ""){
                          assign("aptDir.Available",TRUE,affylmGUIenvironment)
                          assign("aptDir", aptDir ,affylmGUIenvironment)
                        } else{  
                                assign("aptDir.Available",FALSE,affylmGUIenvironment)
                                Try(aptFolder())
                                Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                                Try(aptDir <- myinfo[which(myinfo[,1]=="aptDir"),2])
                                assign("aptDir.Available",TRUE,affylmGUIenvironment)
                                assign("aptDir", aptDir ,affylmGUIenvironment)
                        }
                        
                        Try(assign("exonAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exonAffyData", tt ,affylmGUIenvironment))
                        Try(assign("dabg.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("dabg.p" , tt, affylmGUIenvironment))    
                        Try(assign("midas.p" , tt, affylmGUIenvironment))
                        Try(assign("midas.p.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("spliceIndexData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("spliceIndexData", tt ,affylmGUIenvironment))
                        Try(assign("AltSplRP.e.p" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.e.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("AltSplRP.g" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.g.Available" , FALSE, affylmGUIenvironment))
                        
                       	Try(assign("LinearModelFitExon.Available",FALSE,affylmGUIenvironment))
	                      Try(assign("cosie.Available", FALSE ,affylmGUIenvironment))
                        Try(assign("fitExon",tt,affylmGUIenvironment))
                        Try(assign("AltSplLimma" , tt, affylmGUIenvironment))
                        Try(assign("AltSplLimma.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("intronicBg.available", TRUE,affylmGUIenvironment))
                        Try(assign("intronicBg", tt,affylmGUIenvironment))

                        Try(assign("maSigProSigs.Available",FALSE,affylmGUIenvironment))

                        Try(assign("Pset.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("MLdesign.Available",FALSE,affylmGUIenvironment))
                        Try(assign("MLdesign", tt ,affylmGUIenvironment))
                        Try(assign("trainAffyData.available", FALSE, env=affylmGUIenvironment))
                        Try(assign("testAffyData.available", FALSE, env=affylmGUIenvironment))
##############initialization variables end

          Try(whichKindOfArray())
#          if (affylmGUIenvironment$aptDir.Available & affylmGUIenvironment$exprConsoleLibs.Available){
           if (affylmGUIenvironment$exprConsoleLibs.Available){
          #define the right Menu depending on the platform
           Try(changeMenu())#modify the default manu in aplatform specific menu
          
           Try(tkmessageBox(title="Selecting the Array Platform",message="If Affymetrix APT tools are installed, \ngene/exon probe sets summaries can be calculated starting from .CEL, \nelse only tab delimted files exported from  Expression Console are supported.", type="ok", icon="info"))  
           Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
    	     Try(NumParameters <- get("NumParameters",envir=affylmGUIenvironment))
	         Try(NumContrastParameterizations <- get("NumContrastParameterizations",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationList <- get("ContrastParameterizationList",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationTREEIndexVec <- get("ContrastParameterizationTREEIndexVec",envir=affylmGUIenvironment))
	         Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	         if(limmaDataSetNameText!="Untitled"){
		         Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled"){LimmaFileName <- limmaDataSetNameText} )	# Local assignment only
		         Try(mbVal <- tkmessageBox(title="Start New Analysis",
				         											message=paste("Save changes to ",fixSeps(LimmaFileName),"?",sep=""),
						         									icon="question",type="yesnocancel",default="yes"
								         						 )#end of tkmessageBox
		         )#end of Try(mbVal..
		         if(tclvalue(mbVal)=="yes"){Try(SaveLimmaFile())}
		         if(tclvalue(mbVal)=="cancel"){
			         Try(tkfocus(.affylmGUIglobals$ttMain))
			         return()
		         }#end of if(tclvalue(mbVal)=="cancel")
		         Try(limmaDataSetNameText <- "Untitled")
	         }#end of if(limmaDataSetNameText!="Untitled")
	         #Try(tkmessageBox(title="Working Directory",message="After clicking OK, please select a working directory.",type="ok"))
	         Try(WD <- SetWD())
	         if(WD=="") return()
	    Try(tkdelete(.affylmGUIglobals$mainTree,"RawAffyData.Status"))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFit.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFit","LinearModelFit.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(tkdelete(.affylmGUIglobals$mainTree,"maSIgProData.Status"))
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","maSIgProData","maSIgProData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"PLM.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","PLM","PLM.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptDabg.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptMidas.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptMidas","AptMidas.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"spliceIndex.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","spliceIndex","spliceIndex.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.e.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.e.Status" ,text="Not Available at exon level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.g.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.g.Status" ,text="Not Available at gene level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"classification.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","classification","classification.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFitExon.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFitExon","LinearModelFitExon.Status",text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
    
	    Try(
		    if(NumContrastParameterizations>0){
			    Try(for (i in (1:NumContrastParameterizations))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("ContrastParameterizations.Status.",i,sep="")))
			    )
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"ContrastParameterizations.Status.1"))
		    }
	    )
	    Try(
		    tkinsert(.affylmGUIglobals$mainTree,"end","ContrastParameterizations","ContrastParameterizations.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree)
	    )#end of Try
	    Try(
		    if(NumParameters>0){
			    Try(for (i in (1:NumParameters))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("Parameters.Status.",i,sep="")))
			    )#end of Try-for..
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"Parameters.Status.1"))
		    }
	    )#end of Try-if...
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters","Parameters.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree))
	    if(NumContrastParameterizations>0){
		    for (contrastParameterizationIndex in (1:NumContrastParameterizations)){
			    Try(.affylmGUIglobals$ContrastParameterizationTREEIndex <- ContrastParameterizationTREEIndexVec[contrastParameterizationIndex])
			    Try(ParameterizationNameNode <- paste("ContrastParameterizationName.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			    Try(tkdelete(.affylmGUIglobals$ContrastParameterizationTREE,ParameterizationNameNode))
			    Try(assign("ContrastParameterizationList", deleteItemFromList(ContrastParameterizationList,ParameterizationNameNode),affylmGUIenvironment))
		    }#end of for
	    }#end of if
	    Try(initGlobals())
	    Try(LimmaFileName <- get("LimmaFileName",affylmGUIenvironment))
      Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled") LimmaFileName <- limmaDataSetNameText) # Local assignment only
      Try(if(.Platform$OS.type=="windows")
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",gsub("/","\\\\",LimmaFileName))))
	             else
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",LimmaFileName)))
      )#end of Try
#	    Try(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)		 <- "Please select a Chip Definition (CDF) file.")
#	    Try(tclvalue(.affylmGUIglobals$CDFfileName)				 <- "No filename is selected at the moment.	Press the Select CDF File Button.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle) <- "Please select a tab-delimited file listing the CEL files.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileName)		 <- "No filename is selected at the moment.	Press the Select Targets File Button.")
	    Try(OpenExonandTargetsfiles())
	    Try(tkfocus(.affylmGUIglobals$ttMain))
  }  else {return()}# some parameters were missed therefore gene/exon data cannot be loaded  
       
       })

##########################################################################
        Try(if(ReturnVal=="LARGE"){
          Try(assign("whichArrayPlatform","LARGE",affylmGUIenvironment))
##############initialization variables start
                        Try(tt <- "")
                        Try(assign("illuData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("illuData",tt,affylmGUIenvironment))

                        Try(assign("RawAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("NormalizedAffyData.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("unfilteredData.location", tt, affylmGUIenvironment))
                        Try(assign("geoPlatform",  tt, env=affylmGUIenvironment))

                        Try(assign("metaData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("metaData",tt,affylmGUIenvironment))

                        Try(assign("exprConsoleLibs.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exprConsoleLibs", tt ,affylmGUIenvironment))#locate here the library files as a list of data.frames

                        assign("libDir.Available",FALSE,affylmGUIenvironment)
                        assign("libDir", tt ,affylmGUIenvironment)#locate here the library files as a list of data.frames
                        assign("whichLib", tt ,affylmGUIenvironment)#remember the type of exon library loaded
                        
                        Try(assign("exonAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exonAffyData", tt ,affylmGUIenvironment))
                        Try(assign("dabg.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("dabg.p" , tt, affylmGUIenvironment))    
                        Try(assign("midas.p" , tt, affylmGUIenvironment))
                        Try(assign("midas.p.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("spliceIndexData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("spliceIndexData", tt ,affylmGUIenvironment))
                        Try(assign("AltSplRP.e.p" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.e.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("AltSplRP.g" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.g.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("LinearModelFitExon.Available",FALSE,affylmGUIenvironment))
	                      Try(assign("cosie.Available", FALSE ,affylmGUIenvironment))
                        Try(assign("fitExon",tt,affylmGUIenvironment))
                        Try(assign("AltSplLimma" , tt, affylmGUIenvironment))
                        Try(assign("AltSplLimma.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("intronicBg.available", TRUE,affylmGUIenvironment))
                        Try(assign("intronicBg", tt,affylmGUIenvironment))

                        Try(assign("maSigProSigs.Available",FALSE,affylmGUIenvironment))

                        Try(assign("Pset.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("MLdesign.Available",FALSE,affylmGUIenvironment))
                        Try(assign("MLdesign", tt ,affylmGUIenvironment))
                        Try(assign("trainAffyData.available", FALSE, env=affylmGUIenvironment))
                        Try(assign("testAffyData.available", FALSE, env=affylmGUIenvironment))
##############initialization variables end

 #         Try(whichKindOfArray())
          #define the right Menu depending on the platform
          Try(changeMenu())#modify the default manu in aplatform specific menu
          
           Try(tkmessageBox(title="Selecting the Array Platform",message="Only tab delimited files, with array names in header and 1st column with probe set ids", type="ok", icon="info"))  
           Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
    	     Try(NumParameters <- get("NumParameters",envir=affylmGUIenvironment))
	         Try(NumContrastParameterizations <- get("NumContrastParameterizations",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationList <- get("ContrastParameterizationList",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationTREEIndexVec <- get("ContrastParameterizationTREEIndexVec",envir=affylmGUIenvironment))
	         Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	         if(limmaDataSetNameText!="Untitled"){
		         Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled"){LimmaFileName <- limmaDataSetNameText} )	# Local assignment only
		         Try(mbVal <- tkmessageBox(title="Start New Analysis",
				         											message=paste("Save changes to ",fixSeps(LimmaFileName),"?",sep=""),
						         									icon="question",type="yesnocancel",default="yes"
								         						 )#end of tkmessageBox
		         )#end of Try(mbVal..
		         if(tclvalue(mbVal)=="yes"){Try(SaveLimmaFile())}
		         if(tclvalue(mbVal)=="cancel"){
			         Try(tkfocus(.affylmGUIglobals$ttMain))
			         return()
		         }#end of if(tclvalue(mbVal)=="cancel")
		         Try(limmaDataSetNameText <- "Untitled")
	         }#end of if(limmaDataSetNameText!="Untitled")
	         #Try(tkmessageBox(title="Working Directory",message="After clicking OK, please select a working directory.",type="ok"))
	         Try(WD <- SetWD())
	         if(WD=="") return()
	    Try(tkdelete(.affylmGUIglobals$mainTree,"RawAffyData.Status"))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFit.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFit","LinearModelFit.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(tkdelete(.affylmGUIglobals$mainTree,"maSIgProData.Status"))
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","maSIgProData","maSIgProData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"PLM.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","PLM","PLM.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptDabg.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptMidas.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptMidas","AptMidas.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"spliceIndex.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","spliceIndex","spliceIndex.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.e.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.e.Status" ,text="Not Available at exon level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.g.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.g.Status" ,text="Not Available at gene level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"classification.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","classification","classification.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFitExon.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFitExon","LinearModelFitExon.Status",text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(
		    if(NumContrastParameterizations>0){
			    Try(for (i in (1:NumContrastParameterizations))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("ContrastParameterizations.Status.",i,sep="")))
			    )
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"ContrastParameterizations.Status.1"))
		    }
	    )
	    Try(
		    tkinsert(.affylmGUIglobals$mainTree,"end","ContrastParameterizations","ContrastParameterizations.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree)
	    )#end of Try
	    Try(
		    if(NumParameters>0){
			    Try(for (i in (1:NumParameters))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("Parameters.Status.",i,sep="")))
			    )#end of Try-for..
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"Parameters.Status.1"))
		    }
	    )#end of Try-if...
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters","Parameters.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree))
	    if(NumContrastParameterizations>0){
		    for (contrastParameterizationIndex in (1:NumContrastParameterizations)){
			    Try(.affylmGUIglobals$ContrastParameterizationTREEIndex <- ContrastParameterizationTREEIndexVec[contrastParameterizationIndex])
			    Try(ParameterizationNameNode <- paste("ContrastParameterizationName.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			    Try(tkdelete(.affylmGUIglobals$ContrastParameterizationTREE,ParameterizationNameNode))
			    Try(assign("ContrastParameterizationList", deleteItemFromList(ContrastParameterizationList,ParameterizationNameNode),affylmGUIenvironment))
		    }#end of for
	    }#end of if
	    Try(initGlobals())
	    Try(LimmaFileName <- get("LimmaFileName",affylmGUIenvironment))
      Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled") LimmaFileName <- limmaDataSetNameText) # Local assignment only
      Try(if(.Platform$OS.type=="windows")
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",gsub("/","\\\\",LimmaFileName))))
	             else
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",LimmaFileName)))
      )#end of Try
#	    Try(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)		 <- "Please select a Chip Definition (CDF) file.")
#	    Try(tclvalue(.affylmGUIglobals$CDFfileName)				 <- "No filename is selected at the moment.	Press the Select CDF File Button.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle) <- "Please select a tab-delimited file listing the CEL files.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileName)		 <- "No filename is selected at the moment.	Press the Select Targets File Button.")
	    Try(OpenLargefiles())
	    Try(tkfocus(.affylmGUIglobals$ttMain))

       
       })

        Try(if(ReturnVal=="GEO"){
          Try(assign("whichArrayPlatform","LARGE",affylmGUIenvironment))
##############initialization variables start
                        Try(tt <- "")
                        Try(assign("illuData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("illuData",tt,affylmGUIenvironment))

                        Try(assign("RawAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("NormalizedAffyData.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("unfilteredData.location", tt, affylmGUIenvironment))
                        Try(assign("geoPlatform",  tt, env=affylmGUIenvironment))

                        Try(assign("metaData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("metaData",tt,affylmGUIenvironment))

                        Try(assign("exprConsoleLibs.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exprConsoleLibs", tt ,affylmGUIenvironment))#locate here the library files as a list of data.frames

                        assign("libDir.Available",FALSE,affylmGUIenvironment)
                        assign("libDir", tt ,affylmGUIenvironment)#locate here the library files as a list of data.frames
                        Try(assign("whichLib", tt ,affylmGUIenvironment))#remember the type of exon library loaded

                        Try(assign("exonAffyData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("exonAffyData", tt ,affylmGUIenvironment))
                        Try(assign("dabg.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("dabg.p" , tt, affylmGUIenvironment))    
                        Try(assign("midas.p" , tt, affylmGUIenvironment))
                        Try(assign("midas.p.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("spliceIndexData.Available",FALSE,affylmGUIenvironment))
                        Try(assign("spliceIndexData", tt ,affylmGUIenvironment))
                        Try(assign("AltSplRP.e.p" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.e.Available" , FALSE, affylmGUIenvironment))
                        Try(assign("AltSplRP.g" , tt, affylmGUIenvironment))
                        Try(assign("AltSplRP.g.Available" , FALSE, affylmGUIenvironment))
                        
                       	Try(assign("LinearModelFitExon.Available",FALSE,affylmGUIenvironment))
	                      Try(assign("cosie.Available", FALSE ,affylmGUIenvironment))
                        Try(assign("fitExon",tt,affylmGUIenvironment))
                        Try(assign("AltSplLimma" , tt, affylmGUIenvironment))
                        Try(assign("AltSplLimma.Available" , FALSE, affylmGUIenvironment))
                        
                        Try(assign("intronicBg.available", TRUE,affylmGUIenvironment))
                        Try(assign("intronicBg", tt,affylmGUIenvironment))

                        Try(assign("maSigProSigs.Available",FALSE,affylmGUIenvironment))

                        Try(assign("Pset.Available",FALSE,affylmGUIenvironment))
                        
                        Try(assign("MLdesign.Available",FALSE,affylmGUIenvironment))
                        Try(assign("MLdesign", tt ,affylmGUIenvironment))
                        Try(assign("trainAffyData.available", FALSE, env=affylmGUIenvironment))
                        Try(assign("testAffyData.available", FALSE, env=affylmGUIenvironment))
##############initialization variables end
 #         Try(whichKindOfArray())
          #define the right Menu depending on the platform
          Try(changeMenu())#modify the default manu in aplatform specific menu
          
           Try(tkmessageBox(title="Selecting the Array Platform",message="Ony GEO Series Matrix Files could be loaded!", type="ok", icon="info"))  
           Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
    	     Try(NumParameters <- get("NumParameters",envir=affylmGUIenvironment))
	         Try(NumContrastParameterizations <- get("NumContrastParameterizations",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationList <- get("ContrastParameterizationList",envir=affylmGUIenvironment))
	         Try(ContrastParameterizationTREEIndexVec <- get("ContrastParameterizationTREEIndexVec",envir=affylmGUIenvironment))
	         Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	         if(limmaDataSetNameText!="Untitled"){
		         Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled"){LimmaFileName <- limmaDataSetNameText} )	# Local assignment only
		         Try(mbVal <- tkmessageBox(title="Start New Analysis",
				         											message=paste("Save changes to ",fixSeps(LimmaFileName),"?",sep=""),
						         									icon="question",type="yesnocancel",default="yes"
								         						 )#end of tkmessageBox
		         )#end of Try(mbVal..
		         if(tclvalue(mbVal)=="yes"){Try(SaveLimmaFile())}
		         if(tclvalue(mbVal)=="cancel"){
			         Try(tkfocus(.affylmGUIglobals$ttMain))
			         return()
		         }#end of if(tclvalue(mbVal)=="cancel")
		         Try(limmaDataSetNameText <- "Untitled")
	         }#end of if(limmaDataSetNameText!="Untitled")
	         #Try(tkmessageBox(title="Working Directory",message="After clicking OK, please select a working directory.",type="ok"))
	         Try(WD <- SetWD())
	         if(WD=="") return()
	    Try(tkdelete(.affylmGUIglobals$mainTree,"RawAffyData.Status"))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFit.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFit","LinearModelFit.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(tkdelete(.affylmGUIglobals$mainTree,"maSIgProData.Status"))
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","maSIgProData","maSIgProData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"PLM.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","PLM","PLM.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptDabg.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AptMidas.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptMidas","AptMidas.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"spliceIndex.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","spliceIndex","spliceIndex.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.e.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.e.Status" ,text="Not Available at exon level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.g.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.g.Status" ,text="Not Available at gene level",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
      Try(tkdelete(.affylmGUIglobals$mainTree,"classification.Status"))            
      Try(tkinsert(.affylmGUIglobals$mainTree,"end","classification","classification.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))
	    Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFitExon.Status"))
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFitExon","LinearModelFitExon.Status",text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))

	    Try(
		    if(NumContrastParameterizations>0){
			    Try(for (i in (1:NumContrastParameterizations))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("ContrastParameterizations.Status.",i,sep="")))
			    )
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"ContrastParameterizations.Status.1"))
		    }
	    )
	    Try(
		    tkinsert(.affylmGUIglobals$mainTree,"end","ContrastParameterizations","ContrastParameterizations.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree)
	    )#end of Try
	    Try(
		    if(NumParameters>0){
			    Try(for (i in (1:NumParameters))
				    Try(tkdelete(.affylmGUIglobals$mainTree,paste("Parameters.Status.",i,sep="")))
			    )#end of Try-for..
		    }else{
			    Try(tkdelete(.affylmGUIglobals$mainTree,"Parameters.Status.1"))
		    }
	    )#end of Try-if...
	    Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters","Parameters.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree))
	    if(NumContrastParameterizations>0){
		    for (contrastParameterizationIndex in (1:NumContrastParameterizations)){
			    Try(.affylmGUIglobals$ContrastParameterizationTREEIndex <- ContrastParameterizationTREEIndexVec[contrastParameterizationIndex])
			    Try(ParameterizationNameNode <- paste("ContrastParameterizationName.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			    Try(tkdelete(.affylmGUIglobals$ContrastParameterizationTREE,ParameterizationNameNode))
			    Try(assign("ContrastParameterizationList", deleteItemFromList(ContrastParameterizationList,ParameterizationNameNode),affylmGUIenvironment))
		    }#end of for
	    }#end of if
	    Try(initGlobals())
	    Try(LimmaFileName <- get("LimmaFileName",affylmGUIenvironment))
      Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled") LimmaFileName <- limmaDataSetNameText) # Local assignment only
      Try(if(.Platform$OS.type=="windows")
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",gsub("/","\\\\",LimmaFileName))))
	             else
		             Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",LimmaFileName)))
      )#end of Try
#	    Try(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)		 <- "Please select a Chip Definition (CDF) file.")
#	    Try(tclvalue(.affylmGUIglobals$CDFfileName)				 <- "No filename is selected at the moment.	Press the Select CDF File Button.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle) <- "Please select a tab-delimited file listing the CEL files.")
	    Try(tclvalue(.affylmGUIglobals$TargetsfileName)		 <- "No filename is selected at the moment.	Press the Select Targets File Button.")
	    Try(OpenGeoFiles())
	    Try(tkfocus(.affylmGUIglobals$ttMain))

       
       })



 } 
 ###############################################################################
 
 SaveAsLimmaFile <- function()
{
	Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
	Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled") LimmaFileName <- limmaDataSetNameText) # Local assignment only
	Try(tempLimmaFileName <- tclvalue(tkgetSaveFile(initialfile=LimmaFileName,filetypes="{{Limma Files} {.lma}} {{All files} *}")))
	if(!nchar(tempLimmaFileName))
	{
		try(tkfocus(.affylmGUIglobals$ttMain),silent=TRUE)
		return()
	}
	len <- nchar(tempLimmaFileName)
	if(len<=4)
			tempLimmaFileName <- paste(tempLimmaFileName,".lma",sep="")
	else if(substring(tempLimmaFileName,len-3,len)!=".lma")
				tempLimmaFileName <- paste(tempLimmaFileName,".lma",sep="")
	Try(LimmaFileName <- tempLimmaFileName)
	Try(assign("LimmaFileName",LimmaFileName,affylmGUIenvironment))

	Try(recentFilesFileName <- system.file("etc/recent-files.txt",package="oneChannelGUI"))
	Try(recentFiles <- readLines(recentFilesFileName))

	Try(recentFiles <- gsub("\\\\","/",recentFiles))

	# Remove any blank lines:
	Try(blanks <- grep("^[ \t\n]*$",recentFiles))
	Try(if(length(blanks)>0)
		recentFiles <- recentFiles[-blanks])
	Try(numRecentFiles <- length(recentFiles))

	Try(if(length(grep(LimmaFileName,recentFiles))==0)
		recentFiles <- c(LimmaFileName,recentFiles))
	Try(if(length(recentFiles)>4)
		recentFiles <- recentFiles[1:4])
	try(writeLines(con=recentFilesFileName,recentFiles),TRUE)
	Try(numRecentFiles <- length(recentFiles))

	Try(if(numRecentFiles>0)
	{
		Try(fileMenu <- .affylmGUIglobals$menus$fileMenu)
		Try(workingDirIndex <- as.numeric(tclvalue(tkindex(.affylmGUIglobals$menus$fileMenu,"affylmGUI: Working Directory"))))
		Try(exitIndex <- as.numeric(tclvalue(tkindex(.affylmGUIglobals$menus$fileMenu,"affylmGUI: Exit"))))
		Try(if(exitIndex==workingDirIndex+2)
			Try(numRecentFilesInMenu <- 0)
		else
		{
			Try(numRecentFilesInMenu <- exitIndex - workingDirIndex - 3)
			Try(for (i in (1:(numRecentFilesInMenu+1)))
				Try(tkdelete(fileMenu,workingDirIndex+2)))
		})
		Try(tkinsert(fileMenu,workingDirIndex+1,"separator"))

		Try(for (i in (numRecentFiles:1))
		{
			Try(label <- recentFiles[i])
			Try(fileNameOnly <- strsplit(label,"/")[[1]])
			Try(fileNameOnly <- fileNameOnly[length(fileNameOnly)])
			Try(if(nchar(recentFiles[i])>60)
					label <- paste(".../",fileNameOnly))
			Try(eval(parse(text=paste("assign(\".OpenALimmaFile_",i,"\",function() OpenALimmaFile(\"",recentFiles[i],"\"),.GlobalEnv)",sep=""))))
			Try(if(.Platform$OS.type=="windows")
				Try(tkinsert(fileMenu,workingDirIndex+2,"command",label=paste(i,". ",gsub("/","\\\\",label),sep=""),
					command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))))
			else
				Try(tkinsert(fileMenu,workingDirIndex+2,"command",label=paste(i,". ",label,sep=""),
					command=eval(parse(text=paste(".OpenALimmaFile_",i,sep=""))))))

		})
	})

	# .affylmGUIglobals$ttMain may have been destroyed
	e <- try(tkfocus(.affylmGUIglobals$ttMain),silent=TRUE)
	if(!inherits(e, "try-error"))
		Try(if(.Platform$OS.type=="windows")
			Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",gsub("/","\\\\",LimmaFileName))))
		else
			Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",LimmaFileName))))

	try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"),silent=TRUE)
	assign("PsetData.Available",FALSE,affylmGUIenvironment)#Always assign this to FALSE. Will always recalculate it in the Plot menu functions
	Try(save(list = ls(envir=affylmGUIenvironment), file=LimmaFileName, envir=affylmGUIenvironment))
	try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"),silent=TRUE)
	try(tkfocus(.affylmGUIglobals$ttMain),silent=TRUE)
}
################################################################################

OpenCDFandTargetsfiles <- function()
{
	Require("affy")
	Try(ttCDFandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttCDFandTargets))
	Try(tkgrab.set(ttCDFandTargets))
	Try(tkfocus(ttCDFandTargets))
	Try(tkwm.title(ttCDFandTargets,"Targets file"))
	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))

	OpenTargetsFileAndSetCursor <- function()
	{
			Try(tkconfigure(ttCDFandTargets,cursor="watch"))
			Try(tkfocus(ttCDFandTargets))
			Try(OpenTargetsFile())
			Try(tkconfigure(ttCDFandTargets,cursor="arrow"))
			Try(tkfocus(ttCDFandTargets))
	}

	OpenCDFFileAndSetCursor <- function()
	{
			Try(tkconfigure(ttCDFandTargets,cursor="watch"))
			Try(tkfocus(ttCDFandTargets))
			Try(OpenCDFFile())
			Try(tkconfigure(ttCDFandTargets,cursor="arrow"))
			Try(tkfocus(ttCDFandTargets))
	}

	Try(OpenCDFFile.but <- tkbutton(ttCDFandTargets, text="Select CDF File",command=OpenCDFFile,font=.affylmGUIglobals$affylmGUIfont2))
	Try(OpenTargetsFile.but <- tkbutton(ttCDFandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	Try(tclvalue(.affylmGUIglobals$CDFfileName) <- fixSeps(tclvalue(.affylmGUIglobals$CDFfileName)))
	Try(.affylmGUIglobals$CDFfileBoxTitleLabel<-tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	Try(.affylmGUIglobals$CDFfileNameLabel<-tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$CDFfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkconfigure(.affylmGUIglobals$CDFfileBoxTitleLabel, textvariable=.affylmGUIglobals$CDFfileBoxTitle))
	Try(tkconfigure(.affylmGUIglobals$CDFfileNameLabel, textvariable=.affylmGUIglobals$CDFfileName))

#	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
#	Try(tkgrid(.affylmGUIglobals$CDFfileBoxTitleLabel,columnspan=4))
#	Try(tkgrid(.affylmGUIglobals$CDFfileNameLabel,columnspan=4))

	Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	Try(TargetsfileBoxTitleLabel <- tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	Try(TargetsfileNameLabel <- tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
	Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))

#	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
#	Try(tkgrid(tklabel(ttCDFandTargets,text="    "),OpenCDFFile.but, OpenTargetsFile.but))
	Try(tkgrid(tklabel(ttCDFandTargets,text="    "),OpenTargetsFile.but))
	Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	Try(Abort <- 1)
	onOK <- function()
	{
#			Try(cdf		 <- get("cdf",envir=affylmGUIenvironment))
			Try(Targets <- get("Targets",envir=affylmGUIenvironment))
#			Try(if(length(cdf)==0)
#			{
#				Try(tkmessageBox(title="CDF (Chip Definition) File",message=paste("Either you did not specify a valid CDF (Chip Definition File",
#					"or an error occurred while reading in the CDF file.	It should be in tab-delimited text format and it should include the column headings \"Block\", \"Column\", \"Row\", \"Name\" and \"ID\"."),icon="error"))
#				onCancel()
#				return()
#			})
			Try(if(length(Targets)==0)
			{
				Try(tkmessageBox(title="RNA Targets File",message=paste("Either you did not specify a valid RNA Targets File",
					"or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				onCancel()
				return()
			})
			Try(tkgrab.release(ttCDFandTargets));
			Try(tkdestroy(ttCDFandTargets));
			Try(tkfocus(.affylmGUIglobals$ttMain))
			Try(Abort <<- 0)
	}
	onCancel <- function() {Try(tkgrab.release(ttCDFandTargets));Try(tkdestroy(ttCDFandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	Try(OK.but <-tkbutton(ttCDFandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <-tkbutton(ttCDFandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
	Try(tkgrid(tklabel(ttCDFandTargets,text="    "),OK.but,Cancel.but))
	Try(tkgrid(tklabel(ttCDFandTargets,text="       ")))
	Try(tkfocus(ttCDFandTargets))
	Try(tkbind(ttCDFandTargets, "<Destroy>", function() {Try(tkgrab.release(ttCDFandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkwait.window(ttCDFandTargets))

	if(Abort==1)
				return(0)

	#OK
	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
	Try(tkfocus(.affylmGUIglobals$ttMain))
	Try(Targets <- get("Targets",affylmGUIenvironment))
	Try(slides <- Targets$FileName)
	Try(filesExist <- file.exists(slides))
	Try(filesWhichDontExist <- slides[!filesExist])
	Try(if(length(filesWhichDontExist)>0)
		Try(for (i in (1:length(filesWhichDontExist)))
			Try(tkmessageBox(title="Error opening file",message=paste("Failed to open file: \"",filesWhichDontExist[i],"\"",sep=""),icon="error"))))
	Try(if(length(filesWhichDontExist)>0)
	{
		Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
		return(0)
	})

	Try(RawAffyData <- ReadAffy(filenames=Targets$FileName))
	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	Try(assign("RawAffyData",RawAffyData,affylmGUIenvironment))
	Try(assign("RawAffyData.Available",TRUE,affylmGUIenvironment))
	Try(SlideNamesVec <- colnames(exprs(RawAffyData)))
	Try(if("Name" %in% colnames(Targets))
		SlideNamesVec <- Targets$Name)
	Try(assign("SlideNamesVec",SlideNamesVec,affylmGUIenvironment))
	Try(assign("ArraysLoaded",TRUE,affylmGUIenvironment))
	Try(tkdelete(.affylmGUIglobals$mainTree,"RawAffyData.Status"))
	Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree))
	Try(ReturnVal <- GetlimmaDataSetName())
	if(ReturnVal==0) return(0)
	return(1)
}
################################################################################

#this function define the organism (hs, mm, rn) of the exon array and the subgroup under analysis (core, extended, full)
#the exon analysis require the library files used by expression console
#in this version of the function user can choose of using tab delimited files calculated by Expression Console or use
#the APT tools to calculate gene/ exon summaries
"whichKindOfArray" <- function(){
Try(exonVal <- tkmessageBox(title="Probe sets intensities by Affymetrix APT", message="Do you want to use APT for gene/exon summaries", icon="question",type="yesno",default="yes"))
                    Try(assign("exonVal",exonVal,affylmGUIenvironment)) #the information about the decision of using apt tools for  intenisties calculation
                    Try(whereApt <- get("aptDir",envir=affylmGUIenvironment))
                    Try(if(is.na(whereApt)) whereApt <- "")
                    if(tclvalue(exonVal)=="yes"){
                           #Try(whereApt <- "")
                           #Try(whereApt <- .aptDir())
                           if(whereApt != ""){
                                                   #APT dir
                                                 if(length(grep("apt-probeset-summarize", dir(paste(whereApt, "/bin", sep="")))) == 0){
                                                        Try(tkmessageBox(title="APT tools dir ",message="The main folder where APT tools are located is not correctly defined!",icon="error"))
                                                        assign("aptDir.Available",FALSE,affylmGUIenvironment)
                                                        assign("aptDir", "" ,affylmGUIenvironment)
                                                        Try(aptFolder())
                                                 }  
                                                   Try(assign("aptDir.Available",TRUE,affylmGUIenvironment))
                                                   Try(assign("aptDir", whereApt ,affylmGUIenvironment))

                                                   #select the organism under analysis and the subgroup of the analysis
                                                   Try(ReturnVal <<- "")
                                                   Try(ttIfDialog<-tktoplevel(.affylmGUIglobals$ttMain))
                                                   Try(tkwm.deiconify(ttIfDialog))
                                                   Try(tkgrab.set(ttIfDialog))
                                                   Try(tkfocus(ttIfDialog))
                                                   Try(tkwm.title(ttIfDialog,"Exon/Gene arrays"))
                                                   Try(tkgrid(tklabel(ttIfDialog,text="    ")))
                                                   Try(whichArrayPlatform <- get("whichArrayPlatform",affylmGUIenvironment))
                                                   
                                                   if(whichArrayPlatform == "GENE"){
                                                      Try(frame1 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
                                                      Try(HowManyQuestion1 <- tklabel(frame1,text="Select the organism under analysis",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(tkgrid(HowManyQuestion1))
                                                      Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
                                                      Try(thresholdTcl <- tclVar("HuGene"))
                                                      Try(I1.but  <- tkradiobutton(frame1,text="Hs",variable=thresholdTcl,value="HuGene",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(I2.but  <- tkradiobutton(frame1,text="Mm",variable=thresholdTcl,value="MoGene",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(I3.but  <- tkradiobutton(frame1,text="Rn",variable=thresholdTcl,value="RaGene",font=.affylmGUIglobals$affylmGUIfont2))
           
                                                      Try(tkgrid(I1.but,sticky="w"))
                                                      Try(tkgrid(I2.but,sticky="w"))
                                                      Try(tkgrid(I3.but,sticky="w"))
                                                      Try(tkgrid.configure(HowManyQuestion1,I1.but,I2.but,I3.but,sticky="w"))

                                                  #    Try(frame2 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
                                                  #    Try(fractionLabel <- tklabel(frame2,text="Exon subgroup",font=.affylmGUIglobals$affylmGUIfont2))
                                                  #    Try(tkgrid(fractionLabel,sticky="w"))
                                                  #    Try(tkgrid.configure(fractionLabel,sticky="w"))
                                                  #    Try(fractionTcl <- tclVar("core"))
                                                  #    Try(F1.but <- tkradiobutton(frame2,text="core",variable=fractionTcl,value="core",font=.affylmGUIglobals$affylmGUIfont2))
                                                  #    Try(F2.but <- tkradiobutton(frame2,text="extended",variable=fractionTcl,value="extended",font=.affylmGUIglobals$affylmGUIfont2))
                                                  #    Try(F3.but <- tkradiobutton(frame2,text="full",variable=fractionTcl,value="full",font=.affylmGUIglobals$affylmGUIfont2))

                                                   #   Try(tkgrid(F1.but,sticky="w"))
                                                   #   Try(tkgrid(F2.but,sticky="w"))
                                                   #   Try(tkgrid(F3.but,sticky="w"))

                                                    #  Try(tkgrid.configure(fractionLabel,F1.but,F2.but,F3.but,sticky="w"))

                                                      Try(onOK <- function()
                                                      {
                                                           ReturnVal1 <- as.character(tclvalue(thresholdTcl))
                                                           ReturnVal2 <- "gene" #this is not used in gene 1.0 st arrays
                                                           Try(ReturnVal <<- paste(ReturnVal1, ReturnVal2, sep=";"))
                                                           Try(tkgrab.release(ttIfDialog))
                                                           Try(tkdestroy(ttIfDialog))
                                                           Try(tkfocus(.affylmGUIglobals$ttMain))
                                                      })

                                                      Try(frame3 <- tkframe(ttIfDialog,borderwidth=2))
                                                      Try(onCancel <- function() {
                                                               Try(tkgrab.release(ttIfDialog))
                                                               Try(tkdestroy(ttIfDialog))
                                                               Try(tkfocus(.affylmGUIglobals$ttMain))
                                                               Try(return())
                                                      })
                                                      Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

                                                      Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))

                                                      Try(tkgrid(tklabel(ttIfDialog,text="    "),frame1,tklabel(ttIfDialog,text="  ")))
                                                      Try(tkgrid(tklabel(ttIfDialog,text="    ")))
                                                      Try(tkgrid(tklabel(ttIfDialog,text="    "),frame3,tklabel(ttIfDialog,text="  ")))
                                                      Try(tkgrid(tklabel(ttIfDialog,text="    ")))
                                                      Try(tkgrid.configure(frame1,frame3,sticky="w"))

                                                      Try(tkfocus(ttIfDialog))
                                                      Try(tkbind(ttIfDialog, "<Destroy>", function() {Try(tkgrab.release(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));}))
                                                      Try(tkwait.window(ttIfDialog))
                                                  }
                                                  if(whichArrayPlatform == "EXON"){
                                                      Try(frame1 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
                                                      Try(HowManyQuestion1 <- tklabel(frame1,text="Select the organism under analysis",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(tkgrid(HowManyQuestion1))
                                                      Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
                                                      Try(thresholdTcl <- tclVar("HuEx"))
                                                      Try(I1.but  <- tkradiobutton(frame1,text="Hs",variable=thresholdTcl,value="HuEx",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(I2.but  <- tkradiobutton(frame1,text="Mm",variable=thresholdTcl,value="MoEx",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(I3.but  <- tkradiobutton(frame1,text="Rn",variable=thresholdTcl,value="RaEx",font=.affylmGUIglobals$affylmGUIfont2))
           
                                                      Try(tkgrid(I1.but,sticky="w"))
                                                      Try(tkgrid(I2.but,sticky="w"))
                                                      Try(tkgrid(I3.but,sticky="w"))
                                                      Try(tkgrid.configure(HowManyQuestion1,I1.but,I2.but,I3.but,sticky="w"))

                                                      Try(frame2 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
                                                      Try(fractionLabel <- tklabel(frame2,text="Exon subgroup",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(tkgrid(fractionLabel,sticky="w"))
                                                      Try(tkgrid.configure(fractionLabel,sticky="w"))
                                                      Try(fractionTcl <- tclVar("core"))
                                                      Try(F1.but <- tkradiobutton(frame2,text="core",variable=fractionTcl,value="core",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(F2.but <- tkradiobutton(frame2,text="extended",variable=fractionTcl,value="extended",font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(F3.but <- tkradiobutton(frame2,text="full",variable=fractionTcl,value="full",font=.affylmGUIglobals$affylmGUIfont2))

                                                      Try(tkgrid(F1.but,sticky="w"))
                                                      Try(tkgrid(F2.but,sticky="w"))
                                                      Try(tkgrid(F3.but,sticky="w"))

                                                      Try(tkgrid.configure(fractionLabel,F1.but,F2.but,F3.but,sticky="w"))

                                                      Try(onOK <- function()
                                                      {
                                                           ReturnVal1 <- as.character(tclvalue(thresholdTcl))
                                                           ReturnVal2 <- as.character(tclvalue(fractionTcl))
                                                           Try(ReturnVal <<- paste(ReturnVal1, ReturnVal2, sep=";"))
                                                           Try(tkgrab.release(ttIfDialog))
                                                           Try(tkdestroy(ttIfDialog))
                                                           Try(tkfocus(.affylmGUIglobals$ttMain))
                                                      })

                                                      Try(frame3 <- tkframe(ttIfDialog,borderwidth=2))
                                                      Try(onCancel <- function() {
                                                               Try(tkgrab.release(ttIfDialog))
                                                               Try(tkdestroy(ttIfDialog))
                                                               Try(tkfocus(.affylmGUIglobals$ttMain))
                                                               Try(return())
                                                      })
                                                      Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
                                                      Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

                                                      Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))

                                                      Try(tkgrid(tklabel(ttIfDialog,text="    "),frame1,frame2,tklabel(ttIfDialog,text="  ")))
                                                      Try(tkgrid(tklabel(ttIfDialog,text="    ")))
                                                      Try(tkgrid(tklabel(ttIfDialog,text="    "),frame3,tklabel(ttIfDialog,text="  ")))
                                                      Try(tkgrid(tklabel(ttIfDialog,text="    ")))
                                                      Try(tkgrid.configure(frame1,frame3,sticky="w"))

                                                      Try(tkfocus(ttIfDialog))
                                                      Try(tkbind(ttIfDialog, "<Destroy>", function() {Try(tkgrab.release(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));}))
                                                      Try(tkwait.window(ttIfDialog))
                                                  }

                                                  #loading the exon libraries
                                                  if(ReturnVal == ""){
                                                              Try(tkfocus(.affylmGUIglobals$ttMain))
                                                              Try(return())
                                                  }
                                                  Try(tmp<-strsplit(ReturnVal, ";"))
                                                  Try(assign("whichLib", tmp ,affylmGUIenvironment))#saving the type of exon library under use
                                                  #select the directory in which are present the library data for expression console analysis
                                                  Try(libDir <- "")
                                                  Try(libDirLocation <- get("libDirLocation", affylmGUIenvironment))
                                                  #Try(libDir <- libraryFilesDir())
                                                  Try(libDir <- libDirLocation)
                                                  if(libDir != ""){
                                                                           Try(libDir <- paste(libDir, "/", sep=""))
                                                                           Try(content.libDir <- dir(libDir))
                                                                           if(length(grep(tmp[[1]][1],content.libDir)) == 0){
                                                                                  Try(tkmessageBox(title="Gene/Exon libraries Dir",message=paste("The selected folder does not contain ", tmp[[1]][1], " library files!\n Download them using the function provided in the general tools!", sep=""),icon="error"))
                                                                                  Try(return())
                                                                           }
                                                                           assign("libDir.Available",TRUE,affylmGUIenvironment)
                                                                           assign("libDir", libDir ,affylmGUIenvironment)#locate here the library files as a list of data.frames
                                                                           if(whichArrayPlatform == "EXON"){
                                                                               Try(ctrl.name <- paste(libDir, content.libDir[intersect(grep(tmp[[1]][1],content.libDir), grep('controls.ps$',content.libDir))], sep=""))
                                                                               Try(ctrl <- read.table(ctrl.name, sep="\t", header=T, as.is=T))
                                                                               Try(exonlib.name <- paste(libDir, content.libDir[intersect(grep('.mps$',content.libDir), intersect(grep(tmp[[1]][1],content.libDir), grep(tmp[[1]][2],content.libDir)))], sep=""))
                                                                               Try(exonlib <- read.table(exonlib.name, sep="\t", header=T, as.is=T))
                                                                               Try(ctrl.exonlib <- list("controls"=ctrl, "exon.library"=exonlib))
                                                                               Try(assign("exprConsoleLibs.Available",TRUE,affylmGUIenvironment))
                                                                               Try(assign("exprConsoleLibs", ctrl.exonlib ,affylmGUIenvironment))
                                                                               Try(cat(""))
                                                                           }
                                                                           if(whichArrayPlatform == "GENE"){
                                                                               #Try(ctrl.name <- paste(libDir, content.libDir[intersect(grep(tmp[[1]][1],content.libDir), grep('controls.ps$',content.libDir))], sep=""))
                                                                               #Try(ctrl <- read.table(ctrl.name, sep="\t", header=T, as.is=T))
                                                                               Try(ctrl <- "")
                                                                               Try(exonlib.name <- paste(libDir, content.libDir[intersect(grep('.mps$',content.libDir), grep(tmp[[1]][1],content.libDir))], sep=""))
                                                                               Try(exonlib <- read.table(exonlib.name, sep="\t", header=T, as.is=T, fill=T))
                                                                               
                                                                               Try(ctrl.exonlib <- list("controls"=ctrl, "exon.library"=exonlib))
                                                                               Try(assign("exprConsoleLibs.Available",TRUE,affylmGUIenvironment))
                                                                               Try(assign("exprConsoleLibs", ctrl.exonlib ,affylmGUIenvironment))
                                                                               Try(cat(""))
                                                                           }
                                                                           
                                                                     } else {
                                                                           Try(tkmessageBox(title="Gene/exon libraries Dir",message="You have not defined the directory where gene/exon libraries are installed!",icon="error"))
			                                                                     Try(geneExonLibs())
                                                                     }
                                                          Try(cat(""))
                                                   } else {
                                                           Try(aptFolder())
                                                   }
                    } else {
                             Try(ReturnVal <<- "")
                             #summaries uploaded from tab delimited files
                             #select the organism under analysis and the subgroup of the analysis
                             Try(ttIfDialog<-tktoplevel(.affylmGUIglobals$ttMain))
                             Try(tkwm.deiconify(ttIfDialog))
                             Try(tkgrab.set(ttIfDialog))
                             Try(tkfocus(ttIfDialog))
                             Try(tkwm.title(ttIfDialog,"Exon arrays"))
                             Try(tkgrid(tklabel(ttIfDialog,text="    ")))

                             Try(frame1 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
                             Try(HowManyQuestion1 <- tklabel(frame1,text="Select the organism under analysis",font=.affylmGUIglobals$affylmGUIfont2))
                             Try(tkgrid(HowManyQuestion1))
                             Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
                             Try(thresholdTcl <- tclVar("HuEx"))
                             Try(I1.but  <- tkradiobutton(frame1,text="Hs",variable=thresholdTcl,value="HuEx",font=.affylmGUIglobals$affylmGUIfont2))
                             Try(I2.but  <- tkradiobutton(frame1,text="Mm",variable=thresholdTcl,value="MoEx",font=.affylmGUIglobals$affylmGUIfont2))
                             Try(I3.but  <- tkradiobutton(frame1,text="Rn",variable=thresholdTcl,value="RaEx",font=.affylmGUIglobals$affylmGUIfont2))
           
                             Try(tkgrid(I1.but,sticky="w"))
                             Try(tkgrid(I2.but,sticky="w"))
                             Try(tkgrid(I3.but,sticky="w"))
                             Try(tkgrid.configure(HowManyQuestion1,I1.but,I2.but,I3.but,sticky="w"))

                             Try(frame2 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
                             Try(fractionLabel <- tklabel(frame2,text="Exon subgroup",font=.affylmGUIglobals$affylmGUIfont2))
                             Try(tkgrid(fractionLabel,sticky="w"))
                             Try(tkgrid.configure(fractionLabel,sticky="w"))
                             Try(fractionTcl <- tclVar("core"))
                             Try(F1.but <- tkradiobutton(frame2,text="core",variable=fractionTcl,value="core",font=.affylmGUIglobals$affylmGUIfont2))
                             Try(F2.but <- tkradiobutton(frame2,text="extended",variable=fractionTcl,value="extended",font=.affylmGUIglobals$affylmGUIfont2))
                             Try(F3.but <- tkradiobutton(frame2,text="full",variable=fractionTcl,value="full",font=.affylmGUIglobals$affylmGUIfont2))

                             Try(tkgrid(F1.but,sticky="w"))
                             Try(tkgrid(F2.but,sticky="w"))
                             Try(tkgrid(F3.but,sticky="w"))

                             Try(tkgrid.configure(fractionLabel,F1.but,F2.but,F3.but,sticky="w"))
                    
                             Try(onOK <- function()
                             {
                                  ReturnVal1 <- as.character(tclvalue(thresholdTcl))
                                  ReturnVal2 <- as.character(tclvalue(fractionTcl))
                                  Try(ReturnVal <<- paste(ReturnVal1, ReturnVal2, sep=";"))
                                  Try(tkgrab.release(ttIfDialog))
                                  Try(tkdestroy(ttIfDialog))
                                  Try(tkfocus(.affylmGUIglobals$ttMain))
                             })

                             Try(frame3 <- tkframe(ttIfDialog,borderwidth=2))
                             Try(onCancel <- function() {
                                  Try(tkgrab.release(ttIfDialog))
                                  Try(tkdestroy(ttIfDialog))
                                  Try(tkfocus(.affylmGUIglobals$ttMain))
                                  Try(return())
                             })
                             Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
                             Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

                             Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))

                             Try(tkgrid(tklabel(ttIfDialog,text="    "),frame1,frame2,tklabel(ttIfDialog,text="  ")))
                             Try(tkgrid(tklabel(ttIfDialog,text="    ")))
                             Try(tkgrid(tklabel(ttIfDialog,text="    "),frame3,tklabel(ttIfDialog,text="  ")))
                             Try(tkgrid(tklabel(ttIfDialog,text="    ")))
                             Try(tkgrid.configure(frame1,frame3,sticky="w"))

                             Try(tkfocus(ttIfDialog))
                             Try(tkbind(ttIfDialog, "<Destroy>", function() {Try(tkgrab.release(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));}))
                             Try(tkwait.window(ttIfDialog))
                             #loading the exon libraries
                             if(ReturnVal != ""){
                                 Try(tmp<-strsplit(ReturnVal, ";"))
                                 Try(assign("whichLib", tmp ,affylmGUIenvironment))#saving the type of exon library under use
                                 #select the directory in which are present the library data for expression console analysis
                                 Try(libDirLocation <- get("libDirLocation",envir=affylmGUIenvironment))
                                 Try(if(is.na(libDirLocation)) libDirLocation <- "")
                                 #Try(libDir <- "")
                                 #Try(libDir <- libraryFilesDir())
                                 Try(libDir <- libDirLocation)
                                 if(libDir != ""){
                                                     Try(libDir <- paste(libDir, "/", sep=""))
                                                     Try(content.libDir <- dir(libDir))
                                                     if(length(grep(tmp[[1]][1],content.libDir)) == 0){
                                                              Try(tkmessageBox(title="Gene/exon libraries Dir",message=paste("The selected folder does not contain ", tmp[[1]][1], " library files!\n Download them from Affymetrix web site!", sep=""),icon="error"))
                                                              Try(return())
                                                     }
                                                     assign("libDir.Available",TRUE,affylmGUIenvironment)
                                                     assign("libDir", libDir ,affylmGUIenvironment)#locate here the library files as a list of data.frames
                     
                                                     Try(ctrl.name <- paste(libDir, content.libDir[intersect(grep(tmp[[1]][1],content.libDir), grep('controls.ps$',content.libDir))], sep=""))
                                                     Try(ctrl <- read.table(ctrl.name, sep="\t", header=T, as.is=T))
                                                     Try(exonlib.name <- paste(libDir, content.libDir[intersect(grep('.mps$',content.libDir), intersect(grep(tmp[[1]][1],content.libDir), grep(tmp[[1]][2],content.libDir)))], sep=""))
                                                     Try(exonlib <- read.table(exonlib.name, sep="\t", header=T, as.is=T))
                                                     Try(ctrl.exonlib <- list("controls"=ctrl, "exon.library"=exonlib))
                                                     Try(assign("exprConsoleLibs.Available",TRUE,affylmGUIenvironment))
                                                     Try(assign("exprConsoleLibs", ctrl.exonlib ,affylmGUIenvironment))
                                                     Try(cat(""))
                                                  } else {
                                                           Try(tkmessageBox(title="Gene/exon libraries Dir",message="You have not defined the directory where gene/exon libraries are installed!",icon="error"))
			                                                     return()
                                                    }
  
                           } else {
                               Try(tkmessageBox(title="Gene/exon libraries Dir",message="You have not defined the directory where gene/exon libraries are installed!",icon="error"))
                               Try(geneExonLibs())
                            }
                       }
}

#loading the position of the APT application
".aptDir" <- function (){
    Try(wd <- tclVar(getwd()))
    Try(if (.Platform$OS.type == "windows") 
        Try(tclvalue(wd) <- gsub("/", "\\\\", tclvalue(wd))))
    Try(ttChooseDir <- tktoplevel(.affylmGUIglobals$ttMain))
    Try(tkwm.title(ttChooseDir, "Please enter the dir in which APT is located"))
    Try(tkwm.deiconify(ttChooseDir))
    Try(tkgrab.set(ttChooseDir))
    Try(tkgrid(tklabel(ttChooseDir, text = "    ")))
    Try(label1 <- tklabel(ttChooseDir, text = "Locate APT dir", 
        font = .affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), label1, sticky = "w"))
    Try(tkgrid.configure(label1, columnspan = 3))
    Try(tkgrid(tklabel(ttChooseDir, text = "    ")))
    Try(onBrowse <- function() {
        Try(if (file.exists(gsub("\\\\", "/", tclvalue(wd)))) 
            initialdir <- gsub("\\\\", "/", tclvalue(wd))
        else initialdir <- getwd())
        Try(dir1 <- tclvalue(tkchooseDirectory(title = "Please enter the dir in which APT is located", 
            initialdir = initialdir)))
        Try(if (nchar(dir1) > 0) 
            tclvalue(wd) <- dir1)
        Try(if (.Platform$OS.type == "windows") 
            Try(tclvalue(wd) <- gsub("/", "\\\\", tclvalue(wd))))
    })
    Try(ReturnVal <- "")
    Try(onOK <- function() {
        Try(DirChosen <- tclvalue(wd))
        Try(tkgrab.release(ttChooseDir))
        Try(tkdestroy(ttChooseDir))
        Try(DirChosen <- gsub("\\\\", "/", DirChosen))
        Try(ReturnVal <<- DirChosen)
    })
    Try(onCancel <- function() {
        Try(tkgrab.release(ttChooseDir))
        Try(tkdestroy(ttChooseDir))
        Try(return())
    })
    Try(Browse.but <- tkbutton(ttChooseDir, text = "Browse", 
        command = onBrowse, font = .affylmGUIglobals$affylmGUIfont2))
    Try(OK.but <- tkbutton(ttChooseDir, text = "    OK\t\t", 
        command = onOK, font = .affylmGUIglobals$affylmGUIfont2))
    Try(Cancel.but <- tkbutton(ttChooseDir, text = " Cancel ", 
        command = onCancel, font = .affylmGUIglobals$affylmGUIfont2))
    Try(entry1 <- tkentry(ttChooseDir, textvariable = wd, width = 40, 
        font = .affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), entry1))
    Try(tkgrid.configure(entry1, columnspan = 3))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), row = 3, 
        column = 4))
    Try(tkgrid(Browse.but, row = 3, column = 5))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), row = 3, 
        column = 6))
    Try(tkgrid(tklabel(ttChooseDir, text = "    ")))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), tklabel(ttChooseDir, 
        text = "    "), OK.but, Cancel.but))
    Try(tkgrid.configure(Cancel.but, sticky = "w"))
    Try(tkgrid(tklabel(ttChooseDir, text = "    ")))
    Try(tkfocus(entry1))
    Try(tkbind(ttChooseDir, "<Destroy>", function() tkgrab.release(ttChooseDir)))
    Try(tkbind(entry1, "<Return>", onOK))
    Try(tkwait.window(ttChooseDir))
    return(ReturnVal)
}
################################################################################

#this function save in int affylmGUIenvironment the directory location of the expression console library files.
#these files are needed for exon level analysis
"libraryFilesDir" <- function()
 {
    Try(wd <- tclVar(getwd()))
    Try(if (.Platform$OS.type == "windows") 
        Try(tclvalue(wd) <- gsub("/", "\\\\", tclvalue(wd))))
    Try(ttChooseDir <- tktoplevel(.affylmGUIglobals$ttMain))
    Try(tkwm.title(ttChooseDir, "Choose Expression Console library files dir"))
    Try(tkwm.deiconify(ttChooseDir))
    Try(tkgrab.set(ttChooseDir))
    Try(tkgrid(tklabel(ttChooseDir, text = "    ")))
    Try(label1 <- tklabel(ttChooseDir, text = "Choose Expression Console library files dir: ", 
        font = .affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), label1, sticky = "w"))
    Try(tkgrid.configure(label1, columnspan = 3))
    Try(tkgrid(tklabel(ttChooseDir, text = "    ")))
    Try(onBrowse <- function() {
        Try(if (file.exists(gsub("\\\\", "/", tclvalue(wd)))) 
            initialdir <- gsub("\\\\", "/", tclvalue(wd))
        else initialdir <- getwd())
        Try(dir1 <- tclvalue(tkchooseDirectory(title = "Please choose the Expression Console library files dir", 
            initialdir = initialdir)))
        Try(if (nchar(dir1) > 0) 
            tclvalue(wd) <- dir1)
        Try(if (.Platform$OS.type == "windows") 
            Try(tclvalue(wd) <- gsub("/", "\\\\", tclvalue(wd))))
    })
    Try(ReturnVal <- "")
    Try(onOK <- function() {
        Try(DirChosen <- tclvalue(wd))
        Try(tkgrab.release(ttChooseDir))
        Try(tkdestroy(ttChooseDir))
        Try(DirChosen <- gsub("\\\\", "/", DirChosen))
        Try(ReturnVal <<- DirChosen)
    })
    Try(onCancel <- function() {
        Try(tkgrab.release(ttChooseDir))
        Try(tkdestroy(ttChooseDir))
        Try(return())
    })
    Try(Browse.but <- tkbutton(ttChooseDir, text = "Browse", 
        command = onBrowse, font = .affylmGUIglobals$affylmGUIfont2))
    Try(OK.but <- tkbutton(ttChooseDir, text = "    OK\t\t", 
        command = onOK, font = .affylmGUIglobals$affylmGUIfont2))
    Try(Cancel.but <- tkbutton(ttChooseDir, text = " Cancel ", 
        command = onCancel, font = .affylmGUIglobals$affylmGUIfont2))
    Try(entry1 <- tkentry(ttChooseDir, textvariable = wd, width = 40, 
        font = .affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), entry1))
    Try(tkgrid.configure(entry1, columnspan = 3))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), row = 3, 
        column = 4))
    Try(tkgrid(Browse.but, row = 3, column = 5))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), row = 3, 
        column = 6))
    Try(tkgrid(tklabel(ttChooseDir, text = "    ")))
    Try(tkgrid(tklabel(ttChooseDir, text = "    "), tklabel(ttChooseDir, 
        text = "    "), OK.but, Cancel.but))
    Try(tkgrid.configure(Cancel.but, sticky = "w"))
    Try(tkgrid(tklabel(ttChooseDir, text = "    ")))
    Try(tkfocus(entry1))
    Try(tkbind(ttChooseDir, "<Destroy>", function() tkgrab.release(ttChooseDir)))
    Try(tkbind(entry1, "<Return>", onOK))
    Try(tkwait.window(ttChooseDir))
    Try(return(ReturnVal))
}
################################################################################

#this function change manu of the affylmGUI depending on the available platform
"changeMenu" <- function(){
          Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
          if(whichArrayPlatform=="AFFY"){
             #changing the menu to be used for exons data
             Try(topMenu <- tkmenu(.affylmGUIglobals$ttMain))
 	       	   Try(tkconfigure(.affylmGUIglobals$ttMain,menu=topMenu))
	       	   Try(Menus <- read.table(file.path(system.file("etc",package="oneChannelGUI"),"affylmGUI-menus.affy.txt"), as.is=TRUE))
	       	   Try(
		       	   for (m in 1:nrow(Menus)){
			       	   Try(if(Menus[m, 1] == "menu"){
					         	assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))
				       	    }else if(Menus[m, 1] == "item"){
					       	  if(Menus[m, 3] == "command")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"command", label=Menus[m, 4], command=eval(parse(text=Menus[m, 5])))
					       	   else if(Menus[m, 3] == "cascade"){
						       	   cascadeMenu <- eval(parse(text=Menus[m, 5]))
						       	   tkadd(eval(parse(text=Menus[m, 2])),"cascade", label=Menus[m, 4], menu=cascadeMenu)
						       	 if(Menus[m, 4]=="File"){
							         	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
							       	  Try(menuNames <- unique(Menus[,2,drop=TRUE]))
							       	  Try(numMenus <- length(menuNames))
							       	  Try(menus <- list())
							       	  Try(for (j in (1:numMenus))
								       	  menus[[j]] <- eval(parse(text=Menus[j,2]))
							       	  )#end of Try
							       	  Try(names(menus) <- menuNames)
							       	  Try(affylmGUIglobals$menus <- menus)
							       	  Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
						       	   }#end of if(Menus[m, 4]=="File")
					       	   }else if(Menus[m, 3] == "separator"){#end of else if(Menus[m, 3] == "cascade")
						       	  if(nrow(Menus)>m && Menus[m+1, 4]=="Exit"){
							       	  recentFilesFileName <- system.file("etc/recent-files.txt",package="oneChannelGUI")
							       	  recentFiles <- readLines(recentFilesFileName)
							       	  recentFiles <- gsub("\\\\","/",recentFiles)
							       	  # Remove any blank lines:
							       	  blanks <- grep("^[ \t\n]*$",recentFiles)
							       	  if(length(blanks)>0)
								       	  recentFiles <- recentFiles[-blanks]
							       	    numRecentFiles <- length(recentFiles)
							       	  if(numRecentFiles>0){
								       	   tkadd(eval(parse(text=Menus[m, 2])),"separator")
								       	   for (i in (1:numRecentFiles)){
									       	   label <- recentFiles[i]
									       	   fileNameOnly <- strsplit(label,"/")[[1]]
								       	     fileNameOnly <- fileNameOnly[length(fileNameOnly)]
									       	   if(nchar(recentFiles[i])>60)
											         	label <- paste(".../",fileNameOnly)
									       	      eval(parse(text=paste("assign(\".OpenALimmaFile_",i,"\",function() OpenALimmaFile(\"",recentFiles[i],"\"),.GlobalEnv)",sep="")))
									       	   Try(
										       	   if(.Platform$OS.type=="windows"){
											       	   tkadd(
												       	   eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",gsub("/","\\\\",label),sep=""),
												       	   command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	   )#end of tkadd
									       	     }else{
											       	    tkadd(
											       	    eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",label,sep=""),
												       	  command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	 )#end of tkadd
										       	 }#end of else/if
							       	     )#end of Try
								       	 }#end of for (i in (1:numRecentFiles))
							       	 }#end of if(numRecentFiles>0)
						       	 }#end of if(nrow(Menus)>m && Menus[m+1, 4]=="Exit")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"separator")
					       	    }else{
						         	  stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
					       	    }#end of else if(Menus[m, 3] == "separator")
				     	      }else{
					         	    stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
			   	      }#end of else/if(Menus[m, 1] == "item")
			       	)#end of Try(if(Menus[m, 1] == "menu") assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))...)
		       	}#end of for (m in 1:nrow(Menus))
	       	)#end of Try(for (m in 1:nrow(Menus))..)

	       	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
	       	Try(affylmGUIglobals$mainMenu <- topMenu)
	       	Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
    }        
###########################################################################################
          if(whichArrayPlatform=="GENE"){
             #changing the menu to be used for exons data
             Try(topMenu <- tkmenu(.affylmGUIglobals$ttMain))
 	       	   Try(tkconfigure(.affylmGUIglobals$ttMain,menu=topMenu))
	       	   Try(Menus <- read.table(file.path(system.file("etc",package="oneChannelGUI"),"affylmGUI-menus.gene.txt"), as.is=TRUE))
	       	   Try(
		       	   for (m in 1:nrow(Menus)){
			       	   Try(if(Menus[m, 1] == "menu"){
					         	assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))
				       	    }else if(Menus[m, 1] == "item"){
					       	  if(Menus[m, 3] == "command")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"command", label=Menus[m, 4], command=eval(parse(text=Menus[m, 5])))
					       	   else if(Menus[m, 3] == "cascade"){
						       	   cascadeMenu <- eval(parse(text=Menus[m, 5]))
						       	   tkadd(eval(parse(text=Menus[m, 2])),"cascade", label=Menus[m, 4], menu=cascadeMenu)
						       	 if(Menus[m, 4]=="File"){
							         	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
							       	  Try(menuNames <- unique(Menus[,2,drop=TRUE]))
							       	  Try(numMenus <- length(menuNames))
							       	  Try(menus <- list())
							       	  Try(for (j in (1:numMenus))
								       	  menus[[j]] <- eval(parse(text=Menus[j,2]))
							       	  )#end of Try
							       	  Try(names(menus) <- menuNames)
							       	  Try(affylmGUIglobals$menus <- menus)
							       	  Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
						       	   }#end of if(Menus[m, 4]=="File")
					       	   }else if(Menus[m, 3] == "separator"){#end of else if(Menus[m, 3] == "cascade")
						       	  if(nrow(Menus)>m && Menus[m+1, 4]=="Exit"){
							       	  recentFilesFileName <- system.file("etc/recent-files.txt",package="oneChannelGUI")
							       	  recentFiles <- readLines(recentFilesFileName)
							       	  recentFiles <- gsub("\\\\","/",recentFiles)
							       	  # Remove any blank lines:
							       	  blanks <- grep("^[ \t\n]*$",recentFiles)
							       	  if(length(blanks)>0)
								       	  recentFiles <- recentFiles[-blanks]
							       	    numRecentFiles <- length(recentFiles)
							       	  if(numRecentFiles>0){
								       	   tkadd(eval(parse(text=Menus[m, 2])),"separator")
								       	   for (i in (1:numRecentFiles)){
									       	   label <- recentFiles[i]
									       	   fileNameOnly <- strsplit(label,"/")[[1]]
								       	     fileNameOnly <- fileNameOnly[length(fileNameOnly)]
									       	   if(nchar(recentFiles[i])>60)
											         	label <- paste(".../",fileNameOnly)
									       	      eval(parse(text=paste("assign(\".OpenALimmaFile_",i,"\",function() OpenALimmaFile(\"",recentFiles[i],"\"),.GlobalEnv)",sep="")))
									       	   Try(
										       	   if(.Platform$OS.type=="windows"){
											       	   tkadd(
												       	   eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",gsub("/","\\\\",label),sep=""),
												       	   command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	   )#end of tkadd
									       	     }else{
											       	    tkadd(
											       	    eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",label,sep=""),
												       	  command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	 )#end of tkadd
										       	 }#end of else/if
							       	     )#end of Try
								       	 }#end of for (i in (1:numRecentFiles))
							       	 }#end of if(numRecentFiles>0)
						       	 }#end of if(nrow(Menus)>m && Menus[m+1, 4]=="Exit")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"separator")
					       	    }else{
						         	  stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
					       	    }#end of else if(Menus[m, 3] == "separator")
				     	      }else{
					         	    stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
			   	      }#end of else/if(Menus[m, 1] == "item")
			       	)#end of Try(if(Menus[m, 1] == "menu") assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))...)
		       	}#end of for (m in 1:nrow(Menus))
	       	)#end of Try(for (m in 1:nrow(Menus))..)

	       	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
	       	Try(affylmGUIglobals$mainMenu <- topMenu)
	       	Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
    }        
###############################################################################
          if(whichArrayPlatform=="EXON"){
             #changing the menu to be used for exons data
             Try(topMenu <- tkmenu(.affylmGUIglobals$ttMain))
 	       	   Try(tkconfigure(.affylmGUIglobals$ttMain,menu=topMenu))
	       	   Try(Menus <- read.table(file.path(system.file("etc",package="oneChannelGUI"),"affylmGUI-menus.exon.txt"), as.is=TRUE))
	       	   Try(
		       	   for (m in 1:nrow(Menus)){
			       	   Try(if(Menus[m, 1] == "menu"){
					         	assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))
				       	    }else if(Menus[m, 1] == "item"){
					       	  if(Menus[m, 3] == "command")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"command", label=Menus[m, 4], command=eval(parse(text=Menus[m, 5])))
					       	   else if(Menus[m, 3] == "cascade"){
						       	   cascadeMenu <- eval(parse(text=Menus[m, 5]))
						       	   tkadd(eval(parse(text=Menus[m, 2])),"cascade", label=Menus[m, 4], menu=cascadeMenu)
						       	 if(Menus[m, 4]=="File"){
							         	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
							       	  Try(menuNames <- unique(Menus[,2,drop=TRUE]))
							       	  Try(numMenus <- length(menuNames))
							       	  Try(menus <- list())
							       	  Try(for (j in (1:numMenus))
								       	  menus[[j]] <- eval(parse(text=Menus[j,2]))
							       	  )#end of Try
							       	  Try(names(menus) <- menuNames)
							       	  Try(affylmGUIglobals$menus <- menus)
							       	  Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
						       	   }#end of if(Menus[m, 4]=="File")
					       	   }else if(Menus[m, 3] == "separator"){#end of else if(Menus[m, 3] == "cascade")
						       	  if(nrow(Menus)>m && Menus[m+1, 4]=="Exit"){
							       	  recentFilesFileName <- system.file("etc/recent-files.txt",package="oneChannelGUI")
							       	  recentFiles <- readLines(recentFilesFileName)
							       	  recentFiles <- gsub("\\\\","/",recentFiles)
							       	  # Remove any blank lines:
							       	  blanks <- grep("^[ \t\n]*$",recentFiles)
							       	  if(length(blanks)>0)
								       	  recentFiles <- recentFiles[-blanks]
							       	    numRecentFiles <- length(recentFiles)
							       	  if(numRecentFiles>0){
								       	   tkadd(eval(parse(text=Menus[m, 2])),"separator")
								       	   for (i in (1:numRecentFiles)){
									       	   label <- recentFiles[i]
									       	   fileNameOnly <- strsplit(label,"/")[[1]]
								       	     fileNameOnly <- fileNameOnly[length(fileNameOnly)]
									       	   if(nchar(recentFiles[i])>60)
											         	label <- paste(".../",fileNameOnly)
									       	      eval(parse(text=paste("assign(\".OpenALimmaFile_",i,"\",function() OpenALimmaFile(\"",recentFiles[i],"\"),.GlobalEnv)",sep="")))
									       	   Try(
										       	   if(.Platform$OS.type=="windows"){
											       	   tkadd(
												       	   eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",gsub("/","\\\\",label),sep=""),
												       	   command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	   )#end of tkadd
									       	     }else{
											       	    tkadd(
											       	    eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",label,sep=""),
												       	  command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	 )#end of tkadd
										       	 }#end of else/if
							       	     )#end of Try
								       	 }#end of for (i in (1:numRecentFiles))
							       	 }#end of if(numRecentFiles>0)
						       	 }#end of if(nrow(Menus)>m && Menus[m+1, 4]=="Exit")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"separator")
					       	    }else{
						         	  stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
					       	    }#end of else if(Menus[m, 3] == "separator")
				     	      }else{
					         	    stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
			   	      }#end of else/if(Menus[m, 1] == "item")
			       	)#end of Try(if(Menus[m, 1] == "menu") assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))...)
		       	}#end of for (m in 1:nrow(Menus))
	       	)#end of Try(for (m in 1:nrow(Menus))..)

	       	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
	       	Try(affylmGUIglobals$mainMenu <- topMenu)
	       	Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
    }        
 ###########################################################################
           if(whichArrayPlatform=="ILLU"){
             #changing the menu to be used for exons data
             Try(topMenu <- tkmenu(.affylmGUIglobals$ttMain))
 	       	   Try(tkconfigure(.affylmGUIglobals$ttMain,menu=topMenu))
	       	   Try(Menus <- read.table(file.path(system.file("etc",package="oneChannelGUI"),"affylmGUI-menus.illumina.txt"), as.is=TRUE))
	       	   Try(
		       	   for (m in 1:nrow(Menus)){
			       	   Try(if(Menus[m, 1] == "menu"){
					         	assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))
				       	    }else if(Menus[m, 1] == "item"){
					       	  if(Menus[m, 3] == "command")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"command", label=Menus[m, 4], command=eval(parse(text=Menus[m, 5])))
					       	   else if(Menus[m, 3] == "cascade"){
						       	   cascadeMenu <- eval(parse(text=Menus[m, 5]))
						       	   tkadd(eval(parse(text=Menus[m, 2])),"cascade", label=Menus[m, 4], menu=cascadeMenu)
						       	 if(Menus[m, 4]=="File"){
							         	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
							       	  Try(menuNames <- unique(Menus[,2,drop=TRUE]))
							       	  Try(numMenus <- length(menuNames))
							       	  Try(menus <- list())
							       	  Try(for (j in (1:numMenus))
								       	  menus[[j]] <- eval(parse(text=Menus[j,2]))
							       	  )#end of Try
							       	  Try(names(menus) <- menuNames)
							       	  Try(affylmGUIglobals$menus <- menus)
							       	  Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
						       	   }#end of if(Menus[m, 4]=="File")
					       	   }else if(Menus[m, 3] == "separator"){#end of else if(Menus[m, 3] == "cascade")
						       	  if(nrow(Menus)>m && Menus[m+1, 4]=="Exit"){
							       	  recentFilesFileName <- system.file("etc/recent-files.txt",package="oneChannelGUI")
							       	  recentFiles <- readLines(recentFilesFileName)
							       	  recentFiles <- gsub("\\\\","/",recentFiles)
							       	  # Remove any blank lines:
							       	  blanks <- grep("^[ \t\n]*$",recentFiles)
							       	  if(length(blanks)>0)
								       	  recentFiles <- recentFiles[-blanks]
							       	    numRecentFiles <- length(recentFiles)
							       	  if(numRecentFiles>0){
								       	   tkadd(eval(parse(text=Menus[m, 2])),"separator")
								       	   for (i in (1:numRecentFiles)){
									       	   label <- recentFiles[i]
									       	   fileNameOnly <- strsplit(label,"/")[[1]]
								       	     fileNameOnly <- fileNameOnly[length(fileNameOnly)]
									       	   if(nchar(recentFiles[i])>60)
											         	label <- paste(".../",fileNameOnly)
									       	      eval(parse(text=paste("assign(\".OpenALimmaFile_",i,"\",function() OpenALimmaFile(\"",recentFiles[i],"\"),.GlobalEnv)",sep="")))
									       	   Try(
										       	   if(.Platform$OS.type=="windows"){
											       	   tkadd(
												       	   eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",gsub("/","\\\\",label),sep=""),
												       	   command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	   )#end of tkadd
									       	     }else{
											       	    tkadd(
											       	    eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",label,sep=""),
												       	  command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	 )#end of tkadd
										       	 }#end of else/if
							       	     )#end of Try
								       	 }#end of for (i in (1:numRecentFiles))
							       	 }#end of if(numRecentFiles>0)
						       	 }#end of if(nrow(Menus)>m && Menus[m+1, 4]=="Exit")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"separator")
					       	    }else{
						         	  stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
					       	    }#end of else if(Menus[m, 3] == "separator")
				     	      }else{
					         	    stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
			   	      }#end of else/if(Menus[m, 1] == "item")
			       	)#end of Try(if(Menus[m, 1] == "menu") assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))...)
		       	}#end of for (m in 1:nrow(Menus))
	       	)#end of Try(for (m in 1:nrow(Menus))..)

	       	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
	       	Try(affylmGUIglobals$mainMenu <- topMenu)
	       	Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
    }
    
 ###########################################################################################
          if(whichArrayPlatform=="LARGE"){
             #changing the menu to be used for exons data
             Try(topMenu <- tkmenu(.affylmGUIglobals$ttMain))
 	       	   Try(tkconfigure(.affylmGUIglobals$ttMain,menu=topMenu))
	       	   Try(Menus <- read.table(file.path(system.file("etc",package="oneChannelGUI"),"affylmGUI-menus.large.datasets.txt"), as.is=TRUE))
	       	   Try(
		       	   for (m in 1:nrow(Menus)){
			       	   Try(if(Menus[m, 1] == "menu"){
					         	assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))
				       	    }else if(Menus[m, 1] == "item"){
					       	  if(Menus[m, 3] == "command")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"command", label=Menus[m, 4], command=eval(parse(text=Menus[m, 5])))
					       	   else if(Menus[m, 3] == "cascade"){
						       	   cascadeMenu <- eval(parse(text=Menus[m, 5]))
						       	   tkadd(eval(parse(text=Menus[m, 2])),"cascade", label=Menus[m, 4], menu=cascadeMenu)
						       	 if(Menus[m, 4]=="File"){
							         	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
							       	  Try(menuNames <- unique(Menus[,2,drop=TRUE]))
							       	  Try(numMenus <- length(menuNames))
							       	  Try(menus <- list())
							       	  Try(for (j in (1:numMenus))
								       	  menus[[j]] <- eval(parse(text=Menus[j,2]))
							       	  )#end of Try
							       	  Try(names(menus) <- menuNames)
							       	  Try(affylmGUIglobals$menus <- menus)
							       	  Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
						       	   }#end of if(Menus[m, 4]=="File")
					       	   }else if(Menus[m, 3] == "separator"){#end of else if(Menus[m, 3] == "cascade")
						       	  if(nrow(Menus)>m && Menus[m+1, 4]=="Exit"){
							       	  recentFilesFileName <- system.file("etc/recent-files.txt",package="oneChannelGUI")
							       	  recentFiles <- readLines(recentFilesFileName)
							       	  recentFiles <- gsub("\\\\","/",recentFiles)
							       	  # Remove any blank lines:
							       	  blanks <- grep("^[ \t\n]*$",recentFiles)
							       	  if(length(blanks)>0)
								       	  recentFiles <- recentFiles[-blanks]
							       	    numRecentFiles <- length(recentFiles)
							       	  if(numRecentFiles>0){
								       	   tkadd(eval(parse(text=Menus[m, 2])),"separator")
								       	   for (i in (1:numRecentFiles)){
									       	   label <- recentFiles[i]
									       	   fileNameOnly <- strsplit(label,"/")[[1]]
								       	     fileNameOnly <- fileNameOnly[length(fileNameOnly)]
									       	   if(nchar(recentFiles[i])>60)
											         	label <- paste(".../",fileNameOnly)
									       	      eval(parse(text=paste("assign(\".OpenALimmaFile_",i,"\",function() OpenALimmaFile(\"",recentFiles[i],"\"),.GlobalEnv)",sep="")))
									       	   Try(
										       	   if(.Platform$OS.type=="windows"){
											       	   tkadd(
												       	   eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",gsub("/","\\\\",label),sep=""),
												       	   command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	   )#end of tkadd
									       	     }else{
											       	    tkadd(
											       	    eval(parse(text=Menus[m,2])),"command",label=paste(i,". ",label,sep=""),
												       	  command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))
											       	 )#end of tkadd
										       	 }#end of else/if
							       	     )#end of Try
								       	 }#end of for (i in (1:numRecentFiles))
							       	 }#end of if(numRecentFiles>0)
						       	 }#end of if(nrow(Menus)>m && Menus[m+1, 4]=="Exit")
						       	  tkadd(eval(parse(text=Menus[m, 2])),"separator")
					       	    }else{
						         	  stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
					       	    }#end of else if(Menus[m, 3] == "separator")
				     	      }else{
					         	    stop(paste("menu defintion error:", Menus[m, ], collapse=" "))
			   	      }#end of else/if(Menus[m, 1] == "item")
			       	)#end of Try(if(Menus[m, 1] == "menu") assign(Menus[m, 2], tkmenu(eval(parse(text=Menus[m, 3])), tearoff=FALSE))...)
		       	}#end of for (m in 1:nrow(Menus))
	       	)#end of Try(for (m in 1:nrow(Menus))..)

	       	Try(affylmGUIglobals <- get(".affylmGUIglobals",envir=affylmGUIenvironment))
	       	Try(affylmGUIglobals$mainMenu <- topMenu)
	       	Try(assign(".affylmGUIglobals",affylmGUIglobals,.GlobalEnv))
    }        
}
################################################################################

#modified on 16 12 2006 adding the load of large data set as tab delimited files
"OpenLargefiles" <- function()
{
	Require("affy")
	Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttExonandTargets))
	Try(tkgrab.set(ttExonandTargets))
	Try(tkfocus(ttExonandTargets))
	Try(tkwm.title(ttExonandTargets,"Targets file"))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	OpenTargetsFileAndSetCursor <- function()
	{
			Try(tkconfigure(ttExonandTargets,cursor="watch"))
			Try(tkfocus(ttExonandTargets))
			Try(OpenTargetsFile())
			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			Try(tkfocus(ttExonandTargets))
	}

#	OpenExonFileAndSetCursor <- function()
#	{
#			Try(tkconfigure(ttExonandTargets,cursor="watch"))
#			Try(tkfocus(ttExonandTargets))
#			Try(OpenExonFile())
#			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
#			Try(tkfocus(ttExonandTargets))
#	}

#	Try(OpenExonFile.but <- tkbutton(ttExonandTargets, text="Select Exon File",command=OpenExonFile,font=.affylmGUIglobals$affylmGUIfont2))
	Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	#Try(tclvalue(.affylmGUIglobals$CDFfileName) <- fixSeps(tclvalue(.affylmGUIglobals$CDFfileName)))
	#Try(.affylmGUIglobals$CDFfileBoxTitleLabel<-tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	#Try(.affylmGUIglobals$CDFfileNameLabel<-tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$CDFfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	#Try(tkconfigure(.affylmGUIglobals$CDFfileBoxTitleLabel, textvariable=.affylmGUIglobals$CDFfileBoxTitle))
	#Try(tkconfigure(.affylmGUIglobals$CDFfileNameLabel, textvariable=.affylmGUIglobals$CDFfileName))

#	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
#	Try(tkgrid(.affylmGUIglobals$CDFfileBoxTitleLabel,columnspan=4))
#	Try(tkgrid(.affylmGUIglobals$CDFfileNameLabel,columnspan=4))

	Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

#	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
#	Try(tkgrid(tklabel(ttCDFandTargets,text="    "),OpenCDFFile.but, OpenTargetsFile.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
	Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	Try(Abort <- 1)
	onOK <- function()
	{
#			Try(cdf		 <- get("cdf",envir=affylmGUIenvironment))
			Try(Targets <- get("Targets",envir=affylmGUIenvironment))
#			Try(if(length(cdf)==0)
#			{
#				Try(tkmessageBox(title="CDF (Chip Definition) File",message=paste("Either you did not specify a valid CDF (Chip Definition File",
#					"or an error occurred while reading in the CDF file.	It should be in tab-delimited text format and it should include the column headings \"Block\", \"Column\", \"Row\", \"Name\" and \"ID\"."),icon="error"))
#				onCancel()
#				return()
#			})
			Try(if(length(Targets)==0)
			{
				Try(tkmessageBox(title="RNA Targets File",message=paste("Either you did not specify a valid RNA Targets File",
					"or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				onCancel()
#				return()
			})
			Try(tkgrab.release(ttExonandTargets));
			Try(tkdestroy(ttExonandTargets));
			Try(tkfocus(.affylmGUIglobals$ttMain))
			Try(Abort <<- 0)
	}
	onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	Try(tkfocus(ttExonandTargets))
	Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkwait.window(ttExonandTargets))

	if(Abort==1)
				return(0)

	#OK
	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
	Try(tkfocus(.affylmGUIglobals$ttMain))
	Try(Targets <- get("Targets",affylmGUIenvironment))
	Try(slides <- Targets$FileName)
	#################################################
  #not used for exons from expression console
  #Try(filesExist <- file.exists(slides))
	#Try(filesWhichDontExist <- slides[!filesExist])
	#Try(if(length(filesWhichDontExist)>0)
	#	Try(for (i in (1:length(filesWhichDontExist)))
	#		Try(tkmessageBox(title="Error opening file",message=paste("Failed to open file: \"",filesWhichDontExist[i],"\"",sep=""),icon="error"))))
	#Try(if(length(filesWhichDontExist)>0)
	#{
	#	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	#	return(0)
	#})
  #########################################################

  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
  Try(rownames(Targets) <- Targets$FileName) 
  Try(var.tmp.pd<-data.frame(names(Targets)))
  Try(names(var.tmp.pd)<-"labelDescription" )
  Try(rownames(var.tmp.pd)<-names(Targets))
  Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
  Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
  Try(my.exons <- OpenLargeFile())#loading gene level data
  Try(my.exons.array.names <- NULL)
  Try(    for( i in 1:length(target.array.names)){
          if(length(grep(target.array.names[i], names(my.exons))) == 1){
              my.exons.array.names[i] <- grep(target.array.names[i], names(my.exons))
          } else{
               error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], names(my.exons))],sep=","), "\n", sep="")
               cat("\nERROR! Filenames are not unique!\n")
               cat(error.message)
               cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
               Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
               return()
          }
      })
  Try(my.exons <- my.exons[,my.exons.array.names])
  Try(names(my.exons) <-  tmp1.pd$FileName)

  Try(startFun <- tclvalue(tkmessageBox(title="Log transformation",message="Do you wish to log2 transform your data?",type="yesno",icon="question")))
  Try(if (startFun=="yes"){my.exons <- log2(my.exons)})

  Try(NormalizedAffyData <- new("ExpressionSet", exprs=as.matrix(my.exons), phenoData=tmp1.pd, annotation=""))
	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
        Try(assign("NormalizedAffyData.Available",TRUE,affylmGUIenvironment))
	Try(assign("NormalizedAffyData",NormalizedAffyData,affylmGUIenvironment))
        Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Normalized data from tab delimited file",font=.affylmGUIglobals$affylmGUIfontTree))

	Try(if("Name" %in% colnames(Targets))
	SlideNamesVec <- Targets$Name)
	Try(assign("SlideNamesVec",SlideNamesVec,affylmGUIenvironment))
	Try(assign("ArraysLoaded",TRUE,affylmGUIenvironment))

 	Try(ReturnVal <- GetlimmaDataSetName())
	if(ReturnVal==0) return(0)
	return(1)


}
#loading the tab delimited file
OpenLargeFile <- function(){
          Try(tkmessageBox(title="Large data set analysis",message="Open the file, containing the normalized expression data.
          This file should be tab delimited with identifiers in first 
          row and array names in the header.\n"))  
          my.exons <- OpenAFile()
}


OpenAFile <- function(FileName)
      {
         Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
               if(!nchar(tempFileName))
               {
                  tkfocus(.affylmGUIglobals$ttMain)
                  return()
               }
         mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, row.names=1)
         return(mySel)
      }
################################################################################

#modified on 16 12 2006 adding the load of large data set as tab delimited files
"OpenGeoFiles" <- function()
{
	Require("affy")
	Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttExonandTargets))
	Try(tkgrab.set(ttExonandTargets))
	Try(tkfocus(ttExonandTargets))
	Try(tkwm.title(ttExonandTargets,"Targets file"))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	OpenTargetsFileAndSetCursor <- function()
	{
			Try(tkconfigure(ttExonandTargets,cursor="watch"))
			Try(tkfocus(ttExonandTargets))
			Try(OpenTargetsFile())
			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			Try(tkfocus(ttExonandTargets))
	}

#	OpenExonFileAndSetCursor <- function()
#	{
#			Try(tkconfigure(ttExonandTargets,cursor="watch"))
#			Try(tkfocus(ttExonandTargets))
#			Try(OpenExonFile())
#			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
#			Try(tkfocus(ttExonandTargets))
#	}

#	Try(OpenExonFile.but <- tkbutton(ttExonandTargets, text="Select Exon File",command=OpenExonFile,font=.affylmGUIglobals$affylmGUIfont2))
	Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	#Try(tclvalue(.affylmGUIglobals$CDFfileName) <- fixSeps(tclvalue(.affylmGUIglobals$CDFfileName)))
	#Try(.affylmGUIglobals$CDFfileBoxTitleLabel<-tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	#Try(.affylmGUIglobals$CDFfileNameLabel<-tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$CDFfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	#Try(tkconfigure(.affylmGUIglobals$CDFfileBoxTitleLabel, textvariable=.affylmGUIglobals$CDFfileBoxTitle))
	#Try(tkconfigure(.affylmGUIglobals$CDFfileNameLabel, textvariable=.affylmGUIglobals$CDFfileName))

#	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
#	Try(tkgrid(.affylmGUIglobals$CDFfileBoxTitleLabel,columnspan=4))
#	Try(tkgrid(.affylmGUIglobals$CDFfileNameLabel,columnspan=4))

	Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

#	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
#	Try(tkgrid(tklabel(ttCDFandTargets,text="    "),OpenCDFFile.but, OpenTargetsFile.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
	Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	Try(Abort <- 1)
	onOK <- function()
	{
#			Try(cdf		 <- get("cdf",envir=affylmGUIenvironment))
			Try(Targets <- get("Targets",envir=affylmGUIenvironment))
#			Try(if(length(cdf)==0)
#			{
#				Try(tkmessageBox(title="CDF (Chip Definition) File",message=paste("Either you did not specify a valid CDF (Chip Definition File",
#					"or an error occurred while reading in the CDF file.	It should be in tab-delimited text format and it should include the column headings \"Block\", \"Column\", \"Row\", \"Name\" and \"ID\"."),icon="error"))
#				onCancel()
#				return()
#			})
			Try(if(length(Targets)==0)
			{
				Try(tkmessageBox(title="RNA Targets File",message=paste("Either you did not specify a valid RNA Targets File",
					"or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				onCancel()
				return()
			})
			Try(tkgrab.release(ttExonandTargets));
			Try(tkdestroy(ttExonandTargets));
			Try(tkfocus(.affylmGUIglobals$ttMain))
			Try(Abort <<- 0)
	}
	onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	Try(tkfocus(ttExonandTargets))
	Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkwait.window(ttExonandTargets))

	if(Abort==1)
				return(0)

	#OK
	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
	Try(tkfocus(.affylmGUIglobals$ttMain))
	Try(Targets <- get("Targets",affylmGUIenvironment))
	Try(slides <- Targets$FileName)
	#################################################
  #not used for exons from expression console
  #Try(filesExist <- file.exists(slides))
	#Try(filesWhichDontExist <- slides[!filesExist])
	#Try(if(length(filesWhichDontExist)>0)
	#	Try(for (i in (1:length(filesWhichDontExist)))
	#		Try(tkmessageBox(title="Error opening file",message=paste("Failed to open file: \"",filesWhichDontExist[i],"\"",sep=""),icon="error"))))
	#Try(if(length(filesWhichDontExist)>0)
	#{
	#	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	#	return(0)
	#})
  #########################################################

  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
  Try(rownames(Targets) <- Targets$FileName) 
  Try(var.tmp.pd<-data.frame(names(Targets)))
  Try(names(var.tmp.pd)<-"labelDescription" )
  Try(rownames(var.tmp.pd)<-names(Targets))
  Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
  Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
  Try(my.exons <- OpenGeoFile())#loading gene level data
  Try(my.exons.array.names <- NULL)
  Try(    for( i in 1:length(target.array.names)){
                    if(length(grep(target.array.names[i], names(my.exons))) == 1){
                       my.exons.array.names[i] <- grep(target.array.names[i], names(my.exons))
                       } else{
                              error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], names(my.exons))],sep=","), "\n", sep="")
                              cat("\nERROR! Filenames are not unique!\n")
                              cat(error.message)
                              cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
                              Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                              return()
                       }
      })
  Try(my.exons <- my.exons[,my.exons.array.names])
  Try(names(my.exons) <-  tmp1.pd$FileName)
  Try(startFun <- tclvalue(tkmessageBox(title="Log transformation",message="Do you wish to log2 transform your data?",type="yesno",icon="question")))
       Try(if (startFun=="yes"){my.exons <- log2(my.exons)})
  ########adding bioc annlib to geo data
  Try(data("geoVSbioc",package="oneChannelGUI"))
  Try(geoPlatform <- get("geoPlatform", env=affylmGUIenvironment))
  
  if(geoPlatform == "") {Try(geoAnn <- "")} else{
         Try(geoAnn.loc <- which(geoVSbioc[,1]==geoPlatform))
         if(length(geoAnn.loc)==1){
                Try(geoAnn <- geoVSbioc[geoAnn.loc,4])
         } else Try(geoAnn <- "")
  }
  ########adding bioc annlib to geo data
  
  Try(NormalizedAffyData <- new("ExpressionSet", exprs=as.matrix(my.exons), phenoData=tmp1.pd, annotation=geoAnn))
	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
        Try(assign("NormalizedAffyData.Available",TRUE,affylmGUIenvironment))
	Try(assign("NormalizedAffyData",NormalizedAffyData,affylmGUIenvironment))
        Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Normalized data from GEO Series Matrix file",font=.affylmGUIglobals$affylmGUIfontTree))

	Try(if("Name" %in% colnames(Targets))
	SlideNamesVec <- Targets$Name)
	Try(assign("SlideNamesVec",SlideNamesVec,affylmGUIenvironment))
	Try(assign("ArraysLoaded",TRUE,affylmGUIenvironment))

 	Try(ReturnVal <- GetlimmaDataSetName())
	if(ReturnVal==0) return(0)
	return(1)


}
#loading the tab delimited file
OpenGeoFile <- function(){
          Try(tkmessageBox(title="Large data set analysis",message="Open the GEO Series Matrix file."))  
          my.exons <- OpenAGeoFile()
}


OpenAGeoFile <- function(FileName)
      {
         Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
               if(!nchar(tempFileName))
               {
                  tkfocus(.affylmGUIglobals$ttMain)
                  return()
               }
           ##start grabbing GEO platform info
           Try(con <- file(tempFileName, "r", blocking = FALSE))
           Try(geoInfo <- readLines(con, n=500))
           Try(close(con))
           Try(geoPlatform <- geoInfo[grep("^!Series_platform_id", geoInfo)])
           Try(geoPlatform <- strsplit(geoPlatform, "\\\""))
           Try(geoPlatform <- unlist(geoPlatform))
           Try(geoPlatform <- geoPlatform[2])
           Try(assign("geoPlatform",  geoPlatform, env=affylmGUIenvironment))
           ##end grabbing GEO platform info
           whereSkip <- grep("^!series_matrix_table_begin", geoInfo)
           mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, row.names=1, skip=whereSkip, fill=T)
           mySel <- mySel[1:(dim(mySel)[1] - 1),]
           return(mySel)
      }
################################################################################


OpenLimmaFile <- function() OpenALimmaFile()

OpenALimmaFile <- function(FileName)
{
	Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
	Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	Try(if(missing(FileName))
	{
		Try(tempLimmaFileName <- tclvalue(tkgetOpenFile(filetypes="{{Limma Files} {.lma}} {{All files} *}")))
		if(!nchar(tempLimmaFileName))
		{
			tkfocus(.affylmGUIglobals$ttMain)
			return()
		}
	}
	else
		tempLimmaFileName <- FileName)

	Try(if(!nchar(tempLimmaFileName))
	{
		tkfocus(.affylmGUIglobals$ttMain)
		return()
	})
	Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
	Try(if(limmaDataSetNameText!="Untitled")
	{
			Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled")	LimmaFileName <- limmaDataSetNameText)	# Local assignment only
	#		Try(mbVal <- tkmessageBox(title="Open File",
	#					message=paste("Save changes to ",fixSeps(LimmaFileName),"?",sep=""),
	#					icon="question",type="yesnocancel",default="yes"))
	#		Try(if(tclvalue(mbVal)=="yes")
	#				SaveLimmaFile())
	#		Try(if(tclvalue(mbVal)=="cancel")
	#				return())
	})
	Try(LimmaFileName <- tempLimmaFileName)
	Try(assign("LimmaFileName",LimmaFileName,affylmGUIenvironment))

	Try(recentFilesFileName <- system.file("etc/recent-files.txt",package="oneChannelGUI"))
	Try(recentFiles <- readLines(recentFilesFileName))

	Try(recentFiles <- gsub("\\\\","/",recentFiles))

	# Remove any blank lines:
	Try(blanks <- grep("^[ \t\n]*$",recentFiles))
	Try(if(length(blanks)>0)
		recentFiles <- recentFiles[-blanks])
	Try(numRecentFiles <- length(recentFiles))

	Try(if(length(grep(LimmaFileName,recentFiles))==0)
		recentFiles <- c(LimmaFileName,recentFiles))
	Try(if(length(recentFiles)>4)
		recentFiles <- recentFiles[1:4])
	try(writeLines(con=recentFilesFileName,recentFiles),TRUE)
	Try(numRecentFiles <- length(recentFiles))

	Try(if(numRecentFiles>0)
	{
		Try(fileMenu <- .affylmGUIglobals$menus$fileMenu)
		Try(workingDirIndex <- as.numeric(tclvalue(tkindex(.affylmGUIglobals$menus$fileMenu,"affylmGUI: Working Directory"))))
		Try(exitIndex <- as.numeric(tclvalue(tkindex(.affylmGUIglobals$menus$fileMenu,"affylmGUI: Exit"))))
		Try(if(exitIndex==workingDirIndex+2)
			Try(numRecentFilesInMenu <- 0)
		else
		{
			Try(numRecentFilesInMenu <- exitIndex - workingDirIndex - 3)
			Try(for (i in (1:(numRecentFilesInMenu+1)))
				Try(tkdelete(fileMenu,workingDirIndex+2)))
		})
		Try(tkinsert(fileMenu,workingDirIndex+1,"separator"))

		Try(for (i in (numRecentFiles:1))
		{
			Try(label <- recentFiles[i])
			Try(fileNameOnly <- strsplit(label,"/")[[1]])
			Try(fileNameOnly <- fileNameOnly[length(fileNameOnly)])
			Try(if(nchar(recentFiles[i])>60)
					label <- paste(".../",fileNameOnly))
			Try(eval(parse(text=paste("assign(\".OpenALimmaFile_",i,"\",function() OpenALimmaFile(\"",recentFiles[i],"\"),.GlobalEnv)",sep=""))))
			Try(if(.Platform$OS.type=="windows")
				Try(tkinsert(fileMenu,workingDirIndex+2,"command",label=paste(i,". ",gsub("/","\\\\",label),sep=""),
					command=eval(parse(text=paste(".OpenALimmaFile_",i,sep="")))))
			else
				Try(tkinsert(fileMenu,workingDirIndex+2,"command",label=paste(i,". ",label,sep=""),
					command=eval(parse(text=paste(".OpenALimmaFile_",i,sep=""))))))
		})
	})

	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
	Try(tkfocus(.affylmGUIglobals$ttMain))

	Try(NumParameters <- get("NumParameters",envir=affylmGUIenvironment))
	Try(NumContrastParameterizations <- get("NumContrastParameterizations",envir=affylmGUIenvironment))
	Try(ContrastParameterizationList <- get("ContrastParameterizationList",envir=affylmGUIenvironment))
	Try(ContrastParameterizationTREEIndexVec <- get("ContrastParameterizationTREEIndexVec",envir=affylmGUIenvironment))

# Using existing NumContrastParameterizations, NOT the one loaded from the .lma file.
# (We haven't loaded it yet.)
	Try(OldNumParameters <- NumParameters)

	Try(if(NumContrastParameterizations>0)
		Try(for (contrastParameterizationIndex in (1:NumContrastParameterizations))
		{
			Try(.affylmGUIglobals$ContrastParameterizationTREEIndex <- ContrastParameterizationTREEIndexVec[contrastParameterizationIndex])
			Try(ContrastParameterizationNameNode <- paste("ContrastParameterizationName.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			Try(tkdelete(.affylmGUIglobals$ContrastParameterizationTREE,ContrastParameterizationNameNode))
			Try(assign("ContrastParameterizationList",deleteItemFromList(ContrastParameterizationList,ContrastParameterizationNameNode),affylmGUIenvironment))
		}))

	# Load the RData File whose name is "LimmaFileName"
	Try(load(LimmaFileName,envir=affylmGUIenvironment))

	# The user may have changed the filename in the operating system since the last save.
	Try(LimmaFileName <- tempLimmaFileName)
	Try(assign("LimmaFileName",LimmaFileName,affylmGUIenvironment))

	Try(limmaDataSetNameText <- get("limmaDataSetNameText" , envir=affylmGUIenvironment))
	Try(ContrastParameterizationNamesVec <- get("ContrastParameterizationNamesVec", envir=affylmGUIenvironment))
	Try(NumContrastParameterizations <- get("NumContrastParameterizations", envir=affylmGUIenvironment))
	Try(ContrastParameterizationTREEIndexVec <- get("ContrastParameterizationTREEIndexVec",envir=affylmGUIenvironment))
	Try(NumParameters <- get("NumParameters" , envir=affylmGUIenvironment))
	Try(ContrastParameterizationList <- get("ContrastParameterizationList",envir=affylmGUIenvironment))

	Try(LimmaFileName <- get("LimmaFileName",envir=affylmGUIenvironment))
	Try(if(LimmaFileName=="Untitled" && limmaDataSetNameText!="Untitled") LimmaFileName <- limmaDataSetNameText) # Local assignment only
	Try(if(.Platform$OS.type=="windows")
		Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",gsub("/","\\\\",LimmaFileName))))
	else
		Try(tkwm.title(.affylmGUIglobals$ttMain,paste("You are now using oneChannelGUI. A add-on package extending the capabilities of affylmGUI -",LimmaFileName))))
	Try(assign("limmaDataSetNameText",limmaDataSetNameText,affylmGUIenvironment))
	Try(tclvalue(.affylmGUIglobals$limmaDataSetNameTcl) <- limmaDataSetNameText)

	Try(tkdelete(.affylmGUIglobals$mainTree,"RawAffyData.Status"))
	Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	Try(tkdelete(.affylmGUIglobals$mainTree,"LinearModelFit.Status"))
###################new items
  Try(tkdelete(.affylmGUIglobals$mainTree,"maSIgProData.Status"))
	Try(tkdelete(.affylmGUIglobals$mainTree,"PLM.Status"))
	Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))
  Try(tkdelete(.affylmGUIglobals$mainTree,"AptDabg.Status"))
  Try(tkdelete(.affylmGUIglobals$mainTree,"AptMidas.Status"))            
	Try(tkdelete(.affylmGUIglobals$mainTree,"spliceIndex.Status"))
  Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.e.Status"))            
  Try(tkdelete(.affylmGUIglobals$mainTree,"AltSplRP.g.Status"))            
  Try(tkdelete(.affylmGUIglobals$mainTree,"metaData.Status"))            
  Try(tkdelete(.affylmGUIglobals$mainTree,"classification.Status"))            
	

	
	
	
############################	

	
	Try(if(OldNumParameters>0)
		Try(for (i in (1:OldNumParameters))
			Try(tkdelete(.affylmGUIglobals$mainTree,paste("Parameters.Status.",i,sep=""))))
	else
			Try(tkdelete(.affylmGUIglobals$mainTree,"Parameters.Status.1")))
	Try(if(NumContrastParameterizations>0)
		Try(for (i in (1:NumContrastParameterizations))
			Try(tkdelete(.affylmGUIglobals$mainTree,paste("ContrastParameterizations.Status.",i,sep=""))))
	else
			Try(tkdelete(.affylmGUIglobals$mainTree,"ContrastParameterizations.Status.1")))

	Try(RawAffyData.Available						<- get("RawAffyData.Available" , envir=affylmGUIenvironment))
	Try(NormalizedAffyData.Available		 <- get("NormalizedAffyData.Available" , envir=affylmGUIenvironment))
	Try(LinearModelFit.Available				 <- get("LinearModelFit.Available" , envir=affylmGUIenvironment))
##############################
  Try(maSigProSigs.Available						<- get("maSigProSigs.Available" , envir=affylmGUIenvironment))
	Try(Pset.Available		              <- get("Pset.Available" , envir=affylmGUIenvironment))
	Try(exonAffyData.Available				 <- get("exonAffyData.Available" , envir=affylmGUIenvironment))
	Try(dabg.Available				         <- get("dabg.Available" , envir=affylmGUIenvironment))
	Try(midas.p.Available		     		 <- get("midas.p.Available" , envir=affylmGUIenvironment))
	Try(spliceIndexData.Available				 <- get("spliceIndexData.Available" , envir=affylmGUIenvironment))
	Try(AltSplRP.e.Available				 <- get("AltSplRP.e.Available" , envir=affylmGUIenvironment))
	Try(AltSplRP.g.Available				 <- get("AltSplRP.g.Available" , envir=affylmGUIenvironment))
	Try(MLdesign.Available				 <- get("MLdesign.Available" , envir=affylmGUIenvironment))
	Try(metaData.Available				 <- get("metaData.Available" , envir=affylmGUIenvironment))
##############################

	Try(if(RawAffyData.Available)
		Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree))
	else
		Try(tkinsert(.affylmGUIglobals$mainTree,"end","RawAffyData","RawAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))		)
	Try(if(exists("NormMethod",envir=affylmGUIenvironment))
		Try(NormMethod <- get("NormMethod",envir=affylmGUIenvironment))
	else
		Try(NormMethod <- "RMA"))
	Try(if(NormalizedAffyData.Available)
		Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text=paste("Available (",NormMethod,")",sep=""),font=.affylmGUIglobals$affylmGUIfontTree))
	else
		Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree))		)
	Try(if(LinearModelFit.Available)
		Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFit","LinearModelFit.Status",text="Available",font=.affylmGUIglobals$affylmGUIfontTree))
	else
		Try(tkinsert(.affylmGUIglobals$mainTree,"end","LinearModelFit","LinearModelFit.Status",text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)))

###########################################
	Try(if(maSigProSigs.Available){
		     tkinsert(.affylmGUIglobals$mainTree,"end","maSIgProData","maSIgProData.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree)
	       require(maSigPro) || stop("library maSigPro could not be found !")
      }
      else
		     tkinsert(.affylmGUIglobals$mainTree,"end","maSIgProData","maSIgProData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)
 )
	Try(if(exonAffyData.Available)
		      tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree)
	  else
		      tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)
	)

	Try(if(dabg.Available)
          tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree)
	  else
		      tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)
	)

	Try(if(midas.p.Available)
          tkinsert(.affylmGUIglobals$mainTree,"end","AptMidas","AptMidas.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree)
	  else
		      tkinsert(.affylmGUIglobals$mainTree,"end","AptMidas","AptMidas.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)
	)

  Try(if(spliceIndexData.Available)
          tkinsert(.affylmGUIglobals$mainTree,"end","spliceIndex","spliceIndex.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree)
      else
		      tkinsert(.affylmGUIglobals$mainTree,"end","spliceIndex","spliceIndex.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)
  )
  
  Try(if(AltSplRP.e.Available)
          tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.e.Status" ,text="Available at exon level",font=.affylmGUIglobals$affylmGUIfontTree)
      else
          tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.e.Status" ,text="Not Available at exon level",font=.affylmGUIglobals$affylmGUIfontTree)
  )
  
  Try(if(AltSplRP.g.Available)
          tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.g.Status" ,text="Available at gene level",font=.affylmGUIglobals$affylmGUIfontTree)
      else
          tkinsert(.affylmGUIglobals$mainTree,"end","AltSplRP","AltSplRP.g.Status" ,text="Not Available at gene level",font=.affylmGUIglobals$affylmGUIfontTree)
  )
  
  Try(if(MLdesign.Available)
          tkinsert(.affylmGUIglobals$mainTree,"end","classification","classification.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree)
      else
          tkinsert(.affylmGUIglobals$mainTree,"end","classification","classification.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)
  )
  
  Try(if(metaData.Available)
          tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree)
      else
          tkinsert(.affylmGUIglobals$mainTree,"end","metaData","metaData.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)
  )
    


  
  Try(if(Pset.Available){
		      tkinsert(.affylmGUIglobals$mainTree,"end","PLM","PLM.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree)
          require(affyPLM) || stop("library affyPLM could not be found !")
      }
	    else
		      tkinsert(.affylmGUIglobals$mainTree,"end","PLM","PLM.Status" ,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)
)
##########################################

	Try(if(LinearModelFit.Available)
	{
		Try(design <- get("design",affylmGUIenvironment))
		Try(if(NumParameters>0)
		{
			for (i in (1:NumParameters))
				Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters",
					paste("Parameters.Status.",i,sep=""),text=colnames(design)[i],font=.affylmGUIglobals$affylmGUIfontTree))
		}
		else
			Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters","Parameters.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree)))
	}
	else
	{
		Try(tkinsert(.affylmGUIglobals$mainTree,"end","Parameters","Parameters.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree))
	})

	Try(if(NumContrastParameterizations>0)
	{
		for (contrastParameterizationIndex in (1:NumContrastParameterizations))
		{
			Try(.affylmGUIglobals$ContrastParameterizationTREEIndex <- ContrastParameterizationTREEIndexVec[contrastParameterizationIndex])
			Try(ContrastParameterizationNameNode <- paste("ContrastParameterizationName.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			Try(ContrastParameterizationsStatusNameNode <- paste("ContrastParameterizations.Status.",.affylmGUIglobals$ContrastParameterizationTREEIndex,sep=""))
			Try(tkinsert(.affylmGUIglobals$mainTree,"end","ContrastParameterizations",ContrastParameterizationsStatusNameNode ,text=ContrastParameterizationNamesVec[contrastParameterizationIndex],font=.affylmGUIglobals$affylmGUIfontTree))
			Try(contrastsMatrix <- ContrastParameterizationList[[1]]$contrastsMatrixInList$contrasts)
			Try(ContrastsNames <- colnames(contrastsMatrix))
			Try(ContrastParameterizationNameText <- ContrastParameterizationList[[1]]$ContrastParameterizationNameText)
			Try(tkinsert(.affylmGUIglobals$ContrastParameterizationTREE,"end","root",ContrastParameterizationNameNode,text=ContrastParameterizationNameText,font=.affylmGUIglobals$affylmGUIfontTree))
			Try(ContrastsNode <- paste("ContrastsNode.",.affylmGUIglobals$ContrastParameterizationTREEIndex))

			Try(tkinsert(.affylmGUIglobals$ContrastParameterizationTREE,"end",ContrastParameterizationNameNode,ContrastsNode,text="Contrasts",font=.affylmGUIglobals$affylmGUIfontTree))

			Try(NumContrastsInContrastParameterization <- length(ContrastsNames))
			Try(for (j in (1:NumContrastsInContrastParameterization))
				Try(tkinsert(.affylmGUIglobals$ContrastParameterizationTREE,"end",ContrastsNode,paste("Contrasts.",.affylmGUIglobals$ContrastParameterizationTREEIndex,".",j,sep=""),text=ContrastsNames[j],font=.affylmGUIglobals$affylmGUIfontTree)))

			Try(LinearModelFitNode			 <- paste("LinearModelFitNode.",.affylmGUIglobals$ContrastParameterizationTREEIndex))
			Try(LinearModelFitStatusNode <- paste("LinearModelFitStatusNode.",.affylmGUIglobals$ContrastParameterizationTREEIndex))
			Try(tkinsert(.affylmGUIglobals$ContrastParameterizationTREE,"end",ContrastParameterizationNameNode,LinearModelFitNode,text="Linear Model Fit",font=.affylmGUIglobals$affylmGUIfontTree))
			Try(tkinsert(.affylmGUIglobals$ContrastParameterizationTREE,"end",LinearModelFitNode,LinearModelFitStatusNode,text="Available",font=.affylmGUIglobals$affylmGUIfontTree))

			Try(if(("eb" %in% names(ContrastParameterizationList[[contrastParameterizationIndex]]))&&
												length(ContrastParameterizationList[[contrastParameterizationIndex]]$eb)>0)
				Try(ebayesAvailable <- TRUE)
			else
				Try(ebayesAvailable <- FALSE))

			Try(EmpiricalBayesNode			 <- paste("EmpiricalBayesNode.",.affylmGUIglobals$ContrastParameterizationTREEIndex))
			Try(EmpiricalBayesStatusNode <- paste("EmpiricalBayesStatusNode.",.affylmGUIglobals$ContrastParameterizationTREEIndex))
			Try(tkinsert(.affylmGUIglobals$ContrastParameterizationTREE,"end",ContrastParameterizationNameNode,EmpiricalBayesNode,text="Empirical Bayes Statistics",font=.affylmGUIglobals$affylmGUIfontTree))
			Try(if(ebayesAvailable==TRUE)
				Try(tkinsert(.affylmGUIglobals$ContrastParameterizationTREE,"end",EmpiricalBayesNode,EmpiricalBayesStatusNode,text="Available",font=.affylmGUIglobals$affylmGUIfontTree))
			else
				Try(tkinsert(.affylmGUIglobals$ContrastParameterizationTREE,"end",EmpiricalBayesNode,EmpiricalBayesStatusNode,text="Not Available",font=.affylmGUIglobals$affylmGUIfontTree)))

		}
	}
	else
		Try(tkinsert(.affylmGUIglobals$mainTree,"end","ContrastParameterizations","ContrastParameterizations.Status.1" ,text="None",font=.affylmGUIglobals$affylmGUIfontTree)))
  #####################################################################
  #updating the localData info after opening a new .lma This is useful 
  #if the same .lma is opened on a new comuter with a different localization of apt and libs files
  Try(localdata  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/localData.txt", sep=""))
  Try(libDirLocation <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/affylibs/", sep = ""))
  Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
  Try(aptDir <- myinfo[which(myinfo[,1]=="aptDir"),2])
  Try(assign("libDirLocation", libDirLocation, affylmGUIenvironment))
  Try(assign("libDir", libDirLocation, affylmGUIenvironment))
  Try(assign("aptDir", aptDir ,affylmGUIenvironment))
  ####################################################################

	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	Try(tkfocus(.affylmGUIglobals$ttMain))

  Try(changeMenu())#place the right menu depending on the kind of platform array under analysis
}
################################################################################

"showDataset"<-function(){
    if(affylmGUIenvironment$whichArrayPlatform=="AFFY" || affylmGUIenvironment$whichArrayPlatform=="LARGE" || affylmGUIenvironment$whichArrayPlatform=="ILLU" || affylmGUIenvironment$whichArrayPlatform==""){
                if(affylmGUIenvironment$NormalizedAffyData.Available){
                          Try(NormalizedAffyData     <- get("NormalizedAffyData" , envir=affylmGUIenvironment))
                          Try(info.dataset<-paste("Probe sets = ", dim(exprs(NormalizedAffyData))[1],"\n",
                                             "Samples = ", dim(exprs(NormalizedAffyData))[2],"\n",
                                             "Annotation library = ", .annotation(NormalizedAffyData),"\n", sep=""))
                          Try(tkmessageBox(title="Summary of normalized data set",message=info.dataset))
                          #rm(NormalizedAffyData)
                          #gc()
                          #gc()
                }else if(affylmGUIenvironment$RawAffyData.Available){
                          Try(RawAffyData     <- get("RawAffyData" , envir=affylmGUIenvironment))
                          Try(info.dataset<-paste("Size of arrays= ", nrow(RawAffyData), "x", nrow(RawAffyData),"\n",
                                             "Samples = ", length(sampleNames(RawAffyData)),"\n",
                                             "cdf = ", cdfName(RawAffyData),"\n",
                                             "Annotation library = ", .annotation(RawAffyData),"\n", sep=""))
                          Try(tkmessageBox(title="Summary of raw data set",message=info.dataset)) 
                          #rm(RawAffyData)
                          #gc()
                          #gc()
                } else   Try(tkmessageBox(title="summary Data set",message="No data set has been loaded yet")) 
  }
  if(affylmGUIenvironment$whichArrayPlatform=="EXON"){
             if(affylmGUIenvironment$NormalizedAffyData.Available){
                Try(whichLib <- get("whichLib",envir=affylmGUIenvironment))
                Try(NormalizedAffyData     <- get("NormalizedAffyData" , envir=affylmGUIenvironment))
                Try(exonAffyData     <- get("exonAffyData" , envir=affylmGUIenvironment))
                Try(info.dataset<-paste("Genes= ", dim(exprs(NormalizedAffyData))[1],"\n",
                                         "Exons= ", dim(exprs(exonAffyData))[1],"\n",
                                         "Samples= ", dim(exprs(NormalizedAffyData))[2],"\n",
                                         "Annotation library= ", paste("onChannelGUI embedded", paste(as.character(unlist(whichLib)), collapse=" "), "Affymetrix annotation", collapse=" "),"\n", sep=""))
                Try(tkmessageBox(title="Summary of normalized data set",message=info.dataset))

             }else   Try(tkmessageBox(title="summary Data set",message="No data set has been loaded yet"))
  
  }
  if(affylmGUIenvironment$whichArrayPlatform=="GENE"){
                if(affylmGUIenvironment$NormalizedAffyData.Available){
                          Try(NormalizedAffyData     <- get("NormalizedAffyData" , envir=affylmGUIenvironment))
                          Try(info.dataset<-paste("Probe sets = ", dim(exprs(NormalizedAffyData))[1],"\n",
                                             "Samples = ", dim(exprs(NormalizedAffyData))[2],"\n",
                                             "Annotation library = ", .annotation(NormalizedAffyData),"\n", sep=""))
                          Try(tkmessageBox(title="Summary of normalized data set",message=info.dataset))
                } else   Try(tkmessageBox(title="summary Data set",message="No data set has been loaded yet")) 
  }
}
################################################################################ 

ExportNormalizedExpressionValues1 <- function(){
    Try(limmaDataSetNameText <- get("limmaDataSetNameText", envir = affylmGUIenvironment))
    Try(ArraysLoaded <- get("ArraysLoaded", envir = affylmGUIenvironment))
    Try(if (ArraysLoaded == FALSE) {
        Try(tkmessageBox(title = "Export Normalized Expression Values", 
            message = "Error: No arrays have been loaded.", icon = "error", 
            default = "ok"))
        return()
    })
    Try(NormalizedAffyData.Available <- get("NormalizedAffyData.Available", 
        envir = affylmGUIenvironment))
    Try(if (NormalizedAffyData.Available == FALSE) {
        NormalizeNow()
    })
    Try(NormalizedAffyData.Available <- get("NormalizedAffyData.Available", 
        envir = affylmGUIenvironment))
    Try(if (NormalizedAffyData.Available == FALSE) {
        tkmessageBox(title = "Export Normalized Expression Values", 
            message = "An error or cancellation occured while trying to normalize the data.")
        return()
    })
    Try(NormalizedAffyData <- get("NormalizedAffyData", envir = affylmGUIenvironment))
    Try(NormalizedAffyData.exprs <- exprs(NormalizedAffyData))
    Try(FileName <- tclvalue(tkgetSaveFile(initialfile = paste(limmaDataSetNameText, 
        "_exprs.xls", sep = ""), filetypes = "{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
    Try(if (!nchar(FileName)) 
        return())
    Try(len <- nchar(FileName))
    if (len <= 4) {
        Try(FileName <- paste(FileName, ".xls", sep = ""))
    }
    else if ((substring(FileName, len - 3, len) != ".txt") && 
        (substring(FileName, len - 3, len) != ".xls")) {
        Try(FileName <- paste(FileName, ".xls", sep = ""))
    }
    Try(write.table(NormalizedAffyData.exprs, file = FileName,  sep = "\t", quote = FALSE, col.names = NA))
    #exporting other data
    Try(whichArrayPlatform <- get("whichArrayPlatform", envir = affylmGUIenvironment))
    if(whichArrayPlatform == "EXON"){
                  Try(exonAffyData <- get("exonAffyData", envir = affylmGUIenvironment))
           		    Try(mbVal <- tkmessageBox(title="Exorting exon data",
				    											message="Do you wish to export exon intensity data?",
						    									icon="question",type="yesnocancel",default="yes"
								    						 )#end of tkmessageBox
		              )#end of Try(mbVal..
                  if(tclvalue(mbVal)=="cancel"){Try(return())} else if(tclvalue(mbVal)=="yes"){
                    Try(FileName <- tclvalue(tkgetSaveFile(initialfile = paste(limmaDataSetNameText, 
                         "_exon_exprs.xls", sep = ""), filetypes = "{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
                    Try(if (!nchar(FileName)) 
                              return())
                    Try(len <- nchar(FileName))
                    if (len <= 4) {
                       Try(FileName <- paste(FileName, ".xls", sep = ""))
                    } else if ((substring(FileName, len - 3, len) != ".txt") && 
                          (substring(FileName, len - 3, len) != ".xls")) {
                                Try(FileName <- paste(FileName, ".xls", sep = ""))
                     }
                   Try(write.table(exprs(exonAffyData), file = FileName,  sep = "\t", quote = FALSE, col.names = NA))
                  }
                  Try(spliceIndexData.Available <- get("spliceIndexData.Available", envir = affylmGUIenvironment))
                  if(spliceIndexData.Available){
                        Try(spliceIndexData <- get("spliceIndexData", envir = affylmGUIenvironment))
           		          Try(mbVal <- tkmessageBox(title="Exorting Splice Index data",
				    						      					message="Do you wish to export Splice Index data?",
						    							      		icon="question",type="yesnocancel",default="yes"
								    				      		 )#end of tkmessageBox
		                    )#end of Try(mbVal..
                        if(tclvalue(mbVal)=="cancel"){Try(return())} else if(tclvalue(mbVal)=="yes"){
                          Try(FileName <- tclvalue(tkgetSaveFile(initialfile = paste(limmaDataSetNameText, 
                               "_SI.xls", sep = ""), filetypes = "{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
                          Try(if (!nchar(FileName)) 
                                    return())
                          Try(len <- nchar(FileName))
                          if (len <= 4) {
                             Try(FileName <- paste(FileName, ".xls", sep = ""))
                          } else if ((substring(FileName, len - 3, len) != ".txt") && 
                                (substring(FileName, len - 3, len) != ".xls")) {
                                      Try(FileName <- paste(FileName, ".xls", sep = ""))
                           }
                         Try(write.table(spliceIndexData, file = FileName,  sep = "\t", quote = FALSE, col.names = NA))
                        }
                  }
                  Try(AltSplRP.Available <- get("AltSplRP.e.Available", envir = affylmGUIenvironment))
                  if(AltSplRP.Available){
                        Try(AltSplRP.e.p <- get("AltSplRP.e.p", envir = affylmGUIenvironment))
           		          Try(mbVal <- tkmessageBox(title="Exorting RP alternative splicing results",
				    						      					message="Do you wish to export RP alternative splicing results?",
						    							      		icon="question",type="yesnocancel",default="yes"
								    				      		 )#end of tkmessageBox
		                    )#end of Try(mbVal..
                        if(tclvalue(mbVal)=="cancel"){Try(return())} else if(tclvalue(mbVal)=="yes"){
                          Try(FileName <- tclvalue(tkgetSaveFile(initialfile = paste(limmaDataSetNameText, 
                               "_RP_alt_spl_eval.xls", sep = ""), filetypes = "{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
                          Try(if (!nchar(FileName)) 
                                    return())
                          Try(len <- nchar(FileName))
                          if (len <= 4) {
                             Try(FileName <- paste(FileName, ".xls", sep = ""))
                          } else if ((substring(FileName, len - 3, len) != ".txt") && 
                                (substring(FileName, len - 3, len) != ".xls")) {
                                      Try(FileName <- paste(FileName, ".xls", sep = ""))
                           }
                         Try(write.table(AltSplRP.e.p, file = FileName,  sep = "\t", quote = FALSE, col.names = NA))
                        }
                  }
                  Try(midas.p.Available <- get("midas.p.Available", envir = affylmGUIenvironment))
                  if(midas.p.Available){
                        Try(midas.p <- get("midas.p", envir = affylmGUIenvironment))
           		          Try(mbVal <- tkmessageBox(title="Exorting MiDAS p-values",
				    						      					message="Do you wish to export MiDAS p-values?",
						    							      		icon="question",type="yesnocancel",default="yes"
								    				      		 )#end of tkmessageBox
		                    )#end of Try(mbVal..
                        if(tclvalue(mbVal)=="cancel"){Try(return())} else if(tclvalue(mbVal)=="yes"){
                          Try(FileName <- tclvalue(tkgetSaveFile(initialfile = paste(limmaDataSetNameText, 
                               "_MiDAS_p.xls", sep = ""), filetypes = "{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
                          Try(if (!nchar(FileName)) 
                                    return())
                          Try(len <- nchar(FileName))
                          if (len <= 4) {
                             Try(FileName <- paste(FileName, ".xls", sep = ""))
                          } else if ((substring(FileName, len - 3, len) != ".txt") && 
                                (substring(FileName, len - 3, len) != ".xls")) {
                                      Try(FileName <- paste(FileName, ".xls", sep = ""))
                           }
                         Try(write.table(midas.p, file = FileName,  sep = "\t", quote = FALSE, col.names = NA))
                        }
                  }
                  Try(mapping2ensembl.Available <- get("mapping2ensembl.Available", envir = affylmGUIenvironment))
                  if(mapping2ensembl.Available){
                        Try(mapping2ensembl <- get("mapping2ensembl", envir = affylmGUIenvironment))
           		          Try(mbVal <- tkmessageBox(title="Exorting exon-level probesets statistics and expression data with EG exon association",
				    						      					message="Do you wish to export stat/exprs data mapped to Entrez Gene exons?",
						    							      		icon="question",type="yesnocancel",default="yes"
								    				      		 )#end of tkmessageBox
		                    )#end of Try(mbVal..
                        if(tclvalue(mbVal)=="cancel"){Try(return())} else if(tclvalue(mbVal)=="yes"){
                          Try(FileName <- tclvalue(tkgetSaveFile(initialfile = paste(limmaDataSetNameText, 
                               "_mapping2ensembl.xls", sep = ""), filetypes = "{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
                          Try(if (!nchar(FileName)) 
                                    return())
                          Try(len <- nchar(FileName))
                          if (len <= 4) {
                             Try(FileName <- paste(FileName, ".xls", sep = ""))
                          } else if ((substring(FileName, len - 3, len) != ".txt") && 
                                (substring(FileName, len - 3, len) != ".xls")) {
                                      Try(FileName <- paste(FileName, ".xls", sep = ""))
                           }
                         Try(write.table(mapping2ensembl, file = FileName,  sep = "\t", quote = FALSE, col.names = NA))
                        }
                  }
                  Try(exonsSpecific2as.Available <- get("exonsSpecific2as.Available", envir = affylmGUIenvironment))
                  if(exonsSpecific2as.Available){
                        Try(exonsSpecific <- get("exonsSpecific2as", envir = affylmGUIenvironment))
           		          Try(mbVal <- tkmessageBox(title="Exorting the structure of mRNA isoforms",
				    						      					message="Do you wish to export structure of mRNA isoforms?",
						    							      		icon="question",type="yesnocancel",default="yes"
								    				      		 )#end of tkmessageBox
		                    )#end of Try(mbVal..
                        if(tclvalue(mbVal)=="cancel"){Try(return())} else if(tclvalue(mbVal)=="yes"){
                          Try(FileName <- tclvalue(tkgetSaveFile(initialfile = paste(limmaDataSetNameText, 
                               "_exonsSpecific2as.xls", sep = ""), filetypes = "{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
                          Try(if (!nchar(FileName)) 
                                    return())
                          Try(len <- nchar(FileName))
                          if (len <= 4) {
                             Try(FileName <- paste(FileName, ".xls", sep = ""))
                          } else if ((substring(FileName, len - 3, len) != ".txt") && 
                                (substring(FileName, len - 3, len) != ".xls")) {
                                      Try(FileName <- paste(FileName, ".xls", sep = ""))
                           }
                         for( i in 1: length(exonsSpecific)){  
                                  Try(write.table(exonsSpecific[i], file = FileName,  sep = "\t", quote = FALSE, row.names= T, append=T))
                         }
                        }
                  }

    }
}
################################################################################

#if annotation lib is not present in the data set , like in the case of loading the data as tab delimted file
#annotation library can be added to the annotation field of ExpressionSet object
"addAnnLib" <- function(){
   NormalizedAffyData.Available     <- get("NormalizedAffyData.Available" , envir=affylmGUIenvironment)
   if(NormalizedAffyData.Available){
         Try(x <- get("NormalizedAffyData",envir=affylmGUIenvironment))

         Try(ttAnnLibName<-tktoplevel(.affylmGUIglobals$ttMain))
         Try(tkwm.deiconify(ttAnnLibName))
         Try(tkgrab.set(ttAnnLibName))
         Try(tkfocus(ttAnnLibName))
         Try(tkwm.title(ttAnnLibName,"Bioconductor Annotation library"))
         Try(tkgrid(tklabel(ttAnnLibName,text="    ")))
         Try(AnnLibNameText <- "")
         Try(Local.AnnLibName <- tclVar(init=AnnLibNameText))
         Try(entry.AnnLibName <-tkentry(ttAnnLibName,width="20",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.AnnLibName,bg="white"))
         Try(tkgrid(tklabel(ttAnnLibName,text="Please enter the code of the Bioconductor\nAnnotation Library.",font=.affylmGUIglobals$affylmGUIfont2)))
         Try(tkgrid(entry.AnnLibName))
         onOK <- function()
         {
               Try(AnnLibNameText <- tclvalue(Local.AnnLibName))
               
               if(nchar(AnnLibNameText)==0)
                  AnnLibNameText <- ""
               Try(x@annotation <- AnnLibNameText)
               Try(assign("NormalizedAffyData",x,affylmGUIenvironment))
               Try(tkgrab.release(ttAnnLibName));Try(tkdestroy(ttAnnLibName));Try(tkfocus(.affylmGUIglobals$ttMain))
         }
         Try(OK.but <-tkbutton(ttAnnLibName,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
         Try(tkgrid(tklabel(ttAnnLibName,text="    ")))
         Try(tkgrid(OK.but))
         Try(tkgrid.configure(OK.but))
         Try(tkgrid(tklabel(ttAnnLibName,text="       ")))
         Try(tkfocus(entry.AnnLibName))
         Try(tkbind(entry.AnnLibName, "<Return>",onOK))
         Try(tkbind(ttAnnLibName, "<Destroy>", function(){Try(tkgrab.release(ttAnnLibName));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
         Try(tkwait.window(ttAnnLibName))
         Try(tkfocus(.affylmGUIglobals$ttMain))
   } else {
            Try(tkmessageBox(title="Bioconductor annotation library",message="Normalized data are not loaded!\n Annotation  Library info cannot be attached.",icon="error",type="ok"))
   }



}
################################################################################

#modified on 16 12 2006 adding the load of exon expression signal together with gene expression signal
OpenExonandTargetsfiles <- function()
{
	Require("affy")
	Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttExonandTargets))
	Try(tkgrab.set(ttExonandTargets))
	Try(tkfocus(ttExonandTargets))
	Try(tkwm.title(ttExonandTargets,"Targets file"))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	OpenTargetsFileAndSetCursor <- function()
	{
			Try(tkconfigure(ttExonandTargets,cursor="watch"))
			Try(tkfocus(ttExonandTargets))
			Try(OpenTargetsFile())
			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			Try(tkfocus(ttExonandTargets))
	}

#	OpenExonFileAndSetCursor <- function()
#	{
#			Try(tkconfigure(ttExonandTargets,cursor="watch"))
#			Try(tkfocus(ttExonandTargets))
#			Try(OpenExonFile())
#			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
#			Try(tkfocus(ttExonandTargets))
#	}

#	Try(OpenExonFile.but <- tkbutton(ttExonandTargets, text="Select Exon File",command=OpenExonFile,font=.affylmGUIglobals$affylmGUIfont2))
	Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	#Try(tclvalue(.affylmGUIglobals$CDFfileName) <- fixSeps(tclvalue(.affylmGUIglobals$CDFfileName)))
	#Try(.affylmGUIglobals$CDFfileBoxTitleLabel<-tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$CDFfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	#Try(.affylmGUIglobals$CDFfileNameLabel<-tklabel(ttCDFandTargets,text=as.character(tclvalue(.affylmGUIglobals$CDFfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	#Try(tkconfigure(.affylmGUIglobals$CDFfileBoxTitleLabel, textvariable=.affylmGUIglobals$CDFfileBoxTitle))
	#Try(tkconfigure(.affylmGUIglobals$CDFfileNameLabel, textvariable=.affylmGUIglobals$CDFfileName))

#	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
#	Try(tkgrid(.affylmGUIglobals$CDFfileBoxTitleLabel,columnspan=4))
#	Try(tkgrid(.affylmGUIglobals$CDFfileNameLabel,columnspan=4))

	Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

#	Try(tkgrid(tklabel(ttCDFandTargets,text="    ")))
#	Try(tkgrid(tklabel(ttCDFandTargets,text="    "),OpenCDFFile.but, OpenTargetsFile.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
	Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	Try(Abort <- 1)
	onOK <- function()
	{
#			Try(cdf		 <- get("cdf",envir=affylmGUIenvironment))
			Try(Targets <- get("Targets",envir=affylmGUIenvironment))
#			Try(if(length(cdf)==0)
#			{
#				Try(tkmessageBox(title="CDF (Chip Definition) File",message=paste("Either you did not specify a valid CDF (Chip Definition File",
#					"or an error occurred while reading in the CDF file.	It should be in tab-delimited text format and it should include the column headings \"Block\", \"Column\", \"Row\", \"Name\" and \"ID\"."),icon="error"))
#				onCancel()
#				return()
#			})
			Try(if(length(Targets)==0)
			{
				Try(tkmessageBox(title="RNA Targets File",message=paste("Either you did not specify a valid RNA Targets File",
					"or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				onCancel()
				return()
			})
			Try(tkgrab.release(ttExonandTargets));
			Try(tkdestroy(ttExonandTargets));
			Try(tkfocus(.affylmGUIglobals$ttMain))
			Try(Abort <<- 0)
	}
	onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	Try(tkfocus(ttExonandTargets))
	Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkwait.window(ttExonandTargets))

	if(Abort==1)
				return(0)

	#OK
	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
	Try(tkfocus(.affylmGUIglobals$ttMain))
	Try(Targets <- get("Targets",affylmGUIenvironment))
	Try(slides <- Targets$FileName)
	#################################################
  #not used for exons from expression console
  #Try(filesExist <- file.exists(slides))
	#Try(filesWhichDontExist <- slides[!filesExist])
	#Try(if(length(filesWhichDontExist)>0)
	#	Try(for (i in (1:length(filesWhichDontExist)))
	#		Try(tkmessageBox(title="Error opening file",message=paste("Failed to open file: \"",filesWhichDontExist[i],"\"",sep=""),icon="error"))))
	#Try(if(length(filesWhichDontExist)>0)
	#{
	#	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	#	return(0)
	#})
  #########################################################
  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
  
  
  Try(exonVal <- get("exonVal",envir=affylmGUIenvironment)) #recover the information about the decision of using apt tools for  intenisties calculation
  Try(whichArrayPlatform <- get("whichArrayPlatform",affylmGUIenvironment))
  if(affylmGUIenvironment$aptDir.Available & tclvalue(exonVal)=="yes" & whichArrayPlatform=="EXON"){
           Try(aptDir <- get("aptDir",envir=affylmGUIenvironment))
           Try(libDir <- get("libDir",envir=affylmGUIenvironment))
           Try(whichLib <- get("whichLib",envir=affylmGUIenvironment))
           #mapping the clf pgf files
           Try(content.libDir <- dir(libDir))
           Try(clf.name <- paste(libDir, content.libDir[intersect(grep(whichLib[[1]][1],content.libDir), grep('.clf$',content.libDir))], sep=""))
           Try(pgf.name <- paste(libDir, content.libDir[intersect(grep(whichLib[[1]][1],content.libDir), grep('.pgf$',content.libDir))], sep=""))
           #defining the meta gene subset
           Try(exonlib.name <- paste(libDir, content.libDir[intersect(grep('.mps$',content.libDir), intersect(grep(whichLib[[1]][1],content.libDir), grep(whichLib[[1]][2],content.libDir)))], sep=""))
           #defining the temp file containing target info for apt
           Try(tempTarget <- tempfile(pattern = "target", tmpdir = getwd()))
           Try(tempTarget <- sub( "\\\\","/",tempTarget)) #changing double backslach with slash
           Try(write.table(Targets[,2:3], tempTarget, sep="\t", row.names =F, col.names = c("cel_files", "group_id"))) 
           Try(tempOut <- tempfile(pattern = "out", tmpdir = getwd()))#creating a temp outfile
           Try(tempOut <- sub( "\\\\","/",tempOut)) #changing double backslach with slash
   
           #######################################################
           #defining the APT tool gene/exon level calculaiton methods
           Try(ttIfDialog<-tktoplevel(.affylmGUIglobals$ttMain))
           Try(tkwm.deiconify(ttIfDialog))
           Try(tkgrab.set(ttIfDialog))
           Try(tkfocus(ttIfDialog))
           Try(tkwm.title(ttIfDialog,"APT tools intensity summaries"))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))
           Try(frame1 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
           Try(HowManyQuestion1 <- tklabel(frame1,text="Gene level methods",font=.affylmGUIglobals$affylmGUIfont2))
           Try(tkgrid(HowManyQuestion1))
           Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
           Try(geneTcl <- tclVar("rma-sketch"))
           Try(I0.but  <- tkradiobutton(frame1,text="rma-sketch",variable=geneTcl,value="rma-sketch",font=.affylmGUIglobals$affylmGUIfont2))
           Try(I1.but  <- tkradiobutton(frame1,text="iter-plier",variable=geneTcl,value="iter-plier",font=.affylmGUIglobals$affylmGUIfont2))
           Try(tkgrid(I0.but,sticky="w"))
           Try(tkgrid(I1.but,sticky="w"))
           Try(tkgrid.configure(HowManyQuestion1,I0.but,I1.but,sticky="w"))

           Try(frame2 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
           Try(exonLabel <- tklabel(frame2,text="Exon level methods",font=.affylmGUIglobals$affylmGUIfont2))
           Try(tkgrid(exonLabel,sticky="w"))
           Try(tkgrid.configure(exonLabel,sticky="w"))
           Try(exonTcl <- tclVar("rma-sketch"))
           Try(F0.but <- tkradiobutton(frame2,text="rma-sketch",variable=exonTcl,value="rma-sketch",font=.affylmGUIglobals$affylmGUIfont2))
           Try(F1.but <- tkradiobutton(frame2,text="plier-gcbg-sketch",variable=exonTcl,value="plier-gcbg-sketch",font=.affylmGUIglobals$affylmGUIfont2))

           Try(tkgrid(F0.but,sticky="w"))
           Try(tkgrid(F1.but,sticky="w"))
           Try(tkgrid.configure(exonLabel,F0.but,F1.but,sticky="w"))
           Try(ReturnValX <<- "")
           Try(onOK <- function()
           {
                ReturnVal1 <- tclvalue(geneTcl)
                ReturnVal2 <- tclvalue(exonTcl)
                Try(ReturnValX <<- paste(ReturnVal1, ReturnVal2, sep=";"))
                Try(tkgrab.release(ttIfDialog))
                Try(tkdestroy(ttIfDialog))
                Try(tkfocus(.affylmGUIglobals$ttMain))
           })

           Try(frame3 <- tkframe(ttIfDialog,borderwidth=2))
           Try(onCancel <- function() {Try(tkgrab.release(ttIfDialog));Try(tkdestroy(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));Try(return())})
           Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
           Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

           Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))

           Try(tkgrid(tklabel(ttIfDialog,text="    "),frame1,frame2,tklabel(ttIfDialog,text="  ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    "),frame3,tklabel(ttIfDialog,text="  ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))
           Try(tkgrid.configure(frame1,frame3,sticky="w"))

           Try(tkfocus(ttIfDialog))
           Try(tkbind(ttIfDialog, "<Destroy>", function() {Try(tkgrab.release(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));}))
           Try(tkwait.window(ttIfDialog))

            ##gene/exon routines 
            if(ReturnValX == ""){
                      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                      Try(tkfocus(.affylmGUIglobals$ttMain))
                      Try(return())
            }
           Try(tmpVal<-strsplit(ReturnValX, ";"))
           Try(gene.summary <- tmpVal[[1]][1])
           Try(exon.summary <- tmpVal[[1]][2])

           if(gene.summary == "rma-sketch"){
                    Try(typeOfSummary <-  "rma-sketch")
                    Try(gene.rma.sketch <- paste(aptDir,"/bin/apt-probeset-summarize", " -a ", typeOfSummary," -p ", pgf.name, " -c ", clf.name, " -m ", exonlib.name," -o ", tempOut," --cel-files ", tempTarget, sep=""))
                    Try(cat("\nGene level probe sets summary started\n"))
                    Try(system(gene.rma.sketch, wait = T))#assign to gene summary one of the method implemented for gene summary
                    Try(cat("\nGene level probe sets summary ended\n"))
           }
           if(gene.summary == "iter-plier"){
                    Try(typeOfSummary <-  "iter-plier")
                    Try(bgfile.name <- paste(libDir, content.libDir[intersect(grep('[.]antigenomic.bgp$',content.libDir), grep(whichLib[[1]][1],content.libDir))], sep=""))
                    Try(gene.iterplier <- paste(aptDir,"/bin/apt-probeset-summarize", " -a ", "quant-norm.sketch=50000.bioc=false,pm-gcbg,", typeOfSummary," -p ", pgf.name," -b ", bgfile.name," -c ", clf.name, " -m ", exonlib.name," -o ", tempOut," --cel-files ", tempTarget, sep=""))
                    Try(cat("\nGene level probe sets summary started\n"))
                    Try(system(gene.iterplier, wait = T))#assign to gene summary one of the method implemented for gene summary
                    Try(cat("\nGene level probe sets summary ended\n"))
           }

           ##########################################################
           #it is necessary to exchange "-" with "." in the FileNames of Targets 
           #since R will convert "-" into "." for the header of the data file
           #e.g. name in the header of the data file 211_MB-211.rma-gene-core-Signal
           # after reading in R:  211_MB.211.rma.gene.core.Signal
           #therefore the FileName  211_MB-211 should be converted in 211_MB.211
           Try(tmp<- apply(Targets, 1,function(x){sub("-",".",x[2])}))
           Try(Targets[,2] <- tmp )
           ############################################################
  
           Try(rownames(Targets) <- Targets$FileName) 
           Try(var.tmp.pd<-data.frame(names(Targets)))
           Try(names(var.tmp.pd)<-"labelDescription" )
           Try(rownames(var.tmp.pd)<-names(Targets))
           Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
           #Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
           Try(target.array.names <- tmp1.pd$FileName)
           Try(tempOut0 <- paste(typeOfSummary ,".summary.txt",sep=""))
           Try(content.outDir <- dir(tempOut))
           Try(tempOut1  <- grep(tempOut0, content.outDir))
           Try(my.exons <-read.table(paste(tempOut, "/", content.outDir[tempOut1], sep=""), sep="\t", header=T, as.is=TRUE, row.names=1))#loading gene level data
           Try(my.exons.array.names <- NULL)
           Try(    for( i in 1:length(target.array.names)){
                                    if(length(grep(target.array.names[i], names(my.exons))) == 1){
                                           my.exons.array.names[i] <- grep(target.array.names[i], names(my.exons))
                                    } else{
                                            error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], names(my.exons))],sep=","), "\n", sep="")
                                            cat("\nERROR! Filenames are not unique!\n")
                                            cat(error.message)
                                            cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
                                            Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                            return()
                                    }
               })
           Try(my.exons <- my.exons[,my.exons.array.names])
           Try(names(my.exons) <-  tmp1.pd$FileName)
           if(gene.summary == "iter-plier"){
                    Try(NormalizedAffyData <- new("ExpressionSet", exprs=log2(as.matrix(my.exons)), phenoData=tmp1.pd, annotation=""))
                    if(!validObject(NormalizedAffyData)){
                           Try(tkmessageBox(title="Gene level APT calculation",message="Check the APT log in the main R window\nNo valid ExpressionSet could be created!",icon="error"))
                				   Try(return())
                    }
           } else {
                    Try(NormalizedAffyData <- new("ExpressionSet", exprs=as.matrix(my.exons), phenoData=tmp1.pd, annotation=""))
                    if(!validObject(NormalizedAffyData)){
                           Try(tkmessageBox(title="Gene level APT calculation",message="Check the APT log in the main R window\nNo valid ExpressionSet could be created!",icon="error"))
                			     Try(return())
                    }

           }
	         Try(assign("NormalizedAffyData.Available",TRUE,affylmGUIenvironment))
	         Try(assign("NormalizedAffyData",NormalizedAffyData,affylmGUIenvironment))
           Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	         Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Gene level exon data available",font=.affylmGUIglobals$affylmGUIfontTree))
	         Try(if("Name" %in% colnames(Targets))
	         SlideNamesVec <- Targets$Name)
	         Try(assign("SlideNamesVec",SlideNamesVec,affylmGUIenvironment))
	         Try(assign("ArraysLoaded",TRUE,affylmGUIenvironment))
           Try(cat("\nGene level probe sets summary ended\n"))
           ####################
           Try(cat("\nExon level probe sets summary started\n"))
           #defining the exon corrsponding to the meta gene subset
           Try(exonlib1.name <- paste(libDir, content.libDir[intersect(grep('[.]ps$',content.libDir), intersect(grep(whichLib[[1]][1],content.libDir), grep(whichLib[[1]][2],content.libDir)))], sep=""))
           Try(tempOut <- tempfile(pattern = "out", tmpdir = getwd()))#creating a temp outfile
           Try(tempOut <- sub( "\\\\","/",tempOut)) #changing double backslach with slash
           
           if(exon.summary == "rma-sketch"){
                    Try(typeOfSummary <-  "rma-sketch")
                    Try(exon.rma.sketch <- paste(aptDir,"/bin/apt-probeset-summarize", " -a ", typeOfSummary," -p ", pgf.name, " -c ", clf.name, " -s ", exonlib1.name," -o ", tempOut," --cel-files ", tempTarget, sep=""))
                    Try(cat("\nExon level probe sets summary started\n"))
                    Try(system(exon.rma.sketch, wait = T))#assign to exon summary one of the method implemented for gene summary
                    Try(cat("\nExon level probe sets summary ended\n"))
           }
           if(exon.summary == "plier-gcbg-sketch"){
                    Try(typeOfSummary <-  "plier-gcbg-sketch")
                    Try(bgfile.name <- paste(libDir, content.libDir[intersect(grep('[.]antigenomic.bgp$',content.libDir), grep(whichLib[[1]][1],content.libDir))], sep=""))
                    Try(exon.plier <- paste(aptDir,"/bin/apt-probeset-summarize", " -a ", typeOfSummary," -p ", pgf.name, " -c ", clf.name, " -b ", bgfile.name," -s ", exonlib1.name," -o ", tempOut," --cel-files ", tempTarget, sep=""))
                    Try(cat("\nExon level probe sets summary started\n"))
                    Try(system(exon.plier, wait = T))#assign to exon summary one of the method implemented for gene summary
                    Try(cat("\nExon level probe sets summary ended\n"))
           }
           Try(my.exons <-read.table(paste(tempOut, "/", typeOfSummary ,".summary.txt",sep=""), sep="\t", header=T, as.is=TRUE, row.names=1))#loading exon level data
           Try(my.exons.array.names <- NULL)
           Try(    for( i in 1:length(target.array.names)){
                             if(length(grep(target.array.names[i], names(my.exons))) == 1){
                                my.exons.array.names[i] <- grep(target.array.names[i], names(my.exons))
                             } else{
                                    error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], names(my.exons))],sep=","), "\n", sep="")
                                    cat("\nERROR! Filenames are not unique!\n")
                                    cat(error.message)
                                    cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
                                    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                    return()
                             }
               })
           Try(my.exons <- my.exons[,my.exons.array.names])
           Try(names(my.exons) <-  tmp1.pd$FileName)
           if(exon.summary == "plier-gcbg-sketch"){
                    Try(ExonAffyData <- new("ExpressionSet", exprs=log2(as.matrix(my.exons)), phenoData=tmp1.pd, annotation=""))
                    if(!validObject(ExonAffyData)){
                           Try(tkmessageBox(title="Exon level APT calculation",message="Check the APT log in the main R window\nNo valid ExpressionSet could be created!",icon="error"))
                			     Try(return())
                    }
           } else {
                    Try(ExonAffyData <- new("ExpressionSet", exprs=as.matrix(my.exons), phenoData=tmp1.pd, annotation=""))
                    if(!validObject(ExonAffyData)){
                           Try(tkmessageBox(title="Exon level APT calculation",message="Check the APT log in the main R window\nNo valid ExpressionSet could be created!",icon="error"))
                			     Try(return())
                    }

           }
	         Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	         Try(assign("exonAffyData.Available",TRUE,affylmGUIenvironment))
	         Try(assign("exonAffyData",ExonAffyData,affylmGUIenvironment))

	         Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))
	         Try(tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Exon level data available",font=.affylmGUIglobals$affylmGUIfontTree))
           Try(cat("\nExon level probe sets summary ended\n"))
           #############dabg
           Try(mbVal <- tkmessageBox(title="dabg p-values", message="Do you wish to calculate dabg? Dabg is a p-value that the intensities in a probeset \ncould have been observed by chance in a background distribution. \nIt can be used to filter out not expressed probe sets \nbefore alternative splicing analysis.",
						         									icon="question",type="yesnocancel",default="yes"
								         						 )#end of tkmessageBox
		         )#end of Try(mbVal..
		         if(tclvalue(mbVal)=="yes"){
		                Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
                    Try(cat("\nDABG calculation started\n"))
                    Try(bgfile.name <- paste(libDir, content.libDir[intersect(grep('[.]antigenomic.bgp$',content.libDir), grep(whichLib[[1]][1],content.libDir))], sep=""))
                    Try(system(paste(aptDir,"/bin/apt-probeset-summarize", " -a ", "dabg"," -b ",bgfile.name, " -p ", pgf.name, " -c ", clf.name, " -m ", exonlib.name," -o ", tempOut," --cel-files ", tempTarget, sep=""), wait = T))
                    #saving dabg in an expression set
                    Try(rownames(Targets) <- Targets$FileName) 
                    Try(var.tmp.pd<-data.frame(names(Targets)))
                    Try(names(var.tmp.pd)<-"labelDescription" )
                    Try(rownames(var.tmp.pd)<-names(Targets))
                    Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
                    #Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
                    Try(target.array.names <- tmp1.pd$FileName)
                    Try(my.exons <-read.table(paste(tempOut, "/", "dabg" ,".summary.txt",sep=""), sep="\t", header=T, as.is=TRUE, row.names=1))#loading gene level data
                    Try(my.exons.array.names <- NULL)
                    Try(    for( i in 1:length(target.array.names)){
                                       if(length(grep(target.array.names[i], names(my.exons))) == 1){
                                            my.exons.array.names[i] <- grep(target.array.names[i], names(my.exons))
                                       } else{
                                               error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], names(my.exons))],sep=","), "\n", sep="")
                                               cat("\nERROR! Filenames are not unique!\n")
                                               cat(error.message)
                                               cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
                                               Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                               return()
                                      }
                    })
                    Try(my.exons <- my.exons[,my.exons.array.names])
                    Try(names(my.exons) <-  tmp1.pd$FileName)
                    Try(dabg.p <- new("ExpressionSet", exprs=as.matrix(my.exons), phenoData=tmp1.pd, annotation=""))
                    Try(assign("dabg.p" , dabg.p, affylmGUIenvironment))
                    Try(assign("dabg.Available" , TRUE, affylmGUIenvironment))
                    Try(tkdelete(.affylmGUIglobals$mainTree,"AptDabg.Status"))
                    Try(tkinsert(.affylmGUIglobals$mainTree,"end","AptDabg","AptDabg.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree))
                    Try(cat("\nDABG calculation ended\n"))
                    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
             }
		         if(tclvalue(mbVal)=="cancel"){
			         Try(tkfocus(.affylmGUIglobals$ttMain))
			         return()
			       }  
		        Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
           #################dabg
	         Try(ReturnVal <- GetlimmaDataSetName())
	         if(ReturnVal==0) return(0)
	         return(1)
  } else if(affylmGUIenvironment$aptDir.Available & tclvalue(exonVal)=="yes" & whichArrayPlatform=="GENE"){
           ######gene
           Try(aptDir <- get("aptDir",envir=affylmGUIenvironment))
           Try(libDir <- get("libDir",envir=affylmGUIenvironment))
           Try(whichLib <- get("whichLib",envir=affylmGUIenvironment))
           #mapping the clf pgf files
           Try(content.libDir <- dir(libDir))
           Try(clf.name <- paste(libDir, content.libDir[intersect(grep(whichLib[[1]][1],content.libDir), grep('.clf$',content.libDir))], sep=""))
           Try(pgf.name <- paste(libDir, content.libDir[intersect(grep(whichLib[[1]][1],content.libDir), grep('.pgf$',content.libDir))], sep=""))
           #defining the meta gene subset
           Try(exonlib.name <- paste(libDir, content.libDir[intersect(grep('.mps$',content.libDir), grep(whichLib[[1]][1],content.libDir))], sep=""))
           #defining the temp file containing target info for apt
           Try(tempTarget <- tempfile(pattern = "target", tmpdir = getwd()))
           Try(tempTarget <- sub( "\\\\","/",tempTarget)) #changing double backslach with slash
           Try(write.table(Targets[,2:3], tempTarget, sep="\t", row.names =F, col.names = c("cel_files", "group_id"))) 
           Try(tempOut <- tempfile(pattern = "out", tmpdir = getwd()))#creating a temp outfile
           Try(tempOut <- sub( "\\\\","/",tempOut)) #changing double backslach with slash
   
           #######################################################
           #defining the APT tool gene/exon level calculaiton methods
           Try(ttIfDialog<-tktoplevel(.affylmGUIglobals$ttMain))
           Try(tkwm.deiconify(ttIfDialog))
           Try(tkgrab.set(ttIfDialog))
           Try(tkfocus(ttIfDialog))
           Try(tkwm.title(ttIfDialog,"APT tools intensity summaries"))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))
           Try(frame1 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
           Try(HowManyQuestion1 <- tklabel(frame1,text="Gene level methods",font=.affylmGUIglobals$affylmGUIfont2))
           Try(tkgrid(HowManyQuestion1))
           Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
           Try(geneTcl <- tclVar("rma-sketch"))
           Try(I0.but  <- tkradiobutton(frame1,text="rma-sketch",variable=geneTcl,value="rma-sketch",font=.affylmGUIglobals$affylmGUIfont2))
           Try(I1.but  <- tkradiobutton(frame1,text="iter-plier",variable=geneTcl,value="iter-plier",font=.affylmGUIglobals$affylmGUIfont2))
           Try(tkgrid(I0.but,sticky="w"))
           Try(tkgrid(I1.but,sticky="w"))
           Try(tkgrid.configure(HowManyQuestion1,I0.but,I1.but,sticky="w"))

           #Try(frame2 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
           #Try(exonLabel <- tklabel(frame2,text="Exon level methods",font=.affylmGUIglobals$affylmGUIfont2))
           #Try(tkgrid(exonLabel,sticky="w"))
           #Try(tkgrid.configure(exonLabel,sticky="w"))
           #Try(exonTcl <- tclVar("rma-sketch"))
           #Try(F0.but <- tkradiobutton(frame2,text="rma-sketch",variable=exonTcl,value="rma-sketch",font=.affylmGUIglobals$affylmGUIfont2))
           #Try(F1.but <- tkradiobutton(frame2,text="plier-gcbg-sketch",variable=exonTcl,value="plier-gcbg-sketch",font=.affylmGUIglobals$affylmGUIfont2))

           #Try(tkgrid(F0.but,sticky="w"))
           #Try(tkgrid(F1.but,sticky="w"))
           #Try(tkgrid.configure(exonLabel,F0.but,F1.but,sticky="w"))
           Try(ReturnValX <<- "")
           Try(onOK <- function()
           {
                ReturnVal1 <- tclvalue(geneTcl)
                ReturnVal2 <- "" #not used in gene 1.0 ST
                Try(ReturnValX <<- paste(ReturnVal1, ReturnVal2, sep=";"))
                Try(tkgrab.release(ttIfDialog))
                Try(tkdestroy(ttIfDialog))
                Try(tkfocus(.affylmGUIglobals$ttMain))
           })

           Try(frame3 <- tkframe(ttIfDialog,borderwidth=2))
           Try(onCancel <- function() {Try(tkgrab.release(ttIfDialog));Try(tkdestroy(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));Try(return())})
           Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
           Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

           Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))

           Try(tkgrid(tklabel(ttIfDialog,text="    "),frame1,tklabel(ttIfDialog,text="  ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    "),frame3,tklabel(ttIfDialog,text="  ")))
           Try(tkgrid(tklabel(ttIfDialog,text="    ")))
           Try(tkgrid.configure(frame1,frame3,sticky="w"))

           Try(tkfocus(ttIfDialog))
           Try(tkbind(ttIfDialog, "<Destroy>", function() {Try(tkgrab.release(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));}))
           Try(tkwait.window(ttIfDialog))

            ##gene/exon routines 
            if(ReturnValX == ""){
                      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                      Try(tkfocus(.affylmGUIglobals$ttMain))
                      Try(return())
            }
           Try(tmpVal<-strsplit(ReturnValX, ";"))
           Try(gene.summary <- tmpVal[[1]][1])
           #Try(exon.summary <- tmpVal[[1]][2])

           if(gene.summary == "rma-sketch"){
                    Try(typeOfSummary <-  "rma-sketch")
                    Try(gene.rma.sketch <- paste(aptDir,"/bin/apt-probeset-summarize", " -a ", typeOfSummary," -p ", pgf.name, " -c ", clf.name, " -m ", exonlib.name, " -o ", tempOut," --cel-files ", tempTarget, sep=""))
                    Try(cat("\nGene level probe sets summary started\n"))
                    Try(system(gene.rma.sketch, wait = T))#assign to gene summary one of the method implemented for gene summary
                    Try(cat("\nGene level probe sets summary ended\n"))
           }
           if(gene.summary == "iter-plier"){
                    Try(typeOfSummary <-  "iter-plier")
                    Try(bgfile.name <- paste(libDir, content.libDir[intersect(grep('[.]antigenomic.bgp$',content.libDir), grep(whichLib[[1]][1],content.libDir))], sep=""))
                    Try(gene.iterplier <- paste(aptDir,"/bin/apt-probeset-summarize", " -a ", "quant-norm.sketch=50000.bioc=false,pm-gcbg,", typeOfSummary," -p ", pgf.name," -b ", bgfile.name," -c ", clf.name, " -m ", exonlib.name," -o ", tempOut," --cel-files ", tempTarget, sep=""))
                    Try(cat("\nGene level probe sets summary started\n"))
                    Try(system(gene.iterplier, wait = T))#assign to gene summary one of the method implemented for gene summary
                    Try(cat("\nGene level probe sets summary ended\n"))
           }

           ##########################################################
           #it is necessary to exchange "-" with "." in the FileNames of Targets 
           #since R will convert "-" into "." for the header of the data file
           #e.g. name in the header of the data file 211_MB-211.rma-gene-core-Signal
           # after reading in R:  211_MB.211.rma.gene.core.Signal
           #therefore the FileName  211_MB-211 should be converted in 211_MB.211
           Try(tmp<- apply(Targets, 1,function(x){sub("-",".",x[2])}))
           Try(Targets[,2] <- tmp )
           ############################################################
  
           Try(rownames(Targets) <- Targets$FileName) 
           Try(var.tmp.pd<-data.frame(names(Targets)))
           Try(names(var.tmp.pd)<-"labelDescription" )
           Try(rownames(var.tmp.pd)<-names(Targets))
           Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
           #Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
           Try(target.array.names <- tmp1.pd$FileName)
           Try(tempOut0 <- paste(typeOfSummary ,".summary.txt",sep=""))
           Try(content.outDir <- dir(tempOut))
           Try(tempOut1  <- grep(tempOut0, content.outDir))
           Try(my.exons <-read.table(paste(tempOut, "/", content.outDir[tempOut1], sep=""), sep="\t", header=T, as.is=TRUE, row.names=1))#loading gene level data
           Try(my.exons.array.names <- NULL)
           Try(    for( i in 1:length(target.array.names)){
                             if(length(grep(target.array.names[i], names(my.exons))) == 1){
                                    my.exons.array.names[i] <- grep(target.array.names[i], names(my.exons))
                             } else{
                                    error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], names(my.exons))],sep=","), "\n", sep="")
                                    cat("\nERROR! Filenames are not unique!\n")
                                    cat(error.message)
                                    cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
                                    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                    return()
                             }
               })
           Try(my.exons <- my.exons[,my.exons.array.names])
           Try(names(my.exons) <-  tmp1.pd$FileName)
           if(gene.summary == "iter-plier"){
                    Try(NormalizedAffyData <- new("ExpressionSet", exprs=log2(as.matrix(my.exons)), phenoData=tmp1.pd, annotation=""))
                    if(!validObject(NormalizedAffyData)){
                           Try(tkmessageBox(title="Gene 1.0 ST  APT calculation",message="Check the APT log in the main R window\nNo valid ExpressionSet could be created!",icon="error"))
                				   Try(return())
                    }
           } else {
                    Try(NormalizedAffyData <- new("ExpressionSet", exprs=as.matrix(my.exons), phenoData=tmp1.pd, annotation=""))
                    if(!validObject(NormalizedAffyData)){
                           Try(tkmessageBox(title="Gene 1.0 ST APT calculation",message="Check the APT log in the main R window\nNo valid ExpressionSet could be created!",icon="error"))
                			     Try(return())
                    }

           }
	         Try(assign("NormalizedAffyData.Available",TRUE,affylmGUIenvironment))
	         Try(assign("NormalizedAffyData",NormalizedAffyData,affylmGUIenvironment))
           Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	         Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Gene 1.0 ST data available",font=.affylmGUIglobals$affylmGUIfontTree))
	         Try(if("Name" %in% colnames(Targets))
	         SlideNamesVec <- Targets$Name)
	         Try(assign("SlideNamesVec",SlideNamesVec,affylmGUIenvironment))
	         Try(assign("ArraysLoaded",TRUE,affylmGUIenvironment))
           Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
           Try(ReturnVal <- GetlimmaDataSetName())
	         if(ReturnVal==0) return(0)
	         return(1)
           Try(cat("\nGene level probe sets summary ended\n"))
  } else if(tclvalue(exonVal)!="yes" & whichArrayPlatform=="EXON"){
           ##########################################################
           #it is necessary to exchange "-" with "." in the FileNames of Targets 
           #since R will convert "-" into "." for the header of the data file
           #e.g. name in the header of the data file 211_MB-211.rma-gene-core-Signal
           # after reading in R:  211_MB.211.rma.gene.core.Signal
           #therefore the FileName  211_MB-211 should be converted in 211_MB.211
           Try(tkmessageBox(title="Probe sets intensities by Affymetrix Expression Console",message="Loading gene/exon data generated by Expression Console",icon="info"))
                             
           Try(tmp<- apply(Targets, 1,function(x){sub("-",".",x[2])}))
           Try(Targets[,2] <- tmp )
           ############################################################
  
           Try(rownames(Targets) <- Targets$FileName) 
           Try(var.tmp.pd<-data.frame(names(Targets)))
           Try(names(var.tmp.pd)<-"labelDescription" )
           Try(rownames(var.tmp.pd)<-names(Targets))
           Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
           Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
           #Try(target.array.names <- tmp1.pd$FileName)
           Try(my.exons <- OpenExonFile())#loading gene level data
           Try(my.exons.array.names <- NULL)
           Try(    for( i in 1:length(target.array.names)){
                             if(length(grep(target.array.names[i], names(my.exons))) == 1){
                                    my.exons.array.names[i] <- grep(target.array.names[i], names(my.exons))
                             } else{
                                    error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], names(my.exons))],sep=","), "\n", sep="")
                                    cat("\nERROR! Filenames are not unique!\n")
                                    cat(error.message)
                                    cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
                                    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                    return()
                             }
               })
           Try(my.exons <- my.exons[,my.exons.array.names])
           Try(names(my.exons) <-  tmp1.pd$FileName)
           Try(NormalizedAffyData <- new("ExpressionSet", exprs=as.matrix(my.exons), phenoData=tmp1.pd, annotation=""))
	         Try(assign("NormalizedAffyData.Available",TRUE,affylmGUIenvironment))
	         Try(assign("NormalizedAffyData",NormalizedAffyData,affylmGUIenvironment))
           Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	         Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Gene level exon data available",font=.affylmGUIglobals$affylmGUIfontTree))

	         Try(if("Name" %in% colnames(Targets))
	         SlideNamesVec <- Targets$Name)
	         Try(assign("SlideNamesVec",SlideNamesVec,affylmGUIenvironment))
	         Try(assign("ArraysLoaded",TRUE,affylmGUIenvironment))

           Try(my.exons <- OpenExonProbeFile())#loading exon level data
           Try(my.exons.array.names <- NULL)
           Try(    for( i in 1:length(target.array.names)){
                             if(length(grep(target.array.names[i], names(my.exons))) == 1){
                                    my.exons.array.names[i] <- grep(target.array.names[i], names(my.exons))
                             } else{
                                    error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], names(my.exons))],sep=","), "\n", sep="")
                                    cat("\nERROR! Filenames are not unique!\n")
                                    cat(error.message)
                                    cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
                                    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                    return()
                             }
               })
           Try(my.exons <- my.exons[,my.exons.array.names])
           Try(names(my.exons) <-  tmp1.pd$FileName)
           Try(ExonAffyData <- new("ExpressionSet", exprs=as.matrix(my.exons), phenoData=tmp1.pd, annotation=""))
	         Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	         Try(assign("exonAffyData.Available",TRUE,affylmGUIenvironment))
	         Try(assign("exonAffyData",ExonAffyData,affylmGUIenvironment))

	         Try(tkdelete(.affylmGUIglobals$mainTree,"ExonArrays.Status"))
	         Try(tkinsert(.affylmGUIglobals$mainTree,"end","ExonArrays","ExonArrays.Status" ,text="Exon level data available",font=.affylmGUIglobals$affylmGUIfontTree))
           Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	         Try(ReturnVal <- GetlimmaDataSetName())
	         if(ReturnVal==0) return(0)
	         return(1)
     }

}
#loading the tab delimited file
OpenExonFile <- function(){
          Try(tkmessageBox(title="Exon analysis",message="Open the file, containing GENE level summary data, exported from Expression console"))  
          my.exons <- OpenAFile()
}

#loading the tab delimited file
OpenExonProbeFile <- function(){
          Try(tkmessageBox(title="Exon analysis",message="Open the file, containing the EXON level summary data, exported from Expression console"))  
          my.exons <- OpenAFile()
}


OpenAFile <- function(FileName)
      {
         Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
               if(!nchar(tempFileName))
               {
                  tkfocus(.affylmGUIglobals$ttMain)
                  return()
               }
         mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, row.names=1)
         return(mySel)
      }
################################################################################
"createGeoTarget" <- function(){
        #loading the tab delimited file
          Try(tkmessageBox(title="Create a Target File",message="Open the GEO Series Matrix file."))  
          Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
               if(!nchar(tempFileName))
               {
                  tkfocus(.affylmGUIglobals$ttMain)
                  return()
               }
           ##start grabbing GEO platform info
           Try(con <- file(tempFileName, "r", blocking = FALSE))
           Try(geoInfo <- readLines(con, n=500))
           Try(close(con))
           #creating Name 
           Try(geoName <- geoInfo[grep("^!Sample_title",geoInfo)])
           Try(geoName <- strsplit(geoName, "\\\""))
           Try(geoName <- unlist(geoName))
           Try(geoName <- geoName[seq(from = 2, to = length(geoName), by=2)])
           Try(geoName <- sapply(geoName, function(x)gsub(" ", ".", x)))
           Try(geoName <- as.vector(unlist(geoName)))
           #creating FileName
           Try(geoFileNames <- geoInfo[grep("ID_REF",geoInfo)])
           Try(geoFileNames <- strsplit(geoFileNames, "\\\""))
           Try(geoFileNames <- unlist(geoFileNames))
           Try(geoFileNames <- geoFileNames[seq(from = 4, to = length(geoFileNames), by=2)])
           #creating target
           Try(geoTarget <- geoInfo[grep("^!Sample_source_name_ch1",geoInfo)])
           Try(geoTarget <- strsplit(geoTarget, "\\\""))
           Try(geoTarget <- unlist(geoTarget))
           Try(geoTarget <- geoTarget[seq(from = 2, to = length(geoTarget), by=2)])
           Try(geoTarget <- sapply(geoTarget, function(x)gsub(" ", ".", x)))
           Try(geoTarget <- as.vector(unlist(geoTarget)))
           Try(mytarget <- data.frame(geoName, geoFileNames, geoTarget))
           Try(names(mytarget) <- c("Name", "FileName", "Target")) 
           #creating the target file name 
           Try(geoSeriesName <- geoInfo[grep("^!Series_geo_accession",geoInfo)])
           Try(geoSeriesName <- strsplit(geoSeriesName, "\\\""))
           Try(geoSeriesName <- unlist(geoSeriesName))
           Try(geoSeriesName <- geoSeriesName[2])
           Try(geoSeriesName <- paste("target.", geoSeriesName, ".txt", sep=""))
           Try(write.table(mytarget, file= geoSeriesName, sep="\t", row.names=F))
           Try(tkmessageBox(title="Create a Target File",message=paste("The target file is saved in ", getwd(), "\nwith the name ", geoSeriesName, sep="")))
}
#combining GEO matrix series files
"combineGeoMSF"  <- function(){
                #Try(tkmessageBox(title="Combining GEO Series Matrix file",message="How many matrix series files do you want to combine?"))        
                ###########Defining the numbero of  GEO Series Matrix file to be combined
                Try(ttGetGeoN<-tktoplevel(.affylmGUIglobals$ttMain))
                Try(tkwm.deiconify(ttGetGeoN))
                Try(tkgrab.set(ttGetGeoN))
                Try(tkfocus(ttGetGeoN))
                Try(tkwm.title(ttGetGeoN,"N. of GEO Matrix Series Files"))
                Try(tkgrid(tklabel(ttGetGeoN,text="    ")))
                Try(CovarText <- "")
                Try(Local.Covar <- tclVar(init=CovarText))
                Try(entry.Covar <-tkentry(ttGetGeoN,width="3",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.Covar,bg="white"))
                Try(tkgrid(tklabel(ttGetGeoN,text="Please enter the N. of GEO Matrix Series Files to be combined",font=.affylmGUIglobals$affylmGUIfont2)))
                Try(tkgrid(entry.Covar))
                Try( 
   	                onOK <- function() {
			                Try(CovarText <<- tclvalue(Local.Covar))
			                Try(tkgrab.release(ttGetGeoN))
			                Try(tkdestroy(ttGetGeoN))
		 	                Try(tkfocus(.affylmGUIglobals$ttMain))
		               }
	              )
                                                
                Try(OK.but <-tkbutton(ttGetGeoN,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
                Try(tkgrid(tklabel(ttGetGeoN,text="    ")))
                Try(tkgrid(OK.but))
                Try(tkgrid.configure(OK.but))
                Try(tkgrid(tklabel(ttGetGeoN,text="       ")))
                Try(tkfocus(entry.Covar))
                Try(tkbind(entry.Covar, "<Return>",onOK))
                Try(tkbind(ttGetGeoN, "<Destroy>", function(){Try(tkgrab.release(ttGetGeoN));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
                Try(tkwait.window(ttGetGeoN))
                Try(tkfocus(.affylmGUIglobals$ttMain))
                Try(mycovar <- as.numeric(CovarText))
                if(CovarText=="" || nchar(CovarText)==0){
                       Try(tkmessageBox(title="Combining GEO Series Matrix file",message="No GEO Matrix Series Files were selected.\nAborting the analysis!"))
                       Try(return())
                }   else {
                            Try(OpenGeoFiles())
                            Try(NormalizedAffyData1 <- get("NormalizedAffyData", env=affylmGUIenvironment))
                            Try(targets1 <- get("Targets", env=affylmGUIenvironment))
                            for( i in 2:mycovar){
                                     Try(OpenGeoFiles())
                                     Try(NormalizedAffyData <- get("NormalizedAffyData", env=affylmGUIenvironment))
                                     Try(targets <- get("Targets", env=affylmGUIenvironment))
                                     Try(NormalizedAffyData1 <- combine(NormalizedAffyData1, NormalizedAffyData))
                                     Try(targets1 <- rbind(targets1, targets)) 
                            }
                            Try(assign("NormalizedAffyData",NormalizedAffyData1,affylmGUIenvironment))
                            Try(assign("Targets",targets1,affylmGUIenvironment))
                }




}
################################################################################
"OpenBeadStudioFiles" <- function(){
          	Require("affy")
	        	Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	        	Try(tkwm.deiconify(ttExonandTargets))
	        	Try(tkgrab.set(ttExonandTargets))
	        	Try(tkfocus(ttExonandTargets))
	        	Try(tkwm.title(ttExonandTargets,"Targets file"))
	        	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	        	OpenTargetsFileAndSetCursor <- function()
	        	{
			        	Try(tkconfigure(ttExonandTargets,cursor="watch"))
			        	Try(tkfocus(ttExonandTargets))
			        	Try(OpenTargetsFile())
			        	Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			        	Try(tkfocus(ttExonandTargets))
	        	}
        		Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

        		Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	        	Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	        	Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	        	Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	        	Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	        	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	        	Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	        	Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	        	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
        		Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
        		Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	        	Try(Abort <- 1)
	        	onOK <- function()
	        	{
        				Try(Targets <- get("Targets",envir=affylmGUIenvironment))
        				Try(if(length(Targets)==0)
			        	{
				        	Try(tkmessageBox(title="RNA Targets File",message=paste("Either you did not specify a valid RNA Targets File",
					        	"or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				        	onCancel()
				        	return()
			        	})
			        	Try(tkgrab.release(ttExonandTargets));
			        	Try(tkdestroy(ttExonandTargets));
			        	Try(tkfocus(.affylmGUIglobals$ttMain))
			        	Try(Abort <<- 0)
	        	}
	        	onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	        	Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	        	Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	        	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	        	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	        	Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	        	Try(tkfocus(ttExonandTargets))
	        	Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	        	Try(tkwait.window(ttExonandTargets))

	        	if(Abort==1)
				        	return(0)
        		Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
	        	Try(tkfocus(.affylmGUIglobals$ttMain))
          ####opening bead studio files and selecting Bead studio version
          Try(mbVal <- tkmessageBox(title="Start New Analysis",
				    											message="Please select the expression data file generated by BeadStudio software.",
						    									icon="question",type="yesno",default="yes"
								    						 )#end of tkmessageBox
		    )#end of Try(mbVal..
		    if(tclvalue(mbVal)=="yes"){
            Try(dataFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.csv}} {{All files} *}")))
               if(!nchar(dataFileName))
               {
                  tkfocus(.affylmGUIglobals$ttMain)
                  return()
               }
        }
		    if(tclvalue(mbVal)=="no"){
			    Try(tkfocus(.affylmGUIglobals$ttMain))
			    return()
		    }#end of if(tclvalue(mbVal)=="no")
        Try(ttGetVersion <- tktoplevel(.affylmGUIglobals$ttMain))
	      Try(tkwm.deiconify(ttGetVersion))
	      Try(tkgrab.set(ttGetVersion))
	      Try(tkfocus(ttGetVersion))
	      Try(tkwm.title(ttGetVersion,"Selecting BeadStudio Version"))
	      #
	      Try(tkgrid(tklabel(ttGetVersion,text="    ")))
	      Try(VersionTcl <- tclVar("One"))
	      Try(rbONE <- tkradiobutton(ttGetVersion,text="BeadStudio v.1 outuput",variable=VersionTcl,value="One",font=.affylmGUIglobals$affylmGUIfont2))
	      Try(rbTWO <- tkradiobutton(ttGetVersion,text="BeadStudio v.2 outuput",variable=VersionTcl,value="Two",font=.affylmGUIglobals$affylmGUIfont2))
        Try(rbTHREE <- tkradiobutton(ttGetVersion,text="BeadStudio v.3 outuput",variable=VersionTcl,value="Three",font=.affylmGUIglobals$affylmGUIfont2))
        Try(tkgrid(tklabel(ttGetVersion,text="    "),rbONE))
	      Try(tkgrid(tklabel(ttGetVersion,text="    "),rbTWO))
	      Try(tkgrid(tklabel(ttGetVersion,text="    "),rbTHREE))
      	Try(tkgrid.configure(rbONE,rbTWO,rbTHREE, columnspan=2,sticky="w"))
       	Try(tkgrid(tklabel(ttGetVersion,text="    "),tklabel(ttGetVersion,text="    ")))
	      #
	      Try(ReturnVal <- "")
	      Try(
		         onCancel <- function() {
			          Try(ReturnVal <<- "");
			          Try(tkgrab.release(ttGetVersion));
			          Try(tkdestroy(ttGetVersion));
			          Try(tkfocus(.affylmGUIglobals$ttMain))
		        }
	      )
	      Try(
		       onOK <- function() {
			         Try(ReturnVal <<- tclvalue(VersionTcl));
			         Try(tkgrab.release(ttGetVersion));
			         Try(tkdestroy(ttGetVersion));
			         Try(tkfocus(.affylmGUIglobals$ttMain))
		      }
	     )
       #
	     Try(OK.but     <- tkbutton(ttGetVersion,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	     Try(Cancel.but <- tkbutton(ttGetVersion,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	     #
	     Try(tkgrid(tklabel(ttGetVersion,text="    "),OK.but,Cancel.but,tklabel(ttGetVersion,text="    ")))
	     Try(tkgrid.configure(OK.but,sticky="e"))
	     Try(tkgrid.configure(Cancel.but,sticky="w"))
	     Try(tkgrid(tklabel(ttGetVersion,text="    ")))
	     #
	     Try(tkbind(ttGetVersion,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetVersion));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	     Try(tkbind(OK.but, "<Return>",onOK))
	     Try(tkbind(Cancel.but, "<Return>",onCancel))
	     #
	     Try(tkwait.window(ttGetVersion))
       Try(if(ReturnVal=="") return())

       #defining the annotation under use if v3 beadstudio is used
       Try(ttGetAnn <- tktoplevel(.affylmGUIglobals$ttMain))
	      Try(tkwm.deiconify(ttGetAnn))
	      Try(tkgrab.set(ttGetAnn))
	      Try(tkfocus(ttGetAnn))
	      Try(tkwm.title(ttGetAnn,"Selecting Bioconductor annotation package"))
	      #
	      Try(tkgrid(tklabel(ttGetAnn,text="    ")))
	      Try(AnnTcl <- tclVar("illuminaHumanv1BeadID.db"))
	      Try(rbA <- tkradiobutton(ttGetAnn,text="Illumina HumanWGv1",variable=AnnTcl,value="illuminaHumanv1BeadID",font=.affylmGUIglobals$affylmGUIfont2))
	      Try(rbB <- tkradiobutton(ttGetAnn,text="Illumina HumanWGv2",variable=AnnTcl,value="illuminaHumanv2BeadID",font=.affylmGUIglobals$affylmGUIfont2))
	      Try(rbC <- tkradiobutton(ttGetAnn,text="Illumina HumanWGv3",variable=AnnTcl,value="illuminaHumanv3BeadID",font=.affylmGUIglobals$affylmGUIfont2))
	      Try(rbD <- tkradiobutton(ttGetAnn,text="Illumina MouseWGv1",variable=AnnTcl,value="illuminaMousev1BeadID",font=.affylmGUIglobals$affylmGUIfont2))
	      Try(rbE <- tkradiobutton(ttGetAnn,text="Illumina MouseWGv1.1",variable=AnnTcl,value="illuminaMousev1p1BeadID",font=.affylmGUIglobals$affylmGUIfont2))
	      Try(rbF <- tkradiobutton(ttGetAnn,text="Illumina MouseWGv2",variable=AnnTcl,value="illuminaMousev2BeadID",font=.affylmGUIglobals$affylmGUIfont2))
        Try(rbG <- tkradiobutton(ttGetAnn,text="Illumina RatWGv1",variable=AnnTcl,value="illuminaRatv1BeadID",font=.affylmGUIglobals$affylmGUIfont2))
        Try(rbH <- tkradiobutton(ttGetAnn,text="None",variable=AnnTcl,value="",font=.affylmGUIglobals$affylmGUIfont2))
        
        Try(tkgrid(tklabel(ttGetAnn,text="    "),rbA))
        Try(tkgrid(tklabel(ttGetAnn,text="    "),rbB))
        Try(tkgrid(tklabel(ttGetAnn,text="    "),rbC))
        Try(tkgrid(tklabel(ttGetAnn,text="    "),rbD))
        Try(tkgrid(tklabel(ttGetAnn,text="    "),rbE))
        Try(tkgrid(tklabel(ttGetAnn,text="    "),rbF))
        Try(tkgrid(tklabel(ttGetAnn,text="    "),rbG))
        Try(tkgrid(tklabel(ttGetAnn,text="    "),rbH))
        
      	Try(tkgrid.configure(rbA,rbB,rbC, rbD, rbE, rbF, rbG, rbH, columnspan=2,sticky="w"))
       	Try(tkgrid(tklabel(ttGetAnn,text="    "),tklabel(ttGetAnn,text="    ")))
	      #
	      Try(ReturnAnn <- "")
	      Try(
		         onCancel <- function() {
			          Try(ReturnAnn <<- "");
			          Try(tkgrab.release(ttGetAnn));
			          Try(tkdestroy(ttGetAnn));
			          Try(tkfocus(.affylmGUIglobals$ttMain))
		        }
	      )
	      Try(
		       onOK <- function() {
			         Try(ReturnAnn <<- tclvalue(AnnTcl));
			         Try(tkgrab.release(ttGetAnn));
			         Try(tkdestroy(ttGetAnn));
			         Try(tkfocus(.affylmGUIglobals$ttMain))
		      }
	     )
       #
	     Try(OK.but     <- tkbutton(ttGetAnn,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	     Try(Cancel.but <- tkbutton(ttGetAnn,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	     #
	     Try(tkgrid(tklabel(ttGetAnn,text="    "),OK.but,Cancel.but,tklabel(ttGetAnn,text="    ")))
	     Try(tkgrid.configure(OK.but,sticky="e"))
	     Try(tkgrid.configure(Cancel.but,sticky="w"))
	     Try(tkgrid(tklabel(ttGetAnn,text="    ")))
	     #
	     Try(tkbind(ttGetAnn,"<Destroy>",function() {ReturnAnn <- "";Try(tkgrab.release(ttGetAnn));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	     Try(tkbind(OK.but, "<Return>",onOK))
	     Try(tkbind(Cancel.but, "<Return>",onCancel))
	     #
	     Try(tkwait.window(ttGetAnn))
       ############################################################
       
       Try(illuData <- .readBead(filenames=dataFileName, version=ReturnVal, annotation = ReturnAnn))
       Try(assign("illuData", illuData, env=affylmGUIenvironment))
       Try(assign("illuData.Available", TRUE, env=affylmGUIenvironment))
       
       Try(Targets <- get("Targets",affylmGUIenvironment))
       Try(rownames(Targets) <- Targets$FileName) 
       Try(var.tmp.pd<-data.frame(names(Targets)))
       Try(names(var.tmp.pd)<-"labelDescription" )
       Try(rownames(var.tmp.pd)<-names(Targets))
       Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
       Try(target.array.names <- sub(":AVG_Signal", "", tmp1.pd$FileName))
       Try(my.exons <- illuData$signal)#loading gene expression data is a matrix
       Try(my.exons.array.names <- NULL)
       Try(    for( i in 1:length(target.array.names)){
                             if(length(grep(target.array.names[i], dimnames(my.exons)[[2]])) == 1){
                                    my.exons.array.names[i] <- grep(target.array.names[i], dimnames(my.exons)[[2]])
                             } else{
                                    error.message <- paste("\nERROR! Filenames are not unique!\n", target.array.names[i], " is a substring of ", paste(names(my.exons)[grep(target.array.names[i], dimnames(my.exons)[[2]])],sep=","), "\n", sep="")
                                    cat("\nERROR! Filenames are not unique!\n")
                                    cat(error.message)
                                    cat("\nYou need to modify filenames since the function is unable to correctly associate arrays to target Filenames\n")
                                    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                    return()
                             }
       })
       Try(my.exons <- my.exons[,my.exons.array.names])
       Try(dimnames(my.exons)[[2]] <-  tmp1.pd$FileName)
       Try(startFun <- tclvalue(tkmessageBox(title="Log transformation",message="Do you wish to log2 transform your data?",type="yesno",icon="question")))
       Try(if (startFun=="yes"){my.exons <- log2(my.exons)})
       Try(NormalizedAffyData <- new("ExpressionSet", exprs=my.exons, phenoData=tmp1.pd, annotation=illuData$annotation))
       Try(assign("NormalizedAffyData", NormalizedAffyData, env=affylmGUIenvironment))
       Try(assign("NormalizedAffyData.Available", TRUE, env=affylmGUIenvironment))
     	 Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	     Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Output from BeadStudio",font=.affylmGUIglobals$affylmGUIfontTree))
       	Try(if("Name" %in% colnames(Targets))
	              SlideNamesVec <- Targets$Name)
	      Try(assign("SlideNamesVec",SlideNamesVec,affylmGUIenvironment))
	      Try(assign("ArraysLoaded",TRUE,affylmGUIenvironment))
        Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
 	      Try(ReturnVal <- GetlimmaDataSetName())
	      if(ReturnVal==0) return(0)
	      return(1)
}

################################################################################
#modified by BeadExplorer library
".readBead" <- function (filenames=NULL, annotation="", verbose=TRUE, version="Two"){
      if (length (filenames)==0) stop ("No input file specified")
      if (version=="One"){ 
	        if (verbose) cat (paste ("Read ", filenames[1], "\n", sep=""))
          param<-scan (filenames[1], nlines=5, what=character(0), sep="\n", strip.white=TRUE, quiet=TRUE)
          param<-param2<-gsub ("(Illumina Inc. BeadStudio version |Normalization = |Array Content = |Error Model = | DateTime = |.xml)", "", param)
          param<-gsub(",","",param)
          names(param)<-c("BeadStudioVersion", "Normalization", "ArrayContent", "ErrorModel", "DateTime")
          data<-read.delim (filenames[1], skip=7, sep=",", row.names=1)
      } else if (version=="Two"){
	        if (verbose) cat (paste ("Read ", filenames[1], "\n", sep=""))
          param<-scan (filenames[1], nlines=5, what=character(0), sep="\n", strip.white=TRUE, quiet=TRUE)
          param<-param2<-gsub ("(Illumina Inc. BeadStudio version |Normalization = |Array Content = |Error Model = | DateTime = |.xml)", "", param)
          param<-gsub(",","",param)
          names(param)<-c("BeadStudioVersion", "Normalization", "ArrayContent", "ErrorModel", "DateTime")
          data<-read.delim (filenames[1], skip=7, row.names=1)
      } else if (version=="Three"){
            data<-read.delim (filenames[1], skip=8, row.names=1)
      } else {
           stop ("Cannot identify version number")
      }
      if (version == "One" | version == "Two"){
          names<-colnames (data)
          signal<-grep ("AVG_Signal", names)
          confid<-grep ("Detection", names)
          sd<-grep ("BEAD_STDEV",names)
          colnames (data)<-gsub ("AVG_Signal.", "", names)
          signal<-data[,signal]
          confscores<-data[,confid]
          sdscores<-data[,sd]
          #defining which bioconductor annotation lib should be used
          arrayContent <- as.vector(unlist(param[names(param)=="ArrayContent"]))
          organism <- NULL
          if(length(grep("Human", arrayContent))==1){
                 organism <- "Human"
          } else if(length(grep("Mouse", arrayContent))==1){
                 organism <- "Mouse"
          } else if(length(grep("Rat", arrayContent))==1){
                organism <- "Rat"
          }
          chipVersion <- NULL
          if(length(grep("V1", arrayContent))==1){
              chipVersion <- "v1"
          } else if(length(grep("V2", arrayContent))==1){
              chipVersion <- "v2"
          }  else if(length(grep("V3", arrayContent))==1){
              chipVersion <- "v3"
          }
      
          param[names(param)=="ArrayContent"]
#         illuData <-  list("signal"=as.matrix(signal), "detection"=as.matrix(confscores), "se.exprs"=as.matrix(sdscores), "annotation"=annotation)
          illuData <-  list("signal"=as.matrix(signal), "annotation"=annotation)       
      
      } else{
          names<-colnames (data)
          signal<-grep ("AVG_Signal", names)
          #confid<-grep ("Detection", names)
          #sd<-grep ("Avg_NBEADS",names)  #number of beads is used instead of sd
          colnames (data)<-gsub(".AVG_Signal", "", names)
          signal<-data[,signal]
          #confscores<-data[,confid]
          #sdscores<-data[,sd]
      
#         illuData <-  list("signal"=as.matrix(signal), "detection"=as.matrix(confscores), "se.exprs"=as.matrix(sdscores), "annotation"=annotation)
          illuData <-  list("signal"=as.matrix(signal), "annotation"=annotation)       
      }
    	return(illuData)
}
################################################################################
ExportfeatureNames <- function(){
    Try(limmaDataSetNameText <- get("limmaDataSetNameText", envir = affylmGUIenvironment))
    Try(ArraysLoaded <- get("ArraysLoaded", envir = affylmGUIenvironment))
    Try(if (ArraysLoaded == FALSE) {
        Try(tkmessageBox(title = "Export gene-level Probe sets ids", 
            message = "Error: No arrays have been loaded.", icon = "error", 
            default = "ok"))
        return()
    })
    Try(NormalizedAffyData.Available <- get("NormalizedAffyData.Available", 
        envir = affylmGUIenvironment))
    Try(if (NormalizedAffyData.Available == FALSE) {
        NormalizeNow()
    })
    Try(NormalizedAffyData.Available <- get("NormalizedAffyData.Available", 
        envir = affylmGUIenvironment))
    Try(if (NormalizedAffyData.Available == FALSE) {
        tkmessageBox(title = "Export gene-level probe sets ids", 
            message = "An error or cancellation occured while trying to normalize the data.")
        return()
    })
    Try(NormalizedAffyData <- get("NormalizedAffyData", envir = affylmGUIenvironment))
    Try(NormalizedAffyData.exprs <- exprs(NormalizedAffyData))
    Try(FileName <- tclvalue(tkgetSaveFile(initialfile = paste(limmaDataSetNameText, 
        "_gene-level_probesetsIDs.txt", sep = ""), filetypes = "{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
    Try(if (!nchar(FileName)) 
        return())
    Try(len <- nchar(FileName))
    if (len <= 4) {
        Try(FileName <- paste(FileName, ".txt", sep = ""))
    }
    else if ((substring(FileName, len - 3, len) != ".txt") && 
        (substring(FileName, len - 3, len) != ".xls")) {
        Try(FileName <- paste(FileName, ".txt", sep = ""))
    }
    #Try(write.table(NormalizedAffyData.exprs, file = FileName,  sep = "\t", quote = FALSE, col.names = NA))
    Try(zz <- file(FileName, "w"))
    Try(writeLines(featureNames(NormalizedAffyData), con = zz, sep = "\n"))
    Try(close(zz))
}


################################################################################

