#set of functions, directly/indirectly involved, in oneChannelGUI normalizeMenu
#oneChannelGUI NormalizeNow is a modification of the original function of affylmGUI and is used to handle ExpressionSets
#oneChannelGUI showDataset describes the content of the loaded data set present in the filemenu.R      
#oneChannelGUI myExpresso is a graphical interphace to the affy expresso function. It works but is very slow
#oneChannelGUI largedatasetNorm this function alows the normalization by variosu methods if unnormalized tab delimited files are loaded
#oneChannelGUI rankingConversion converts intensity signal in normalized ranks

################################################################################

#modified from the affylmGUI version to load ExpressionSet in NormalizeAffyData
NormalizeNow <- function(){
  require(preprocessCore) || stop("\npreprocessCore lib is missing!\n")
	Try(ArraysLoaded  <- get("ArraysLoaded", envir=affylmGUIenvironment))
	Try(
		if (ArraysLoaded==FALSE){
			Try(tkmessageBox(title="Normalization",message="Error: No arrays have been loaded.",icon="error",default="ok"))
		return()
		}
	)
	Require("affy")
	Try(RawAffyData <- get("RawAffyData",envir=affylmGUIenvironment))
	#
	Try(NormalizationMethod <- GetNormalizationMethod())
	Try(if (NormalizationMethod=="") return())
	#
	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
	Try(tkfocus(.affylmGUIglobals$ttMain))
  
  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
  Try(rownames(Targets) <- Targets$FileName) 
  Try(var.tmp.pd<-data.frame(names(Targets)))
  Try(names(var.tmp.pd)<-"labelDescription" )
  Try(rownames(var.tmp.pd)<-names(Targets))
  Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))

	Try(
		if (NormalizationMethod=="RMA"){
			Try(NormalizedAffyDataExpressionSet <- rma(RawAffyData))
			#rma returns an ExpressionSet as shown below:
			#  new("ExpressionSet",
			#      phenoData = phenoData(object),
			#      annotation = .annotation(object),
			#      experimentData = experimentData(object),
			#      exprs = exprs)
			# NormalizedAffyData is an ExpressionSet as from R2.5.0
      Try(phenoData(NormalizedAffyDataExpressionSet) <- tmp1.pd)
			Try(assign("NormalizedAffyData", NormalizedAffyDataExpressionSet, affylmGUIenvironment))
			Try(assign("NormMethod","RMA",affylmGUIenvironment))
			Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	    Try(tkfocus(.affylmGUIglobals$ttMain))


		}else if (NormalizationMethod=="GCRMA"){
			Require("gcrma")
			Try(NormalizedAffyDataExpressionSet <- gcrma(RawAffyData, fast=FALSE))
			# gcrma returns an ExpressionSet, using the rma function as shown:
			# return(rma(object,subset=subset,background=FALSE,normalize=normalize,verbose=verbose))
			# NormalizedAffyData is an ExpressionSet as from R2.5.0
			#Just store the exprs values and set se.exprs values to  NULL
			Try(phenoData(NormalizedAffyDataExpressionSet) <- tmp1.pd)
			Try(assign("NormalizedAffyData", NormalizedAffyDataExpressionSet,affylmGUIenvironment))
			Try(assign("NormMethod","GCRMA",affylmGUIenvironment))
			Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
	    Try(tkfocus(.affylmGUIglobals$ttMain))

		}
    #else{
		#	Require("affyPLM")
			#creating an expressionSet
		#	Try(rownames(Targets) <- Targets$FileName) 
    #  Try(var.tmp.pd<-data.frame(names(Targets)))
    #  Try(names(var.tmp.pd)<-"labelDescription" )
    #  Try(rownames(var.tmp.pd)<-names(Targets))
    #  Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
    #  Try(NormalizedAffyDataPset <- fitPLM(RawAffyData))
			#affyPLM returns an object of class PLMset.
	#		Try(NormalizedAffyData.exprs    <- coefs(NormalizedAffyDataPset))
	#		Try(NormalizedAffyData <- new("ExpressionSet", exprs=as.matrix(NormalizedAffyData.exprs), phenoData=tmp1.pd, annotation=""))
	#		Try(assign("NormMethod","PLM",affylmGUIenvironment))
	#	}
	)
	Try(assign("NormalizedAffyData.Available",TRUE,affylmGUIenvironment))
	#Try(assign("NormalizedAffyData.exprs","",affylmGUIenvironment))
	#Try(assign("NormalizedAffyData.se.exprs","",affylmGUIenvironment))
	Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
	Try(
		if(NormalizationMethod=="RMA"){
			Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Available (RMA)",font=.affylmGUIglobals$affylmGUIfontTree))
		}else if(NormalizationMethod=="GCRMA"){
			Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Available (GCRMA)",font=.affylmGUIglobals$affylmGUIfontTree))
		}
    #else{
		#	Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Available (PLM)",font=.affylmGUIglobals$affylmGUIfontTree))
		#}
	)
}#end of NormalizeNow <- function(){

GetNormalizationMethod <- function(){
	Try(ttGetNormalizationMethod <- tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttGetNormalizationMethod))
	Try(tkgrab.set(ttGetNormalizationMethod))
	Try(tkfocus(ttGetNormalizationMethod))
	Try(tkwm.title(ttGetNormalizationMethod,"Normalization Method"))
	#
	Try(tkgrid(tklabel(ttGetNormalizationMethod,text="    ")))
	Try(NormalizationMethodTcl <- tclVar("RMA"))
	Try(rbRMA <- tkradiobutton(ttGetNormalizationMethod,text="RMA (Robust Multiarray Averaging)",variable=NormalizationMethodTcl,value="RMA",font=.affylmGUIglobals$affylmGUIfont2))
	Try(rbGCRMA<-tkradiobutton(ttGetNormalizationMethod,text="GCRMA (Background Adjustment Using Sequence Information)",variable=NormalizationMethodTcl,value="GCRMA",font=.affylmGUIglobals$affylmGUIfont2))
	#Try(rbPLM <- tkradiobutton(ttGetNormalizationMethod,text="Robust Probe-level Linear Model",variable=NormalizationMethodTcl,value="RPLM",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttGetNormalizationMethod,text="    "),rbRMA))
	Try(tkgrid(tklabel(ttGetNormalizationMethod,text="    "),rbGCRMA))
	#Try(tkgrid(tklabel(ttGetNormalizationMethod,text="    "),rbPLM))
	Try(tkgrid.configure(rbRMA,rbGCRMA,columnspan=2,sticky="w"))
	Try(tkgrid(tklabel(ttGetNormalizationMethod,text="    "),tklabel(ttGetNormalizationMethod,text="    ")))
	#
	Try(ReturnVal <- "")
	Try(
		onCancel <- function() {
			Try(ReturnVal <<- "");
			Try(tkgrab.release(ttGetNormalizationMethod));
			Try(tkdestroy(ttGetNormalizationMethod));
			Try(tkfocus(.affylmGUIglobals$ttMain))
		}
	)
	Try(
		onOK <- function() {
			Try(ReturnVal <<- tclvalue(NormalizationMethodTcl));
			Try(tkgrab.release(ttGetNormalizationMethod));
			Try(tkdestroy(ttGetNormalizationMethod));
			Try(tkfocus(.affylmGUIglobals$ttMain))
		}
	)
	#
	Try(OK.but     <- tkbutton(ttGetNormalizationMethod,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <- tkbutton(ttGetNormalizationMethod,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	#
	Try(tkgrid(tklabel(ttGetNormalizationMethod,text="    "),OK.but,Cancel.but,tklabel(ttGetNormalizationMethod,text="    ")))
	Try(tkgrid.configure(OK.but,sticky="e"))
	Try(tkgrid.configure(Cancel.but,sticky="w"))
	Try(tkgrid(tklabel(ttGetNormalizationMethod,text="    ")))
	#
	Try(tkbind(ttGetNormalizationMethod,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetNormalizationMethod));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkbind(OK.but, "<Return>",onOK))
	Try(tkbind(Cancel.but, "<Return>",onCancel))
	#
	Try(tkwait.window(ttGetNormalizationMethod))
	#
	return (ReturnVal)
}#end of GetNormalizationMethod <- function()

ExportNormalizedExpressionValues <- function(){
	Try(limmaDataSetNameText <- get("limmaDataSetNameText",envir=affylmGUIenvironment))
	Try(ArraysLoaded <- get("ArraysLoaded",envir=affylmGUIenvironment))
	Try(
		if (ArraysLoaded==FALSE){
			Try(tkmessageBox(title="Export Normalized Expression Values",message="Error: No arrays have been loaded.",icon="error",default="ok"))
			return()
		}
	)
	Try(NormalizedAffyData.Available <- get("NormalizedAffyData.Available",envir=affylmGUIenvironment))
	Try(
		if (NormalizedAffyData.Available==FALSE){
			NormalizeNow()
		}
	)
	Try(NormalizedAffyData.Available <- get("NormalizedAffyData.Available",envir=affylmGUIenvironment))
	Try(
		if (NormalizedAffyData.Available==FALSE){
			tkmessageBox(title="Export Normalized Expression Values",message="An error or cancellation occured while trying to normalize the data.")
			return()
		}
	)#end of Try
	Try(NormalizedAffyData <- get("NormalizedAffyData",envir=affylmGUIenvironment))
	Try(NormalizedAffyData.exprs <-  exprs(NormalizedAffyData))
	Try(
		FileName <- tclvalue(
			tkgetSaveFile(
				initialfile=paste(
					limmaDataSetNameText,
					"_exprs.xls",
					sep=""),
				filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}"
			)#end of tkgetSaveFile
		)#end of FileName <- tclvalue
	)#end of Try
	Try(if (!nchar(FileName)) return())
	Try(len <- nchar(FileName))
	if (len <= 4){
		Try(FileName <- paste(FileName,".xls",sep=""))
	}else if ((substring(FileName,len-3,len)!=".txt") &&(substring(FileName,len-3,len)!=".xls")){
		Try(FileName <- paste(FileName,".xls",sep=""))
	}
	Try(write.table(NormalizedAffyData.exprs,file=FileName,sep="\t",quote=FALSE,col.names=NA))
}#end of ExportNormalizedExpressionValues <- function()
################################################################################

"myExpresso" <- function(){
         require(tkWidgets) || stop("library tkWidgets could not be found !")
         #error if no data are loaded
         Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
         if(whichArrayPlatform ==""){
              Try(tkmessageBox(title="Normalization",message="No arrays have been loaded.	Please try New or Open from the File menu.",type="ok",icon="error"))
				    	Try(tkfocus(.affylmGUIglobals$ttMain))
              Try(return())
         }    
         #########################

         Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
         Try(  x <- get("RawAffyData",envir=affylmGUIenvironment))
         Try(xx<- expresso(x, widget=T))
         assign("NormalizedAffyData" , xx, affylmGUIenvironment)
         assign("NormalizedAffyData.Available" , TRUE, affylmGUIenvironment)
         Try(tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status"))
         Try(tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Available",font=.affylmGUIglobals$affylmGUIfontTree))
         Try(tkmessageBox(title="Expresso widget",message=paste("Normalized data are now available for further analysis")))  
         Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
            
}
################################################################################

"largedatasetNorm" <- function(){
           require(affy) || stop("library affy could not be found !")
           #error if no data are loaded
           Try(whichArrayPlatform <- get("whichArrayPlatform",envir=affylmGUIenvironment))
           if(whichArrayPlatform ==""){
              Try(tkmessageBox(title="Normalization",message="No arrays have been loaded.	Please try New or Open from the File menu.",type="ok",icon="error"))
				    	Try(tkfocus(.affylmGUIglobals$ttMain))
              Try(return())
           }    
           #########################

           if(affylmGUIenvironment$NormalizedAffyData.Available){
                     Try(NormalizedAffyData <- get("NormalizedAffyData", env=affylmGUIenvironment))
           } else Try(tkmessageBox(title="Large data set normalization",message="Normalized data are not available.", type="ok", icon="error"))
          	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
            ##makning the menu for selecting large data set normalization
            Try(ttTabNormMethod <- tktoplevel(.affylmGUIglobals$ttMain))
	          Try(tkwm.deiconify(ttTabNormMethod))
            Try(tkgrab.set(ttTabNormMethod))
            Try(tkfocus(ttTabNormMethod))
            Try(tkwm.title(ttTabNormMethod,"Normlization method for tab delimited files"))
	
 	      Try(tkgrid(tklabel(ttTabNormMethod,text="    ")))
	      Try(ttTabNormMethodTcl <- tclVar("loess"))
            Try(rb1 <- tkradiobutton(ttTabNormMethod,text="Cyclic LOESS",variable=ttTabNormMethodTcl,value="loess",font=.affylmGUIglobals$affylmGUIfont2))
            Try(rb2<-tkradiobutton(ttTabNormMethod,text="QUANTILE",variable=ttTabNormMethodTcl,value="quantile",font=.affylmGUIglobals$affylmGUIfont2))
            Try(rb3<-tkradiobutton(ttTabNormMethod,text="QSPLINE",variable=ttTabNormMethodTcl,value="qspline",font=.affylmGUIglobals$affylmGUIfont2))
	      Try(tkgrid(tklabel(ttTabNormMethod,text="    "),rb1))
	      Try(tkgrid(tklabel(ttTabNormMethod,text="    "),rb2))
	      Try(tkgrid(tklabel(ttTabNormMethod,text="    "),rb3))
	      Try(tkgrid.configure(rb1,rb2,rb3,columnspan=2,sticky="w"))
	      Try(tkgrid(tklabel(ttTabNormMethod,text="    "),tklabel(ttTabNormMethod,text="    ")))
	      Try(ReturnVal <- "")
	      Try(onCancel <- function() {Try(ReturnVal <<- "");Try(tkgrab.release(ttTabNormMethod));Try(tkdestroy(ttTabNormMethod));Try(tkfocus(.affylmGUIglobals$ttMain))})
	      Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttTabNormMethodTcl));Try(tkgrab.release(ttTabNormMethod));Try(tkdestroy(ttTabNormMethod));Try(tkfocus(.affylmGUIglobals$ttMain))})

	      Try(OK.but     <- tkbutton(ttTabNormMethod,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	      Try(Cancel.but <- tkbutton(ttTabNormMethod,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	      Try(tkgrid(tklabel(ttTabNormMethod,text="    "),OK.but,Cancel.but,tklabel(ttTabNormMethod,text="    ")))
	      Try(tkgrid.configure(OK.but,sticky="e"))
	      Try(tkgrid.configure(Cancel.but,sticky="w"))
	      Try(tkgrid(tklabel(ttTabNormMethod,text="    ")))

	      Try(tkbind(ttTabNormMethod,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttTabNormMethod));Try(tkfocus(.affylmGUIglobals$ttMain));}))
            Try(tkbind(OK.but, "<Return>",onOK))
            Try(tkbind(Cancel.but, "<Return>",onCancel))      

	      Try(tkwait.window(ttTabNormMethod))
	      if(ReturnVal==""){
	                                               Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
                                                 return()
                                      } else if(ReturnVal=="loess"){
                                                 Try(tmp <- normalize.loess(exprs(NormalizedAffyData)))
                                                 Try(dimnames(tmp)[[2]] <- sampleNames(NormalizedAffyData))
                                                 Try(dimnames(tmp)[[1]] <- featureNames(NormalizedAffyData))
                                                 Try(exprs(NormalizedAffyData) <- tmp)
                                                 Try(assign("NormalizedAffyData", NormalizedAffyData,  env=affylmGUIenvironment))
                                                 tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status")
                                                 tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Available Loess",font=.affylmGUIglobals$affylmGUIfontTree)
                                                 Try(tkmessageBox(title="Large data set normalization",message="Loess normalized data are now available in NormalizedAffyData.", type="ok")) 
                                      } else if(ReturnVal=="quantile"){
                                                 Try(tmp <- normalize.quantiles(exprs(NormalizedAffyData)))
                                                 Try(dimnames(tmp)[[2]] <- sampleNames(NormalizedAffyData))
                                                 Try(dimnames(tmp)[[1]] <- featureNames(NormalizedAffyData))
                                                 Try(exprs(NormalizedAffyData) <- tmp)
                                                 Try(assign("NormalizedAffyData", NormalizedAffyData,  env=affylmGUIenvironment))
                                                 tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status")
                                                 tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Available Quantile",font=.affylmGUIglobals$affylmGUIfontTree)
                                                 Try(tkmessageBox(title="Large data set normalization",message="Quantile normalized data are now available in NormalizedAffyData.", type="ok"))  
                                      } else if(ReturnVal=="qspline"){
                                                 Try(tmp <- normalize.qspline(exprs(NormalizedAffyData)))
                                                 Try(dimnames(tmp)[[2]] <- sampleNames(NormalizedAffyData))
                                                 Try(dimnames(tmp)[[1]] <- featureNames(NormalizedAffyData))
                                                 Try(exprs(NormalizedAffyData) <- tmp)                                                 
                                                 Try(assign("NormalizedAffyData", NormalizedAffyData,  env=affylmGUIenvironment))
                                                 tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status")
                                                 tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Available qspline",font=.affylmGUIglobals$affylmGUIfontTree)
                                                 Try(tkmessageBox(title="Large data set normalization",message="Qspline normalized data are now available in NormalizedAffyData.", type="ok")) 
                                      } else  {return()}
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
}
################################################################################
#exchanging intenisty signal with nomralized rank
"rankingConversion" <- function(){
  if(affylmGUIenvironment$NormalizedAffyData.Available){
                     Try(NormalizedAffyData <- get("NormalizedAffyData", env=affylmGUIenvironment))
  } else Try(tkmessageBox(title="Large data set normalization",message="Normalized data are not available.", type="ok", icon="error"))
  Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
           
  Try(tmp.rank <- esApply(NormalizedAffyData, 2, rank))
  Try(tmp.rank  <- apply(tmp.rank, 2, .myrk, df=tmp.rank))
  Try(exprs(NormalizedAffyData) <- tmp.rank)
  Try(assign("NormalizedAffyData", NormalizedAffyData,  env=affylmGUIenvironment))
  tkdelete(.affylmGUIglobals$mainTree,"NormalizedAffyData.Status")
  tkinsert(.affylmGUIglobals$mainTree,"end","NormalizedAffyData","NormalizedAffyData.Status" ,text="Available normalized ranking",font=.affylmGUIglobals$affylmGUIfontTree)
  Try(tkmessageBox(title="Large data set normalization",message="Data are now available as normalized ranks in NormalizedAffyData.", type="ok")) 
                                      
Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
  
}
#internal function
.myrk <- function(x, df) {x/dim(df)[1]}

################################################################################

